/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	Kolodony.h	(beta version 2003)				      */
/*	------------							      */
/*	two series of Kolodony prototypes				      */
/******************************************************************************/

# include "basic_h.h"

/*******************************************************************************
* REFERENCE
*******************************************************************************
*
* If you use this data in research, please cite:
*
* Rachel Kolodny, Patrice Koehl, Leonidas Guibas, Michael Levitt
* Small Libraries of Protein Fragments Accurately Model Native Protein 
* Structures
*******************************************************************************/

/*******************************************************************************
* 
*               Library of 10 fragments, each 5 residues long
* 
*******************************************************************************/

double Kolodny_10_5[10][5][3]={{{-13.974,42.846,47.708},\
                    {-13.986,44.134,44.117},\
                    {-16.344,41.344,43.003},\
                    {-19.232,43.113,44.738},\
                    {-19.040,46.335,42.683}},\

		{{-11.503,41.111,47.291},\
                    {-13.521,43.691,45.432},\
                    {-17.321,43.807,45.815},\
                    {-19.355,43.053,42.631},\
                    {-20.876,46.109,41.080}},\

		{{-12.558,44.831,46.711},\
                    {-15.329,42.341,46.039},\
                    {-16.503,41.319,42.549},\
                    {-19.898,42.964,43.007},\
                    {-18.288,46.317,43.943}},\

		{{-11.502,43.090,47.112},\
                    {-15.236,43.214,46.361},\
                    {-16.476,41.138,43.442},\
                    {-19.606,43.314,43.093},\
                    {-19.757,47.018,42.241}},\

		{{-14.333,42.954,47.832},\
                    {-13.009,43.211,44.245},\
                    {-16.146,41.535,42.831},\
                    {-18.667,43.662,44.657},\
                    {-20.422,46.410,42.684}},\

		{{-14.669,43.751,47.623},\
                    {-13.084,41.826,44.676},\
                    {-16.236,42.069,42.501},\
                    {-17.529,45.558,43.209},\
                    {-21.059,44.567,44.239}},\

		{{-14.751,43.521,47.472},\
                    {-13.889,43.945,43.794},\
                    {-16.364,41.232,42.750},\
                    {-19.114,42.809,44.843},\
                    {-18.458,46.266,43.390}},\

		{{-13.077,43.111,48.235},\
                    {-12.885,42.188,44.617},\
                    {-16.526,41.923,43.733},\
                    {-18.426,44.751,42.045},\
                    {-21.662,45.798,43.619}},\

		{{-11.460,42.273,48.325},\
                    {-13.320,42.304,44.994},\
                    {-16.965,43.356,44.879},\
                    {-19.344,43.352,41.920},\
                    {-21.487,46.487,42.130}},\

		{{-11.228,42.137,48.000},\
                    {-14.139,41.377,45.757},\
                    {-15.941,44.222,44.042},\
                    {-19.653,43.799,43.302},\
                    {-21.615,46.237,41.148}}};
		    
/*******************************************************************************
* 
*               Library of 20 fragments, each 5 residues long
* 
*******************************************************************************/


double Kolodny_20_5[20][5][3]={{{81.931,35.878,30.391},\
                  {79.746,32.872,31.285},\
                  {77.282,33.743,28.536},\
                  {80.064,34.047,25.977},\
                  {81.531,30.667,27.007}},\

	{{81.526,35.096,33.288},\
                  {80.936,35.195,29.517},\
                  {77.542,33.753,28.575},\
                  {78.929,32.697,25.202},\
                  {81.621,30.466,26.614}},\

	{{81.265,36.710,32.288},\
                  {80.724,33.226,30.801},\
                  {77.846,34.211,28.412},\
                  {79.640,33.176,25.239},\
                  {81.078,29.884,26.456}},\

	{{79.681,37.362,33.494},\
                  {80.750,34.355,31.512},\
                  {81.359,34.182,27.786},\
                  {78.756,32.324,25.814},\
                  {80.008,28.984,24.590}},\

	{{82.287,35.963,32.041},\
                  {78.718,34.523,32.111},\
                  {78.339,34.244,28.316},\
                  {79.039,31.035,26.413},\
                  {82.170,31.442,24.315}},\

	{{81.581,36.764,30.969},\
                  {79.257,34.008,32.224},\
                  {77.736,33.357,28.754},\
                  {80.924,33.067,26.723},\
                  {81.055,30.011,24.526}},\

	{{82.570,34.181,32.423},\
                  {79.870,35.449,30.018},\
                  {77.120,33.173,28.632},\
                  {78.853,32.772,25.278},\
                  {82.141,31.632,26.845}},\

	{{82.352,34.985,30.499},\
                  {78.778,34.596,31.787},\
                  {77.463,33.655,28.316},\
                  {80.252,31.108,27.827},\
                  {81.709,32.863,24.767}},\

	{{81.266,37.306,33.535},\
                  {79.714,34.357,31.700},\
                  {80.001,34.295,27.924},\
                  {78.350,31.691,25.692},\
                  {81.223,29.558,24.344}},\

	{{81.673,36.875,31.534},\
                  {78.630,34.815,32.262},\
                  {78.646,32.782,29.069},\
                  {81.424,31.340,26.940},\
                  {80.181,31.396,23.391}},\

	{{81.680,35.914,33.152},\
                  {79.359,36.256,30.132},\
                  {78.508,32.578,29.412},\
                  {79.777,32.878,25.825},\
                  {81.231,29.580,24.676}},\

	{{81.621,36.514,30.787},\
                  {79.516,33.550,31.899},\
                  {77.505,33.619,28.684},\
                  {80.563,33.581,26.411},\
                  {81.348,29.943,25.414}},\

	{{82.422,35.726,31.091},\
                  {78.883,34.598,31.818},\
                  {77.119,33.229,28.785},\
                  {80.055,33.312,26.347},\
                  {82.076,30.342,25.155}},\

	{{81.780,36.889,32.589},\
                  {78.870,34.504,32.109},\
                  {79.133,34.270,28.321},\
                  {79.125,30.944,26.510},\
                  {81.646,30.599,23.668}},\

	{{82.270,35.340,30.381},\
                  {79.391,33.191,31.568},\
                  {77.140,33.798,28.539},\
                  {79.706,33.804,25.770},\
                  {82.046,31.074,26.938}},\

	{{80.471,37.174,34.193},\
                  {80.176,36.283,30.490},\
                  {79.580,32.729,29.324},\
                  {80.450,32.023,25.691},\
                  {79.878,28.998,23.499}},\

	{{81.210,37.489,33.517},\
                  {79.032,35.734,30.965},\
                  {79.989,32.379,29.449},\
                  {80.292,32.389,25.658},\
                  {80.031,29.216,23.606}},\

	{{81.319,37.471,33.760},\
                  {79.144,35.046,31.679},\
                  {80.469,33.723,28.357},\
                  {78.651,31.544,25.788},\
                  {80.971,29.423,23.611}},\

	{{81.677,36.392,30.890},\
                  {80.006,32.956,31.311},\
                  {77.441,33.754,28.527},\
                  {80.217,33.879,25.876},\
                  {81.213,30.226,26.593}},\

	{{81.077,36.173,33.659},\
                  {81.112,34.809,30.133},\
                  {77.785,34.468,28.342},\
                  {78.928,32.217,25.499},\
                  {81.653,29.540,25.563}}};


char *kolo_ref={"Kolodony et al. (2002)"};



