/******************************************************************************/
/*	PDB Dreamer version 1.02					      */
/*      (A.G. de Brevern - EBGM - U726 INSERM)				      */
/******************************************************************************/
/*	lib_protoC.h	(beta version 2005)				      */
/*	------------							      */
/*	declaration of the different functions				      */
/*	last modification : 29-05-2005					      */
/******************************************************************************/

# include "basic_h.h"
# include "lib_structure.h"

/****************/
/* structure.c  */
/****************/

/* 0001 */ extern void Nullify(pdbfile *);						

/***********/
/* options */
/***********/

/* 0001b */ extern void Decode_Options(int , char **,char **); 
/* 0001c */ extern void ban_deb();				   
/* 0001d */ extern void help(char **);			   
/* 0001- */ void banana();

/**********/
/* follow */
/**********/

/* 0001e */ extern void file_options(char *);
/* 0001f */ extern void end_options();
/* 0001g */ extern void sum(pdbfile *, int);

/**********************************/
/*	pdb lecture		  */
/**********************************/

/* 0002 */ extern void Read_Pdb_File(FILE *, pdbfile *);

/**********************************/
/*	   check		  */
/**********************************/

/* 0001h */ extern void check_seqres(pdbfile *);
/* 0014  */ void Verif_Mol(pdbfile *);
/* 0015  */ short int Test_Prot(pdbfile *);
/* 0016  */ /*void Is_It_AA(pdbfile *,const long ,const long );*/
/* 0017  */ /* short int Test_NuclAc(pdbfile *); */
/* 0018  */ /* void Recapitul_01(pdbfile *); */
/* 0019  */ void Categoriz_Atom(pdbfile *);
/* 0020 */  /* short int Zeroresarch(pdbfile *, const long);*/
/* 0021 */  void Write_Pdb_clean(pdbfile *m);

/**********************************/
/*	   nexus		  */
/**********************************/

void Nettoyage_Prot(pdbfile *);

/**********************************/
/*	   work on blocks         */
/**********************************/

void CheckName(pdbfile *);
double DistAngMin(const double ,const double );
short int WhichBP(double v[NB_ANGLES],double BP[NB_BP][NB_ANGLES]);
float valWhichBP(double v[NB_ANGLES],double BP[NB_BP][NB_ANGLES]);
void AssignBP(pdbfile *);
double GradToDeg(double );
double Calcul_Diehedral(double *,double *,double *);
void Designation_ATOM(pdbfile *, double *, double *, double *,const long ,const long ,const long , const long );
void Angles_Research(pdbfile *);
void Check_AA(pdbfile *);
void Recherche_Alternative_Location(pdbfile *);
void UnChainMyH(pdbfile *);
void EcraseSuivant(pdbfile *, long , long );


/**********************************/
/*     secondary structures       */
/**********************************/

/*int NeufEtatsDssp(char );
void WriteDSSPvsPB(pdbfile *);
int TroisEtatsDsspFormule2(char );
void CompositionS2(pdbfile *);
void LectureFichierPcurveS2(pdbfile *,char *);
*/


void S2pcurve(pdbfile *);
void S2define(pdbfile *);

/*
void LectureFichierDefineS2(pdbfile *,char *);
*/



void S2FodjeAlK(pdbfile *);
/*int DouzEtatsDsspRK(char);
int EtatsFodje(char);
*/
/*
int TroisEtatsPcurve(char );
int TroisEtatsDefine(char );

int TroisEtatsDssp(char );

void S2accord(pdbfile *);
void S2accord5(pdbfile *);
void LectureFichierStrideS2(pdbfile *,char *);
void LectureFichierDsspS2(pdbfile *,char *);*/
/*int EightEtatsxtls(char);*/
void S2dssp(pdbfile *);
void S2dsspcont(pdbfile *);
/*int CEightDssp(char );*/
void S2sea(pdbfile *);
void S2stride(pdbfile *);
void WriteFast(pdbfile *);
/*int TroisEtatsPsea(char );
int FiveStateHel(char );*/

/*int TroisEtatsStride(char );*/

/*int TroisEtatsDssp(char );
int TroisEtatsDefine(char );
int TroisEtatsPcurve(char );*/
void clean(char *, int );

void S2xtlsstr(pdbfile *);
void S2Segno(pdbfile *);
void S2Kaksi(pdbfile *);

int EtatsSegno(char );
int EtatsKaksi(char );


void Modeller_AA(pdbfile *,const long ,const long );
void back_XYZ(pdbfile *);
void Protein_Network(pdbfile *);

/****************************/
/*     rot_mvt_trans        */
/****************************/


double distance_intercarbone(double ,double ,double ,double ,double ,double );
double transDegree(double );
void ORIG_rotation(double ,double *,double *);
void ORIG_translation(double ,double *);
void Translat(double , double *);
void Rotat2axes(double , double *, double *);
void TranslatExt(double , double *, long );	

/***********************************/
/*     small fragments rmsd        */
/***********************************/

void mainpass(double *,double *,double *,double *,double *,double *, char *, int);
void mainpass2(double *,double *,double *,double *,double *,double *, char *, int);

/*****************************/
/*     small ext rmsd        */
/*****************************/

void mainpass3(double *,double *,double *,double *,double *,double *, char *, int, long);
void mainpass4(double *,double *,double *,double *,double *,double *, char *, int, long);


void mainpass3bis(double *,double *,double *,double *,double *,double *, char *, int, long);


void mainpassSippl(double *, double *, double *, double *, double *, double *, long );
double superposit(double *,double *,double *,double *,double *,double *, long , long , long ,long );
double rmsd(double *, double *, double *, double *, double *, double *, long );

double rmsd3d(double **, double **, long );

void Sippl(double *, double *, double *, double *, double *, double *, long );

void create_PDB_CA(double *,double *,double *,char *, char *, long, long );
void create_PDB_CAxyz(double **,char *, char *, long, long );

/*********************/
/*     dist.c        */
/*********************/
double distance_interATOM(const double ,const double ,const double ,const double ,const double ,const double );
void DistanceLAT(pdbfile *);

/*********************/
/*     alloc.c        */
/*********************/
short int***  AllocMemoireShIntIntInt(short int ,short int ,short int );
void DesAllocMemoireShIntIntInt(short int ***,short int ,short int );
char*  AllocMemoireChar(int );
int*  AllocMemoireInt(int );
int**  AllocMemoireIntInt(int ,int );
float*  AllocMemoireFl(int );
float**  AllocMemoireFlFl(int ,int );
float***  AllocMemoireFlFlFl(int ,int ,int );
void DesallocMemoireInt(int *);
void DesallocMemoireIntInt(int **,int );
void DesallocMemoireFlFl(float **,int );
void DesallocMemoireFlFlFl(float ***matrice,int dimension1, int dimension2);

double**  AllocMemoireDblDbl_By_Long(long ,long );
void DesallocMemoireDblDbl_By_Long(double **,long );

/*********************/
/*  basic fonctions  */
/*********************/

extern double controlexp(double );
extern float controlexpf(float );
extern double controlsqrt(double , double , double );
extern double aucarre(double , double );
extern double DistEucl(double , double );
void clean_str(char *, const long );

/**********************************/
/*	     traduction	       	  */
/**********************************/

char BPtransTM(const long );
char BPtrans(const long );
int transAA(const char );
int transAAlogic(const char );
char AAtrans(const long );
char AALogictrans(const long );
int AAthreeToone(char *);
char* aa3(const long );

/**********************************/
/*	     fichier		  */
/**********************************/

void op(FILE *);
void of(FILE *);
void o(void);
void p(char *);
FILE *flire(char []);
void *fMAZ(char []);
FILE *fecrire(char []);
FILE *fSurecrire(char []);




/***************************/
/*     tm_special.c        */
/***************************/

void Helix_Axes(pdbfile *);




void ligne_pdb(pdbfile *, FILE *, long ,long );
void Promotif_Read(pdbfile *);


void WriteFastDBank(pdbfile *);

void SimpleOut(pdbfile *);

/* turn.c */

void Turn(pdbfile *); 
void TurnClean(pdbfile *);


/* definition.c */

void WriteDef(void);
void TransTypeNext(void);


void Kolocomparison(void);
void DistRep(pdbfile *);
void Molscriptage(pdbfile *);

void write_chain_pdb(pdbfile *, char *, long );

void SearchPBmotifs(pdbfile *);

void CYSsearch(pdbfile *);

void rec(pdbfile *);
void PIIpdb(pdbfile *);
void Dist(pdbfile *);

void ReadNaxes(pdbfile *);
void pymol(pdbfile *);

void SubCL(pdbfile *);
