/******************************************************************************/
/*	PDB Dreamer version 1.05					      */
/*      (A.G. de Brevern - EBGM - U726 INSERM)				      */
/******************************************************************************/
/*	sec_str_definition.h	(beta version 2005)			      */
/*	-------------------						      */
/*	definition of turns used					      */
/******************************************************************************/
/*     NB_XXXXX_DEF defined in lib_define.h				      */
/*     extern defined in lib_structure.h                   	              */
/******************************************************************************/

# include "basic_h.h"

/************/
/* 00- dssp */
/************/

char *dssp_name[NB_DSSP_STATE]={"Alpha -helix         ",\
		"3.10 - helix        ",\
		"Pi - helix",\
		"hydrogen bonded turn",\
		"bend",\
		"coil",\
		"residue in isolated beta-bridge",\
		"extended strand, participates in beta ladder",\
		"not found"};
		
		
char *short_dssp_name[NB_DSSP_STATE]={"H ","G ","I ","T ","S ","  ","B ","E ","U "};
		

char *dssp_ref={"W. Kabsh and C. Sander (1983)\nDictionary of protein secondary structure: Pattern recognition of hydrogen bonded and geometrical features.\nBiopolymers, 22:2577."};

/**************/
/* 01- stride */
/**************/

char *stride_ref={"D. Frishman and P. Argos (1995)\nKnowledge-based protein secondary structure.\nProteins, 23:566-579."};

char *stride_notes={"same notations than dssp"};

/************/
/* 02- psea */
/************/

char *psea_name[NB_psea_STATE]={"Alpha -helix         ",\
		"coil",\
		"extended strand",\
		"not found"};
		
		
char *short_psea_name[NB_psea_STATE]={"a ","c ","b ","U "};
		
char *psea_ref={"G. Labesse, N. Colloc'h, J. Pothier, and J.-P. Mornon (1997)\nP-sea: a new efficient assignement of secondary structure from Calpha\nComput. Appl. Biosci., 13:291-295, 1997."};

/**************/
/* 04- define */
/**************/



char *define_name[NB_psea_STATE]={"Alpha -helix         ",\
		"coil",\
		"extended strand",\
		"not found"};
		
		
char *short_define_name[NB_psea_STATE]={"A ","C ","B ","U "};
		
char *define_ref={"F. Ridchards and C. Kundrot (1988)\nIdentification of structural motifs from protein coordinate data: secondary structure and first-level supersecondary structure.\nProteins, 3:71-84."};

/**************/
/* 04- pcurve */
/**************/

char *pcurve_name[NB_psea_STATE]={"Alpha -helix         ",\
		"coil",\
		"extended strand",\
		"not found"};
		
		
char *short_pcurve_name[NB_psea_STATE]={"+ ","  ","- ","U "};
		
char *pcurve_ref={"H. Sklenar, C. Etchebest, and R. Lavery (1989)\nDescribing protein structure: a general algorithm yielding complete helicoidal parameters and a unique overall axis.\nProteins, 6:46-60."};

/**************/
/* consensus: */
/**************/

char *pcons93_ref={"N. Colloc'h, C. Etchebest, E. Thoreau, B. Henrissat, and J. Mornon (1993)\nComparaison of three algorithms for the assignement of secondary structure in proteins: the advantages of a concenssus assignement.\nProtein Eng., 6:377-382."};

/**************/
/* 05- xtllstr */
/**************/

char *xtllstr_name[NB_XTLSSTR_STATE]={"Alpha -helix         ",\
		"3.10 - helix ",\
		"3.10 - helix C-cap ",\
		"turns (hydrogen-bonded)",\
		"turns -'like' (unhydrogen-bonded) ",\
		"polyproline II type (3-1) helix ",\
		"polyproline II type (3-1) helix ",\
		"coils ",\
		"extended strand",\
		"not found"};
		
		
char *short_xtllstr_name[NB_XTLSSTR_STATE]={"H ","G ","g ","T ","N ","P ","p ","- ","E ","U "};
		
char *xtllstr_ref={"S. M. King and W. C. Johnson "};

/**************/
/* 06- helanal */
/**************/

char *helanal_name[NB_HELANAL_STATE]={"Alpha -helix (too short)        ",\
		"linear helix ",\
		"curved helix ",\
		"kinked helix  ",\
		"unsassigned ",\
		"not helicoidal ",\
		"not found"};
		
		
char *short_helanal_name[NB_HELANAL_STATE]={"H ","L ","C ","K ","* ","- ","U "};
		
char *helanal_ref={"Bansal, M., Kumar, S. and Velavan, R. 2000.\n HELANAL - A program to characterise helix geometry in proteins. Journal of Biomolecular Structure and Dynamics.\n 17, 5, 811 - 819.\n"};


/**************************/
/* 07- Rachel Karchin     */
/* extended dssp alphabet */
/**************************/

char *dssprk_name[NB_DSSPRK_STATE]={"Alpha -helix         ",\
		"3.10 - helix        ",\
		"Pi - helix",\
		"hydrogen bonded turn",\
		"bend",\
		"coil",\
		"residue in isolated beta-bridge",\
		"extended strand, parallel in sheet",\
		"extended strand, parallel edge",\
		"extended strand, antiparallel sheet",\
		"extended strand, antiparallel edge",\
		"extended strand, parallel and antiparallel mixed",\
		"extended strand, alone (?)",\
		"not found"};
		
		
char *short_dssprk_name[NB_DSSPRK_STATE]={"H ","G ","I ","T ","S ","  ","B ","P ","Q ","A ","Z ","M ","E ","U "};
		

char *dssprk_ref={"Rachel Karchin et al. (2003)"};

char *dssprk_notes={"It is an extended alphabet which divides only the sheets (B,G,H,I,T,S,C are as in dssp)\nThe STR (strand) alphabet is ``BGHSTLPAMZQE''an enhanced version of DSSP, conceived by Yael Mandel-Gutfreund"};


/**************/
/* 09- secstr */
/**************/

char *secstr_name[NB_secstr_STATE]={"Alpha -helix         ",\
		"3.10 - helix        ",\
		"Pi - helix",\
		"coil",\
		"extended strand ",\
		"not found"};
		
		
char *short_secstr_name[NB_secstr_STATE]={"H ","G ","I ","C ","E ","U "};
		
char *secstr_ref={"Fodje MN, Al-Karadaghi S (2002)\n Occurrence, conformational features and amino acid propensities for the pi-helix.\n Protein Eng. 15(5):353-8\n"};

/**************/
/* 10- segno */
/**************/

char *segno_name[NB_segno_STATE]={"Alpha -helix         ",\
		"3.10 -helix         ",\
		"pi -helix         ",\
		"Polyproline II  ",\
		"coil",\
		"extended strand (in beta-sheet) ",\
		"extended strand (alone)",\
		"not found"};
		
		
char *short_segno_name[NB_segno_STATE]={"H ","G ","I ","P ","O ","E ","b ","U "};
		
char *segno_ref={"Cubellis & Lovell, in preparation\n"};



	
/***************/
/* Beta-bulges */
/***************/

char *betabul_name[NB_betabul_STATE]={"Parallel - Classic         ",\
		"Parallel - G1        ",\
		"Parallel - Wide",\
		"Parallel - Bent",\
		"Parallel - Special ",\
		"Antiparallel - Classic         ",\
		"Antiparallel - G1        ",\
		"Antiparallel - Wide",\
		"Antiparallel - Bent",\
		"Antiparallel - Special ",\
		"not found"};
		
		
char *short_betabul_name[NB_betabul_STATE]={"P C ","P G ","P W ","P B ","P S ","A C ","A G ","A W ","A B ","A S ","U   "};
		
char *betabul_ref={"Chan et al. (1993)\n Identification, classification, and analysis of beta-bulges in proteins\n Protein Science 2(10):1574-1590\n"};
