# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/lib_local_secstr.h"
# include "secondary_structure.h"
# include "comparison.h"


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/****************/
/* Consensus S2 */
/****************/
	
void S2accord(pdbfile *m){
	int y50;
	int i50=0;
	int ok_psea_dssp=0;
	int ok_psea_stride=0;
	int ok_dssp_stride=0;
		
for(y50=0;y50<((m->NB_chain)+1);y50++){
	for(i50=m->Pos_FirstRes[y50];i50<m->Pos_LastRes[y50]-1;i50++){
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsStride(m->S2stride[i50]))
			ok_dssp_stride++;
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsPsea(m->S2sea[i50]))
			ok_psea_dssp++;
		if(TroisEtatsPsea(m->S2sea[i50])==TroisEtatsStride(m->S2stride[i50]))
			ok_psea_stride++;
		}	
	}
	printf("**+> %8.2f %8.2f %8.2f\n",100*(float)ok_dssp_stride/(i50-1),100*(float)ok_psea_dssp/(i50-1),100*(float)ok_psea_stride/(i50-1));
}

void S2accord5(pdbfile *m){
	FILE *f49;
	int y50;
	int i50=0;
	int ok_psea_dssp=0;
	int ok_psea_stride=0;
	int ok_psea_define=0;
	int ok_psea_pcurve=0;
			
	int ok_dssp_stride=0;
	int ok_dssp_define=0;
	int ok_dssp_pcurve=0;		
	
	int ok_stride_define=0;
	int ok_stride_pcurve=0;		
	
	int ok_define_pcurve=0;		

	char cp='A';
	
for(y50=0;y50<((m->NB_chain)+1);y50++){
	ok_psea_dssp=ok_psea_stride=ok_psea_define=ok_psea_pcurve=ok_dssp_stride=ok_dssp_define=ok_dssp_pcurve=ok_stride_define=ok_stride_pcurve=ok_define_pcurve=0;		

	for(i50=m->Pos_FirstRes[y50];i50<m->Pos_LastRes[y50]-1;i50++){
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsPsea(m->S2sea[i50]))
			ok_psea_dssp++;
		if(TroisEtatsPsea(m->S2sea[i50])==TroisEtatsStride(m->S2stride[i50]))
			ok_psea_stride++;
		if(TroisEtatsPsea(m->S2sea[i50])==TroisEtatsDefine(m->S2define[i50]))
			ok_psea_define++;
		if(TroisEtatsPsea(m->S2sea[i50])==TroisEtatsPcurve(m->S2pcurve[i50]))
			ok_psea_pcurve++;
		
		
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsStride(m->S2stride[i50]))
			ok_dssp_stride++;
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsDefine(m->S2define[i50]))
			ok_dssp_define++;
		if(TroisEtatsDssp(m->S2dssp[i50])==TroisEtatsPcurve(m->S2pcurve[i50]))
			ok_dssp_pcurve++;
		
		if(TroisEtatsStride(m->S2stride[i50])==TroisEtatsDefine(m->S2define[i50]))
			ok_stride_define++;
		if(TroisEtatsStride(m->S2stride[i50])==TroisEtatsPcurve(m->S2pcurve[i50]))
			ok_stride_pcurve++;
		
		if(TroisEtatsDefine(m->S2define[i50])==TroisEtatsPcurve(m->S2pcurve[i50]))
			ok_define_pcurve++;
		
		}	
	}				    
	printf("ACCORD SUR LES 5 METHODES :\n---------------------------\n");
	printf("%8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f\n",\
	100*(float)ok_psea_dssp/(i50-1),100*(float)ok_psea_stride/(i50-1),100*(float)ok_psea_define/(i50-1),100*(float)ok_psea_pcurve/(i50-1),\
	100*(float)ok_dssp_stride/(i50-1),100*(float)ok_dssp_define/(i50-1),100*(float)ok_dssp_pcurve/(i50-1),\
	100*(float)ok_stride_define/(i50-1),100*(float)ok_stride_pcurve/(i50-1),100*(float)ok_define_pcurve/(i50-1));
	
	f49=fopen("Results/accord_s2.txt","a+");
	fprintf(f49,">%4s%c %6ld BP16  %1.1f\n",(m->name),(cp),(m->Pos_LastRes[y50]-m->Pos_FirstRes[y50]+1),(m->resolution));
	fprintf(f49,"%6d\t%6d\t%6d\t%6d\t%6d\t%6d\t%6d\t%6d\t%6d\t%6d\t%6d\n",ok_psea_dssp,ok_psea_stride,ok_psea_define,ok_psea_pcurve,ok_dssp_stride,ok_dssp_define,ok_dssp_pcurve,\
	ok_stride_define,ok_stride_pcurve,ok_define_pcurve,i50-1);
	
	cp++;
	fclose(f49);
}


void S2accord5_V2(pdbfile *m){
	FILE *f49;
	int y50;
	int i50,j50;

	int DSSP_STRIDE[4][4];
	int DSSP_PSEA[4][4];
	int DSSP_DEFINE[4][4];
	int DSSP_PCURVE[4][4];
	int STRIDE_PSEA[4][4];
	int STRIDE_DEFINE[4][4];
	int STRIDE_PCURVE[4][4];
	int PSEA_DEFINE[4][4];
	int PSEA_PCURVE[4][4];
	int DEFINE_PCURVE[4][4];

	int DSSP[4];
	int STRIDE[4];
	int DEFINE[4];
	int PSEA[4];
	int PCURVE[4];

	/* 31 - 07 -2003 */
	
	int DSSPcont[4];
	
	int DSSP_DSSPcont[4][4];
	int STRIDE_DSSPcont[4][4];
	int PSEA_DSSPcont[4][4];
	int DEFINE_DSSPcont[4][4];
	int PCURVE_DSSPcont[4][4];
	
	long deb,fin;
	
	printf("S2accord5_V2\n");

	for(i50=0;i50<4;i50++){
		for(j50=0;j50<4;j50++){

			DSSP_STRIDE[i50][j50]=0;
			DSSP_PSEA[i50][j50]=0;
			DSSP_DEFINE[i50][j50]=0;
			DSSP_PCURVE[i50][j50]=0;
			STRIDE_PSEA[i50][j50]=0;
			STRIDE_DEFINE[i50][j50]=0;;
			STRIDE_PCURVE[i50][j50]=0;;
			PSEA_DEFINE[i50][j50]=0;
			PSEA_PCURVE[i50][j50]=0;
			DEFINE_PCURVE[i50][j50]=0;
			
			DSSP_DSSPcont[i50][j50]=0;
 			STRIDE_DSSPcont[i50][j50]=0;
 			PSEA_DSSPcont[i50][j50]=0;
 			DEFINE_DSSPcont[i50][j50]=0;
 			PCURVE_DSSPcont[i50][j50]=0;
			
			
			DSSP[j50]=STRIDE[j50]=DEFINE[j50]=PSEA[j50]=PCURVE[j50]=DSSPcont[j50]=0;
			}
		}
		
	if(CHAIN!='-') {printf("chaine :*%c*\n",CHAIN);	
	deb=(int)(CHAIN)-(int)('A');
	fin=deb+1;
	}
	else{
	deb=0;
	fin=((m->NB_chain)+1);
	}
	
	
/*	for(y50=0;y50<((m->NB_chain)+1);y50++){*/
	for(y50=deb;y50<fin;y50++){
		for(i50=m->Pos_FirstRes[y50];i50<m->Pos_LastRes[y50]-1;i50++){

			DSSP_STRIDE[TroisEtatsDssp(m->S2dssp[i50])][TroisEtatsStride(m->S2stride[i50])]++;
			DSSP_PSEA[TroisEtatsDssp(m->S2dssp[i50])][TroisEtatsPsea(m->S2sea[i50])]++;	
			DSSP_DEFINE[TroisEtatsDssp(m->S2dssp[i50])][TroisEtatsDefine(m->S2define[i50])]++;
			DSSP_PCURVE[TroisEtatsDssp(m->S2dssp[i50])][TroisEtatsPcurve(m->S2pcurve[i50])]++;
	
			STRIDE_PSEA[TroisEtatsStride(m->S2stride[i50])][TroisEtatsPsea(m->S2sea[i50])]++;	
			STRIDE_DEFINE[TroisEtatsStride(m->S2stride[i50])][TroisEtatsDefine(m->S2define[i50])]++;
			STRIDE_PCURVE[TroisEtatsStride(m->S2stride[i50])][TroisEtatsPcurve(m->S2pcurve[i50])]++;
		
			PSEA_DEFINE[TroisEtatsPsea(m->S2sea[i50])][TroisEtatsDefine(m->S2define[i50])]++;
			PSEA_PCURVE[TroisEtatsPsea(m->S2sea[i50])][TroisEtatsPcurve(m->S2pcurve[i50])]++;
	
			DEFINE_PCURVE[TroisEtatsDefine(m->S2define[i50])][TroisEtatsPcurve(m->S2pcurve[i50])]++;
			
			DSSP[TroisEtatsDssp(m->S2dssp[i50])]++;
			STRIDE[TroisEtatsStride(m->S2stride[i50])]++;
			PSEA[TroisEtatsPsea(m->S2sea[i50])]++;
			DEFINE[TroisEtatsDefine(m->S2define[i50])]++;
			PCURVE[TroisEtatsPcurve(m->S2pcurve[i50])]++;
			
			
			if(LECT_DSSP_cont=='T'){DSSPcont[TroisEtatsDssp(m->S2dsspcont[i50])]++;
			
			DSSP_DSSPcont[TroisEtatsDssp(m->S2dssp[i50])][TroisEtatsStride(m->S2dsspcont[i50])]++;
			STRIDE_DSSPcont[TroisEtatsStride(m->S2stride[i50])][TroisEtatsStride(m->S2dsspcont[i50])]++;
			PSEA_DSSPcont[TroisEtatsPsea(m->S2sea[i50])][TroisEtatsStride(m->S2dsspcont[i50])]++;
			DEFINE_DSSPcont[TroisEtatsDefine(m->S2define[i50])][TroisEtatsStride(m->S2dsspcont[i50])]++;
			PCURVE_DSSPcont[TroisEtatsPcurve(m->S2pcurve[i50])][TroisEtatsStride(m->S2dsspcont[i50])]++;}
			
			}
		}	
	
	
	
	
	f49=fopen("Results/Accord_v2.txt","a+");

	/* freq des s2 dans les 5 :*/
	for(j50=0;j50<4;j50++)
		fprintf(f49,"%4d\t",DSSP[j50]);
	for(j50=0;j50<4;j50++)		
		fprintf(f49,"%4d\t",STRIDE[j50]);
	for(j50=0;j50<4;j50++)		
		fprintf(f49,"%4d\t",PSEA[j50]);
	for(j50=0;j50<4;j50++)		
		fprintf(f49,"%4d\t",DEFINE[j50]);
	for(j50=0;j50<4;j50++)		
		fprintf(f49,"%4d\t",PCURVE[j50]);
		

	for(i50=0;i50<4;i50++)
		for(j50=0;j50<4;j50++)
			fprintf(f49,"%4d\t",DSSP_STRIDE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DSSP_PSEA[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DSSP_DEFINE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DSSP_PCURVE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",STRIDE_PSEA[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",STRIDE_DEFINE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",STRIDE_PCURVE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",PSEA_DEFINE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",PSEA_PCURVE[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DEFINE_PCURVE[i50][j50]);
	
	
	/* 31 - 07 -2003 */
	
	if(LECT_DSSP_cont=='T'){
	for(j50=0;j50<4;j50++)
		fprintf(f49,"%4d\t",DSSPcont[j50]);
	
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DSSP_DSSPcont[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",STRIDE_DSSPcont[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",PSEA_DSSPcont[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",DEFINE_DSSPcont[i50][j50]);
	for(i50=0;i50<4;i50++)			
		for(j50=0;j50<4;j50++)			
			fprintf(f49,"%4d\t",PCURVE_DSSPcont[i50][j50]);
	}
	fprintf(f49,"\n");

	fclose(f49);
}

void calccons(int values[4],char state){

	/*printf("%c\t",state);*/
	switch (state){
		case ('H'): values[0]++; break;
		case ('C'): values[1]++; break;
		case ('E'): values[2]++; break;
		default :   values[3]++; break;
		};
	/*printf("%d %d %d %d\n",values[0],values[1],values[2],values[3]);*/
}

char consvalues(int values[4]){
	char c;
	int u,som;
	som=0;
	for(u=0;u<3;u++)
		som+=values[u];
	if((values[0]>0)&&(values[2]>0))c='!';
	if((((double)values[0]/(double)som)==1.0)||(((double)values[1]/(double)som)==1.0)||(((double)values[2]/(double)som)==1.0))
		c='*';
	else 	c='.';
	/*printf("%d %d %d %d ==> [%c]\n",values[0],values[1],values[2],values[3],c);*/
	return(c);
	}


