/***************************************************************************/
/*	PDB Dreamer version x.yz					   */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				   */
/*      this part is taken from an other  soft				   */
/***************************************************************************/
/*	Kohonen Maps software written by A.G. de BREVERN 		   */
/***************************************************************************/
/*	version 1.0 (c) 2003 						   */
/*	please do not use without the permission of the author		   */
/*	contact : debrevern@urbb.jussieu.fr				   */
/***************************************************************************/
/*	A. G. de BREVERN						   */
/*	EBGM - INSERM U436 / E 0346					   */
/*	Equipe de Bioinformatique Gnomique et Molculaire		   */
/*	INSERM, Universit Paris 7, case 7113,				   */
/*	2, place Jussieu, 75251 Paris Cedex 05 - FRANCE			   */
/***************************************************************************/

/***************************************************************************/
/*	allocation.c					 		   	   */
/*	------------							   */
/*	initialization of matrices					   */
/*	version 1.1 (c) 2003						   */
/* 	last modification : 30-JAN-2003					   */
/***************************************************************************/

# include "../HEADER/basic_h.h"

/****************************************************************************************************************/
/*														*/
/* allocation pour char :											*/
/* ----------------------											*/
/*														*/
/* char*  AllocMemoireChar(int dimension1);								        */
/* char**  AllocMemoireCharChar(int dimension1,int dimension2);							*/
/* void DesallocMemoireChar(char *xc);										*/
/* void DesallocMemoireCharChar(char **matrice,int dimension1);							*/
/*														*/
/* char*  AllocMemoireChar_By_Long(long dimension1);								*/
/* char**  AllocMemoireCharChar_By_Long(long dimension1,long dimension2);					*/
/* void DesallocMemoireChar_By_Long(char *xc);									*/
/* void DesallocMemoireCharChar_By_Long(char **matrice,long dimension1);					*/
/*--------------------------------------------------------------------------------------------------------------*/
/*														*/
/* allocation pour short int :											*/
/* ---------------------------											*/
/*														*/
/* short int***  AllocMemoireShIntIntInt(int dimension1,int dimension2, int dimension3);			*/
/* void DesAllocMemoireShIntIntInt(short int ***matrice, int dimension1, int dimension2);			*/
/*														*/
/* short int*  AllocMemoireShortInt_By_Long(long dimension1);							*/
/* void DesallocMemoireIntShortInt_By_Long(short int *xc);							*/
/*--------------------------------------------------------------------------------------------------------------*/
/*														*/
/* allocation pour int :											*/
/* ---------------------											*/
/*														*/
/* int*  AllocMemoireInt(int dimension1);									*/
/* int**  AllocMemoireIntInt(int dimension1,int dimension2);							*/
/* void DesallocMemoireInt(int *xc);										*/
/* void DesallocMemoireIntInt(int **matrice,int dimension1);							*/
/*--------------------------------------------------------------------------------------------------------------*/
/*														*/
/* allocation pour long :											*/
/* ----------------------											*/
/*														*/
/* long*  AllocMemoireLong(int dimension1);									*/
/* long**  AllocMemoireLongLong(int dimension1,int dimension2);							*/
/* long***  AllocMemoireLongLongLong(int dimension1,int dimension2,int dimension3);				*/
/* void DesallocMemoireLong(long *xc);										*/
/* void DesallocMemoireLongLong(long **matrice,long dimension1);						*/
/*														*/
/* long*  AllocMemoireLong_By_Long(long dimension1);								*/
/* long**  AllocMemoireLongLong_By_Long(long dimension1,long dimension2);					*/
/* void DesallocMemoireLong_By_Long(long *xc);									*/
/* void DesallocMemoireLongLong_By_Long(long **matrice,long dimension1);					*/
/* void DesallocMemoireLongLongLong(long ***matrice,int dimension1, int dimension2);				*/
/*--------------------------------------------------------------------------------------------------------------*/
/*														*/
/* allocation pour float :											*/
/* -----------------------											*/
/*														*/
/* float*  AllocMemoireFl(int dimension1);									*/
/* float**  AllocMemoireFlFl(int dimension1,int dimension2);							*/
/* float***  AllocMemoireFlFlFl(int dimension1,int dimension2,int dimension3);					*/
/* void DesallocMemoireFlFl(float **matrice,int dimension1);							*/
/* void DesallocMemoireFlFlFl(float ***matrice,int dimension1, int dimension2);					*/
/* void DesallocMemoireFlFlFlFl(float ***matrice,int dimension1, int dimension2, int dimension3);		*/
/*														*/
/* float*  AllocMemoireFl_By_Long(long dimension1);								*/
/* float**  AllocMemoireFlFl_By_Long(long dimension1,long dimension2);						*/
/* float***  AllocMemoireFlFlFl_By_Long(long dimension1,long dimension2,long dimension3);			*/
/* void DesallocMemoireFl_By_Long(float *xc);									*/
/* void DesallocMemoireFlFl_By_Long(float **matrice,long dimension1);						*/
/* void DesallocMemoireFlFlFl_By_Long(float ***matrice,long dimension1, long dimension2);			*/
/*--------------------------------------------------------------------------------------------------------------*/
/*														*/
/* allocation pour double :											*/
/* ------------------------											*/
/*														*/
/* double*  AllocMemoireDbl(int dimension1);									*/
/* double**  AllocMemoireDblDbl(int dimension1,int dimension2);							*/
/* double***  AllocMemoireDblDblDbl(int dimension1,int dimension2,int dimension3);				*/
/* void DesallocMemoireDblDbl(double **matrice,int dimension1);							*/
/* void DesallocMemoireDblDblDbl(double ***matrice,int dimension1, int dimension2);				*/


/* double**  AllocMemoireDblDbl_By_Long(long dimension1,long dimension2);					*/
/* double*  AllocMemoireDbl_By_Long(long dimension1);								*/

/* void DesallocMemoireDblDbl_By_Long(double **matrice,long dimension1)						*/
/****************************************************************************************************************/

/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/*********************/
/*	CHAR	     */
/*********************/

/******************************************************************************/
/*     		  	Allocation pour char	 		     	      */
/******************************************************************************/

char*  AllocMemoireChar(int dimension1){	
	char *vect;
	if((vect=(char*)calloc((dimension1),sizeof(char)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Entier matrice 2D     *******************************/

char**  AllocMemoireCharChar(int dimension1,int dimension2){	
	char **matrice;
	int i_i;
	matrice=(char **) calloc (dimension1,sizeof (char*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(char*)calloc(dimension2,sizeof(char));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

/******************************************************************************/
/* 		     Desallocation char par entier	 		      */
/******************************************************************************/

/**********************   Char vecteur 1D     *******************************/

void DesallocMemoireChar(char *xc){	
	free(xc);}

/**********************   Char matrice 2D     *******************************/

void DesallocMemoireCharChar(char **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}



/******************************************************************************/
/* 		    	 Allocation par long	 			      */
/******************************************************************************/


char*  AllocMemoireChar_By_Long(long dimension1){	
	char *vect;
	if((vect=(char*)calloc((dimension1),sizeof(char)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Char matrice 2D     *******************************/

char**  AllocMemoireCharChar_By_Long(long dimension1,long dimension2){	
	char **matrice;
	long i_i;
	matrice=(char **) calloc (dimension1,sizeof (char*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(char*)calloc(dimension2,sizeof(char));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

/******************************************************************************/
/* 		     Desallocation par long	 			      */
/******************************************************************************/

/**********************   Char vecteur 1D     *******************************/

void DesallocMemoireChar_By_Long(char *xc){	
	free(xc);}

/**********************   Char matrice 2D     *******************************/

void DesallocMemoireCharChar_By_Long(char **matrice,long dimension1){	
	long i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}


/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/*********************/
/*	ENTIERS	     */
/*********************/

/******************************************************************************/
/*     		  Allocation pour entiers courts	 		      */
/******************************************************************************/


/**********************  short  int matrice 3D     *******************************/
short int***  AllocMemoireShIntIntInt(int dimension1,int dimension2, int dimension3){	
	short int*** matrice;
	int i_i,i_2;
	matrice=(short int***) calloc (dimension1,sizeof (short int**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(short int**)calloc(dimension2,sizeof(short int*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(short int*)calloc(dimension3,sizeof(short int));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

/**********************  short  int matrice 3D     *******************************/

void DesAllocMemoireShIntIntInt(short int ***matrice, int dimension1, int dimension2){	
	short int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}


/**********************  Short Entier vecteur 1D  par long  *******************************/

short int*  AllocMemoireShortInt_By_Long(long dimension1){	
	short int *vect;
	if((vect=(short int*)calloc((dimension1),sizeof(short int)))==NULL)		
		printf("Alloc Pb d'allocation du vecteur AllocMemoireShortInt_By_Long \n");
	return(vect);}

void DesallocMemoireIntShortInt_By_Long(short int *xc){	
	free(xc);}


/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/******************************************************************************/
/* 			Allocation pour entier	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

int*  AllocMemoireInt(int dimension1){	
	int *vect;
	if((vect=(int*)calloc((dimension1),sizeof(int)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Entier matrice 2D     *******************************/

int**  AllocMemoireIntInt(int dimension1,int dimension2){	
	int **matrice;
	int i_i;
	matrice=(int **) calloc (dimension1,sizeof (int*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(int*)calloc(dimension2,sizeof(int));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

/******************************************************************************/
/* 		     Desallocation pour entier	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

void DesallocMemoireInt(int *xc){	
	free(xc);}

/**********************   Entier matrice 2D     *******************************/

void DesallocMemoireIntInt(int **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}

/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/********/
/* LONG */
/********/

/******************************************************************************/
/* 			Allocation pour long	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

long*  AllocMemoireLong(int dimension1){	
	long *vect;
	if((vect=(long*)calloc((dimension1),sizeof(long)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Entier matrice 2D     *******************************/

long**  AllocMemoireLongLong(int dimension1,int dimension2){	
	long **matrice;
	int i_i;
	matrice=(long **) calloc (dimension1,sizeof (long*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(long*)calloc(dimension2,sizeof(long));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

long***  AllocMemoireLongLongLong(int dimension1,int dimension2,int dimension3){	
	long*** matrice;
	int i_i,i_2;
	matrice=(long***) calloc (dimension1,sizeof (long**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(long**)calloc(dimension2,sizeof(long*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(long*)calloc(dimension3,sizeof(long));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

long****  AllocMemoireLongLongLongLong(int dimension1,int dimension2,int dimension3,int dimension4){	
	long**** matrice;
	int i_i,i_2,i_3;
	matrice=(long****) calloc (dimension1,sizeof (long***));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(long***)calloc(dimension2,sizeof(long**));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(long**)calloc(dimension3,sizeof(long*));
			assert(matrice[i_i][i_2]!=NULL);
			for (i_3=0;i_3<dimension3;i_3++){
				matrice[i_i][i_2][i_3]=(long*)calloc(dimension4,sizeof(long));
				assert(matrice[i_i][i_2][i_3]!=NULL);
			}
		}
	}
	return matrice;
}

/******************************************************************************/
/* 		     Desallocation pour long	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

void DesallocMemoireLong(long *xc){	
	free(xc);}

/**********************   Entier matrice 2D     *******************************/

void DesallocMemoireLongLong(long **matrice,long dimension1){	
	long i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}

/******************************************************************************/
/* 			Allocation pour long	 			      */
/*			    par des longs 				      */
/******************************************************************************/

long*  AllocMemoireLong_By_Long(long dimension1){	
	long *vect;
	if((vect=(long*)calloc((dimension1),sizeof(long)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Entier matrice 2D     *******************************/

long**  AllocMemoireLongLong_By_Long(long dimension1,long dimension2){	
	long **matrice;
	long i_i;
	matrice=(long **) calloc (dimension1,sizeof (long*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(long*)calloc(dimension2,sizeof(long));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

/******************************************************************************/
/* 		     Desallocation pour long	 			      */
/*			    par des longs 				      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

void DesallocMemoireLong_By_Long(long *xc){	
	free(xc);}

/**********************   Entier matrice 2D     *******************************/

void DesallocMemoireLongLong_By_Long(long **matrice,long dimension1){	
	long i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}

/**********************   long matrice 3D     *******************************/

void DesallocMemoireLongLongLong(long ***matrice,int dimension1, int dimension2){	
	int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);
}

/**********************   long matrice 4D     *******************************/

void DesallocMemoireLongLongLongLong(long ****matrice,int dimension1, int dimension2, int dimension3){	
	int i2,i3,i4;
	
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			for(i4=0;i4<dimension3;i4++)
				free(matrice[i2][i3][i4]);
				
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
			
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	
	free(matrice);
}


/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/**********/
/* FLOAT */
/**********/

/******************************************************************************/
/*									      */
/* 			Allocation / Desallocation 			      */
/*	       de vecteurs, matrices a 2 ou 3 D pour float	              */
/*									      */
/******************************************************************************/

/******************************************************************************/
/* 			Allocation pour float	 			      */
/******************************************************************************/

float*  AllocMemoireFl(int dimension1){	
	float *vect;
	if((vect=(float*)calloc((dimension1),sizeof(float)))==NULL)		
		printf("Alloc_01 Pb d'allocation du AllocMemoireFl  \n");
	return(vect);}

/**********************   float matrice 2D     *******************************/

float**  AllocMemoireFlFl(int dimension1,int dimension2){	
	float **matrice;
	int i_i;
	matrice=(float **) calloc (dimension1,sizeof (float*));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(float*)calloc(dimension2,sizeof(float));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;
}

/**********************   float matrice 3D     *******************************/

float***  AllocMemoireFlFlFl(int dimension1,int dimension2,int dimension3){	
	float*** matrice;
	int i_i,i_2;
	matrice=(float***) calloc (dimension1,sizeof (float**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(float**)calloc(dimension2,sizeof(float*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(float*)calloc(dimension3,sizeof(float));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

/**********************   float matrice 4D     *******************************/

float****  AllocMemoireFlFlFlFl(int dimension1,int dimension2,int dimension3,int dimension4){	
	float**** matrice;
	int i_i,i_2,i_3;
	matrice=(float****) calloc (dimension1,sizeof (float***));
	assert(matrice!= NULL);
	for (i_i=0;i_i<dimension1;i_i++){
		matrice[i_i]=(float***)calloc(dimension2,sizeof(float**));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(float**)calloc(dimension3,sizeof(float*));
			assert(matrice[i_i][i_2]!=NULL);
			for (i_3=0;i_3<dimension3;i_3++){
				matrice[i_i][i_2][i_3]=(float*)calloc(dimension4,sizeof(float));
				assert(matrice[i_i][i_2][i_3]!=NULL);
				}
		}
	}
	return matrice;
}

/******************************************************************************/
/* 		     Desallocation pour float	 			      */
/******************************************************************************/

/**********************   float matrice 2D     *******************************/

void DesallocMemoireFlFl(float **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/**********************   float matrice 3D     *******************************/

void DesallocMemoireFlFlFl(float ***matrice,int dimension1, int dimension2){	
	int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/*     pour la desallocation on prend la meme chose mais on va a l'envers     */
/******************************************************************************/
/**********************   float matrice 4D     *******************************/
void DesallocMemoireFlFlFlFl(float ****matrice,int dimension1, int dimension2,int dimension3){	
	int i2,i3,i4;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			for(i4=0;i4<dimension3;i4++)
				free(matrice[i2][i3][i4]);
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/******************************************************************************/
/*									      */
/* 			Allocation / Desallocation 			      */
/*	       de vecteurs, matrices a 2 ou 3 D pour float	              */
/*				par long				      */
/*									      */
/******************************************************************************/

/******************************************************************************/
/* 			Allocation pour float	 			      */
/******************************************************************************/

float*  AllocMemoireFl_By_Long(long dimension1){	
	float *vect;
	if((vect=(float*)calloc((dimension1),sizeof(float)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur AllocMemoireFloat_By_Long \n");
	return(vect);}


/**********************   float matrice 2D     *******************************/

float**  AllocMemoireFlFl_By_Long(long dimension1,long dimension2){	
	float **matrice;
	long i_i;
	matrice=(float **) calloc (dimension1,sizeof (float*));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(float*)calloc(dimension2,sizeof(float));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;
}

/**********************   float matrice 3D     *******************************/

float***  AllocMemoireFlFlFl_By_Long(long dimension1,long dimension2,long dimension3){	
	float*** matrice;
	long i_i,i_2;
	matrice=(float***) calloc (dimension1,sizeof (float**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(float**)calloc(dimension2,sizeof(float*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(float*)calloc(dimension3,sizeof(float));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

/******************************************************************************/
/* 		     Desallocation pour float	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

void DesallocMemoireFl_By_Long(float *xc){	
	free(xc);}

/**********************   float matrice 2D     *******************************/

void DesallocMemoireFlFl_By_Long(float **matrice,long dimension1){	
	long i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/**********************   float matrice 3D     *******************************/

void DesallocMemoireFlFlFl_By_Long(float ***matrice,long dimension1, long dimension2){	
	long i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/
/****************************************************************************************************************/

/**********/
/* DOUBLE */
/**********/


/******************************************************************************/
/*									      */
/* 			Allocation / Desallocation 			      */
/*	       de vecteurs, matrices a 2 ou 3 D pour doubles	              */
/*									      */
/******************************************************************************/

/******************************************************************************/
/* 			Allocation pour double	 			      */
/******************************************************************************/

double*  AllocMemoireDbl(int dimension1){	
	double *vect;
	if((vect=(double*)calloc((dimension1),sizeof(double)))==NULL)		
		printf("Alloc_01 Pb d'allocation du AllocMemoireDbl  \n");
	return(vect);}

/**********************   Double matrice 2D     *******************************/

double**  AllocMemoireDblDbl(int dimension1,int dimension2){	
	double **matrice;
	int i_i;
	matrice=(double **) calloc (dimension1,sizeof (double*));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double*)calloc(dimension2,sizeof(double));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;
}

/**********************   Double matrice 3D     *******************************/

double***  AllocMemoireDblDblDbl(int dimension1,int dimension2,int dimension3){	
	double*** matrice;
	int i_i,i_2;
	matrice=(double***) calloc (dimension1,sizeof (double**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double**)calloc(dimension2,sizeof(double*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(double*)calloc(dimension3,sizeof(double));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

double***  AllocMemoireDblDblDbl_by_Long(long dimension1,long dimension2,long dimension3){	
	double*** matrice;
	long i_i,i_2;
	matrice=(double***) calloc (dimension1,sizeof (double**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double**)calloc(dimension2,sizeof(double*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(double*)calloc(dimension3,sizeof(double));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

double**  AllocMemoireDblDbl_By_Long(long dimension1,long dimension2){
	double **matrice;
	long i_i;
	matrice=(double **) calloc (dimension1,sizeof (double*));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double*)calloc(dimension2,sizeof(double));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;
}

/******************************************************************************/
/* 		     Desallocation pour double	 			      */
/******************************************************************************/

/**********************   Double matrice 2D     *******************************/

void DesallocMemoireDblDbl(double **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/**********************   Double matrice 3D     *******************************/

void DesallocMemoireDblDblDbl(double ***matrice,int dimension1, int dimension2){	
	int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

void DesallocMemoireDblDblDbl_by_Long(double ***matrice,long dimension1, long dimension2){	
	long i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}


void DesallocMemoireDblDbl_By_Long(double **matrice,long dimension1){	
	long i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}


double*  AllocMemoireDbl_By_Long(long dimension1){
	double *vect;
	if((vect=(double*)calloc((dimension1),sizeof(double)))==NULL)		
		printf("Alloc_01 Pb d'allocation du AllocMemoireDbl  \n");
	return(vect);}


/*     pour la desallocation on prend la meme chose mais on va a l'envers     */
/******************************************************************************/
