/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	check.c	(beta version 2003)				              */
/*	-------							      	      */
/*	check the PDB files						      */
/*	version : 1.02						              */
/*	last modification : 10-05-2003					      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/***##*****/
/* 0001h  */ 
/***##*****/
/*********************************************************************************************/
/* 	check_seqres :  write SEQRES information				     	     */
/*********************************************************************************************/

void check_seqres(pdbfile *m){
					/****************/
	FILE *fg;			/*    file      */
	int s_check;			/*     count    */
					/****************/
	
	if(CHECK_DBG=='T') printf("check_seqres: %d chains \n",m->pdbseqreschain.nb_chain);

	for(s_check=0;s_check<m->pdbseqreschain.nb_chain;s_check++){
		/*
		to see one day 
			if((m->pdbseqreschain.length_chain[s_check]-m->pdbseqres[m->pdbseqreschain.end_chain[s_check]].chain_length)!=0){
		*/
			fg=fSurecrire("Results/check_seqres.txt");
			fprintf(fg,"#######################################################\n");
			fprintf(fg,"# NAME : %s\n",m->name);
			fprintf(fg,"# RESIDUE NUMBER (SEQRES) : %9ld\n",m->pdbseqreschain.nb_res);
			fprintf(fg,"#######################################################\n");
			fprintf(fg,"# CHAIN NUMBER (SEQRES) :   %9d\n",m->pdbseqreschain.nb_chain);
			fprintf(fg,"#######################################################\n");
			for(s_check=0;s_check<m->pdbseqreschain.nb_chain;s_check++){
				fprintf(fg,"# CHAIN NUMBER %2d BEGIN :   %9ld\n",s_check,m->pdbseqreschain.begin_chain[s_check]);
				fprintf(fg,"# CHAIN NUMBER %2d END :     %9ld\n",s_check,m->pdbseqreschain.end_chain[s_check]);
				fprintf(fg,"# CHAIN NUMBER %2d LENGTH :  %9ld\n",s_check,m->pdbseqreschain.length_chain[s_check]);
				fprintf(fg,"# CHAIN NUMBER %2d (SEQRES) :%9ld\n",s_check,m->pdbseqres[m->pdbseqreschain.end_chain[s_check]].chain_length);
				}
			fprintf(fg,"#######################################################\n");				
		
			of(fg);
			/*}*/
		}	
}

/***##***/
/* 0021 */
/***##***/
/*********************************************************************************************/
/* Write_Pdb_clean : write a new "clean" PDB file (old thing)				     */
/*********************************************************************************************/

void Write_Pdb_clean(pdbfile *m){
	long y06;
	FILE *f06;
	if(TEST_PDB=='T'){
		printf(" ecriture de ./Results/Klewnaos \n");
		f06=fopen("./Results/Klewnaos","a+");
		for(y06=0;y06<(m->NbAtome);y06++){
			fprintf(f06,"%3.0ld %3.0ld ",y06,m->pdbatomtype[y06].ATOM_serialnumber);
			fprintf(f06,"%4s ",m->pdbatomtype[y06].ATOM_name);
			fprintf(f06,"%4s ",m->pdbatomtype[y06].ATOM_residuesname);
			fprintf(f06,"%4ld ",m->pdbatomtype[y06].ATOM_residuesnumber);
			fprintf(f06,"%8.2f %8.2f %8.2f  ",m->pdbatomtype[y06].ATOM_CoordX,m->pdbatomtype[y06].ATOM_CoordY,m->pdbatomtype[y06].ATOM_CoordZ);
			fprintf(f06," %c \n",m->pdbatomtype[y06].ATOM_real);
			}
		of(f06);
		}
}


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0020 */
/***##***/
/*********************************************************************************************/
/* Zeroresarch : for hydrogen atoms							     */
/*********************************************************************************************/

short int Zeroresarch(pdbfile *m, const long pos){
	short int i14=0;
	if(CHECK_DBG=='T')printf("step 0020\n");
	m->pdbatomtype[pos].ATOM_real='X';
	while((m->pdbatomtype[pos].ATOM_name[i14])!='\n'){
		if(m->pdbatomtype[pos].ATOM_name[i14]=='H') {
		m->pdbatomtype[pos].ATOM_real='H';
		return(1);}						/*22/09/99*/
		if(m->pdbatomtype[pos].ATOM_name[i14]=='Q') {	/* beaucoup de QA...QZ mais je sais pas ce que c'est */
		m->pdbatomtype[pos].ATOM_real='X';
		return(1);}
									/*23/09/99*/
		if(m->pdbatomtype[pos].ATOM_name[i14]=='D') {	/* beaucoup de 1DD2, 2DD2, AD1 AD2 mais je sais pas ce que c'est */
		m->pdbatomtype[pos].ATOM_real='X';
		return(1);}
		if(m->pdbatomtype[pos].ATOM_name[i14]=='E') {	/* beaucoup de AE1, AE2 mais je sais pas ce que c'est */
		m->pdbatomtype[pos].ATOM_real='X';
		return(1);}
		i14++;
		if(i14>NB_M_LG)  return(0);		
		}
	return(0);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0019 */
/***##***/
/*********************************************************************************************/
/* Categoriz_Atom : check the real type of atoms     			                     */
/*********************************************************************************************/

void Categoriz_Atom(pdbfile *mole5){
	long i05;
	long y05;
	short int test;
	FILE *f05;
	if(CHECK_DBG=='T')printf("step 0019\n");
	
	if(Werboze=='T') printf("#E-# le travail sur les %ld atomes commence\n",mole5->NbAtome);
	
	for(i05=0;i05<mole5->NbAtome;i05++){
		
		/*printf("%ld\n",i05);*/
		
		y05=0;
		test=0;

			/************************************************/		
			/* on teste dans la premiere liste tout d'abord */
			/************************************************/		
						
		while((y05<NR_type)&&(test==0)){
			if(strcmp(R_type[y05],mole5->pdbatomtype[i05].ATOM_name)==0){
			test=1;	mole5->pdbatomtype[i05].ATOM_real=Trans_R_type[y05];}
			y05++;
			}

			/*******************************************/		
			/* on teste ensuite dans la seconde liste  */
			/*******************************************/		
			
			/*printf("x0 %ld test a %d pour %s\n",i05,test,mole5->pdbatomtype[i05].ATOM_name);*/
			
		if(test==0){    
				mole5->pdbatomtype[i05].ATOM_real='H';
				y05=0;
				while(y05<ND_type){
				
			/*	printf("HYDRO %ld test a %d pour %s | avec %ld %d checking against %s\n",i05,test,mole5->pdbatomtype[i05].ATOM_name,y05,ND_type,D_type[y05]);		
			*/	
				if(strcmp(D_type[y05],mole5->pdbatomtype[i05].ATOM_name)==0){
					test=1;	mole5->pdbatomtype[i05].ATOM_real=Trans_D_type[y05];}
				y05++;	
				}
			}
			
		/************************************************************/	
		/* si pas trouve peut-etre alors du a hydrogene mal declare */
		/*		ou a un autre type bizzaroide		    */	
		/************************************************************/	

		/*	printf("x1 %ld test a %d pour %s\n",i05,test,mole5->pdbatomtype[i05].ATOM_name);		*/

			if(test==0)test=Zeroresarch(mole5,i05);

		/*	printf("x2 %ld test a %d pour %s\n",i05,test,mole5->pdbatomtype[i05].ATOM_name);		*/
			
			/*******************************************/		
			/* sinon peut-etre alors du a un collage : */	
			/*******************************************/			
			
		if(test==0){ f05=fSurecrire("Results/clewnaos");
			     fprintf(f05,"NON trouve : %s\n",mole5->pdbatomtype[i05].ATOM_name);
			     of(f05);
				printf("NON trouve : %s\n",mole5->pdbatomtype[i05].ATOM_name);
			     mole5->pdbatomtype[i05].ATOM_real='U';}
		}
		if(Werboze=='T')printf("#E-# le travail sur les %ld atomes fini\n",mole5->NbAtome);		
}
	
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0018*/
/***##***/
/*********************************************************************************************/
/* Recapitul_01 : short summary of macromolecules 					     */
/*********************************************************************************************/

void Recapitul_01(pdbfile *m){
	FILE *f04;
	f04=fopen("Results/firstlook.txt","a+");
	     if(m->IsItCalphaOnly==1)
	     	fprintf(f04,"%4s is a protein with C alpha only\n",m->header);
	     else {
	     fprintf(f04,"%4s ",m->header);
	     if(m->IsItDNA==1) fprintf(f04," DNA found");
	     if(m->IsItProt==1){ fprintf(f04," with %6ld residues ",m->Nb_residues);
	    			 if(m->PB_AA!=0)    fprintf(f04," and %6ld unknown residues",m->PB_AA);
	     			 if(m->PB_Backbone==0)fprintf(f04," no backbone problems");
	      			                 else fprintf(f04," with %3ld backbone problems ",m->PB_Backbone);
	     			 if(m->PB_latChain==0)fprintf(f04," no side chain(s) problem(s) ");
				  	         else fprintf(f04," with %3ld side chain(s) problem(s) ",m->PB_latChain);
		 	       }
		fprintf(f04,"\n");
	     }
	of(f04);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0017 */
/***##***/
/*********************************************************************************************/
/* Test_NuclAc : do we have DNA in our nice file :-}					     */
/*********************************************************************************************/

short int Test_NuclAc(pdbfile *m){
	long z07,y07;
	for(y07=0;y07<(m->NbAtome);y07++){
		for(z07=0;z07<NB_MAX_NucA;z07++)
		if(strcmp(Designa_NuclAcid[z07],m->pdbatomtype[y07].ATOM_residuesname)==0)
			(m->Nb_AtNA)++;
	}
	if((m->Nb_AtNA)>0) return (1);
		else return (0);
}


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0016 */
/***##***/
/*********************************************************************************************/
/* Is_It_AA : type of residues and if it is complete 					     */
/*********************************************************************************************/

void Is_It_AA(pdbfile *m,const long numberOf_aa,const long pos_in_m){
	long i08;
	long tamp_08=pos_in_m;
	short int test_08=0;
	FILE *f_08;
	
	m->Complete_Res[m->Nb_residues]='Y';									/* Y : default (complete)*/

	for(i08=0;i08<Lg_AA[numberOf_aa];i08++){
		/*printf("%s %s numberOf_aa %ld %ld Nb_residues %ld\n",Prot_Min_AA[numberOf_aa][i08],m->pdbatomtype[tamp_08].ATOM_name,numberOf_aa,pos_in_m,m->Nb_residues);*/
		if((strcmp(Prot_Min_AA[numberOf_aa][i08],m->pdbatomtype[tamp_08].ATOM_name)!=0)){
			if(i08<4){	/* il n'y a meme pas le minimum de la chaine carbonee */
				m->Complete_Res[m->Nb_residues]='I';						/* I : incomplete */
				(m->PB_Backbone)++;
				f_08=fopen("Results/log.txt","a+");
				fprintf(f_08,"PB :Check 02: Backbone incomplete [%s] (%s) : |%s| |%s|  pos :%ld %ld %ld\
				(%ld)\n",m->name,m->pdbatomtype[pos_in_m].ATOM_residuesname,Prot_Min_AA[numberOf_aa][i08],m->pdbatomtype[tamp_08].ATOM_name,i08,m->Nb_residues,numberOf_aa,pos_in_m);
				of(f_08);
				printf("PB :Check 02: Backbone incomplete [%s] (%s) : |%s| |%s| pos : %ld %ld %ld\
				(%ld)\n",m->name,m->pdbatomtype[pos_in_m].ATOM_residuesname,Prot_Min_AA[numberOf_aa][i08],m->pdbatomtype[tamp_08].ATOM_name,i08,m->Nb_residues,numberOf_aa,pos_in_m);
				test_08=1;
				}
			else    {
				if (m->Complete_Res[m->Nb_residues]=='Y'){
					m->Complete_Res[m->Nb_residues]='N';				/* il manque une partie de la chaine laterale */
					(m->PB_latChain)++;
					}
			        }	
			}
		tamp_08++;
		}
	if(test_08==0) m->Nam_residues[m->Nb_residues]=AA_1_Letter[numberOf_aa];
	else 	       m->Nam_residues[m->Nb_residues]='X';							/* il y a eu un probleme */
	
	m->deb_residues[m->Nb_residues]=pos_in_m;			
	m->end_residues[m->Nb_residues]=(tamp_08-1);
	(m->Nb_residues)++;
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0015 */
/***##***/
/*********************************************************************************************/
/* Test_Prot : is it really a protein ?							     */
/*********************************************************************************************/

short int Test_Prot(pdbfile *m){
	long y07,i07;
/*	long last=-100;*/
	long nbaa=0;		/* nombre total d'acides amines de la proteine */
	
			/* pour voir si il ya  des champs mis comme acide amine ==>  proteine */
	
	(m->Nb_residues)=0;
	(m->PB_AA)=0;
	(m->PB_Backbone)=0;
	(m->PB_latChain)=0;   /*  pour remettre les compteurs a zero */
	for(y07=0;y07<(m->NbAtome);y07++){
		if(strcmp("CA",m->pdbatomtype[y07].ATOM_name)==0){			/* on cherche les carbones alpha pour determiner un CA */
			i07=0;
			while(i07<NbrAA){
				if(strcmp(AA_3_Letter[i07],m->pdbatomtype[y07].ATOM_residuesname)==0){
					nbaa++;
					(m->Composition_AA[i07])++;
/*TO SEE*/				if(MODELLER=='T') Modeller_AA(m,i07,(y07-1));
						/* as Modeller does not follow the same */
/* 0016 */					
					Is_It_AA(m,i07,(y07-1));
					i07=100;
					}
				i07++;
				}
			if(i07<100)	
				(m->PB_AA)++;
			}
		}
		
	if((double)(m->PB_AA)/(double)(m->Nb_residues+m->PB_AA)>MAX_PB){
		printf("on a %.2f de non - aa ou incomplet\n",100*((double)(m->PB_AA)/(double)((m->Nb_residues)+(m->PB_AA))));
		return(0);
	}
	else if(nbaa>0) return(1);
		else    return(0);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/


/***##***/
/* 0014 */
/***##***/
/*********************************************************************************************/
/* Verif_Mol :check the molecule(s) type(s) as I'm mainly concerned with proteins	     */
/*********************************************************************************************/

void Verif_Mol(pdbfile *mole4){

	FILE *faa;
	long y04;
	long cal=0;
	
	if(CHECK_DBG=='T')printf("step 0014\n");

	if(CHECK_DBG=='T'){
	for(y04=0;y04<(mole4->NbAtome);y04++){
		printf("%ld %ld ",y04,mole4->pdbatomtype[y04].ATOM_serialnumber);
		printf("AN:%s ",mole4->pdbatomtype[y04].ATOM_name);
		printf("RNA:%s ",mole4->pdbatomtype[y04].ATOM_residuesname);
		printf("RNB:%ld ",mole4->pdbatomtype[y04].ATOM_residuesnumber);
		printf("%8.2f %8.2f %8.2f\n",mole4->pdbatomtype[y04].ATOM_CoordX,mole4->pdbatomtype[y04].ATOM_CoordY,mole4->pdbatomtype[y04].ATOM_CoordZ);
		}
	}
	
	for(y04=0;y04<(mole4->NbAtome);y04++)
		if(strcmp(mole4->pdbatomtype[y04].ATOM_name,"CA")==0)
			cal++;

			/*********************************/
			/* checking of Calpha only files */
			/*********************************/
				
	if(((double)(cal)/(double)(mole4->NbAtome))>.5){
		printf("PB :Check 01: too many Calpha (%8.6lf) in PDB file [%s]\n",100*((double)(cal)/(double)(mole4->NbAtome)),mole4->name);
		faa=fopen("Results/log.txt","a+");
		fprintf(faa,"PB :Check 01: too many Calpha (%8.6lf) in PDB file [%s]\n",100*((double)(cal)/(double)(mole4->NbAtome)),mole4->name);
		of(faa);
		mole4->IsItCalphaOnly=1;
		}
	else {
/* 0015 */		
		(mole4->IsItProt)=Test_Prot(mole4);
/* 0017 */
		(mole4->IsItDNA)=Test_NuclAc(mole4);
	    }
/* 0018 */	    
	     Recapitul_01(mole4);
	     
}	
