/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	main_lek.c	(beta version 2007)				      */
/*	----------							      */
/*	main part of the software					      */
/*	all the different options are sequentially done			      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"
# include "../HEADER/init.h"
# include "../HEADER/definition_01.h"
# include "../HEADER/turn.h"
# include "../HEADER/sec_str_definition.h"
# include "../HEADER/Protein_Blocks.h"

int main(int argc, char *argv[]){
						/********/
	/*FILE *fg;*/				/* file */
	FILE *fpdb;		    		/* file */
						/********/	
	/*******************************/
	/* all the different options : */
	/* --------------------------- */
	/*******************************/
		
	char *options[Nb_Max_Options]={"-h","-Fichier_PDB","-No_Check","-Resolution","-ForProline","-ForGlycine","-v","-PBs",\
				       "-Turn","-WritePhiPsi","-AllPiBi","-Surf","-Dist","-Alpha","-DaDaa","-Pred","-PredFs",\
				       "-Psea","-Vsea","-Dssp","-Vssp","-Stride","-StridT","-Vtride","-S2x3","-Define","-Vefine",\
				       "-Pcurve","-Vcurve","-S2x5","-Rooman","-Fetrow","-Color","-Compo","-CompoS2","-Rama","-best","-backXYZ",\
				       "-Modeller","-Chain","-DbkPN","-SeqSWs","-ClassicCover", "-ExtendCover", "-RasmolPN", "-Cover5", "-RepetPN",\
				       "-PB_RMSd","-helix","-Sippl","-Promotif","-ProtNetwork","-Dbg","-OutPutPdb","-WorkTurnB","-WorkTurnBpdb",\
				       "-Writedef","-Dsspcont","-xtlsstr","-helanal","-RKstr","-Fodje","-CutPsiLoops","-DbName","-Molscript","-MolVideo","-MolMatTrans",\
				       "-LgFasta","-Search","-Cys","-Rec","-P2pdb","-DbT","-Lgcol","-DistCa","-Segno","-YesDB","-Kaksi","-nAc","-CysDSSP",\
				       "-WriteName","-PyMol","-Scwrl","-Scap","-Scatd","-Irecs","-Sccomp","-WritePdBbb","-WritePdBbbCb"};
	
	

	if (argc==0) printf("PB:Main 01 : no arguments \n");
	else {
	
		Decode_Options(argc,argv,options);		/*  option  0001b  */
		if(Werboze=='T') ban_deb(); 			/*  option  0001c  */	

		Nullify(&molecule);				/* structure  0001 */
		
		if((fpdb=fopen(nom_fichier,"r"))==NULL){
			if(strlen(nom_fichier)>0)
	           			printf("PB:Main 02 : the PDB file [%s] is not here\n",nom_fichier);
				}
			else{	
				/*fg=fSurecrire("Results/verification2.txt");fprintf(fg,"\nfichier %s est present ",nom_fichier);of(fg);*/
				file_options(nom_fichier);	/* output 0001e */
				
				if(Werboze=='T')printf("MAIN: Read_Pdb_File the PDB file [%s] is here\n",nom_fichier);
				Read_Pdb_File(fpdb,&molecule);	/* pdb_lecture 0002 */	

				if(Werboze=='T')printf("MAIN:  COD- Verif_Mole de %s\n",nom_fichier);						
				Verif_Mol(&molecule);		/* check 0014 */
			        

				/* les conditions sont  :  - resolution inferieure a 2.5 Angstroms
				   			   - une cristallo rayon X ou synchlotron
				   			   - il faut n'y avoir que des acides amines et complet */


			if((((molecule.resolution)<Resolution_autorisee)&&(molecule.WhichExp==type_experim)&&(molecule.IsItProt==1)\
				&&(molecule.IsItDNA==0)&&(molecule.IsItCalphaOnly==0))||(NO_CHECK=='T')){
	
				if(Werboze=='T')printf("#MAIN:  COD- Categoriz_Atom of %s\n",nom_fichier);				
					Categoriz_Atom(&molecule);	/* check 0019 */	

				if(Werboze=='T')printf("MAIN:  COD- Write_Pdb_clean of %s\n",nom_fichier);				
					Write_Pdb_clean(&molecule);	/* check 0021 */
			
				if(Werboze=='T')printf("MAIN:  COD- Nettoyage_Prot de %s\n",nom_fichier);					
					Nettoyage_Prot(&molecule);	/* 0022 en cours de test !!!!!*/
				}
				/*fg=fSurecrire("Results/verification2.txt");fprintf(fg,"%s ok fini\n",nom_fichier);of(fg);*/
				end_options();			/* output 0001f */
			
			}


	if(Werboze=='T')printf("MAIN:  End of work with PDB file [%s] \n",nom_fichier);								
/*NEXT		UltimOne(&molecule);*/
	}

	/*banana();	*/

	return (0);

}
