# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
void meanTvalcompt(pdbfile *m){

	long y06,y21, deb, fin,nbres;
	double sd;
	nbres=0;
	sd=0.0000000;
	
	for(y21=0;y21<((m->NB_chain)+1);y21++){
		deb=m->Pos_FirstRes[y21];
		fin=m->Pos_LastRes[y21]-1;

		for(y06=deb;y06<fin;y06++){
			m->meanTval+=m->pdbatomtype[((m->deb_residues[y06])+1)].ATOM_TemperatureFactor;
			nbres++;
			}
		}
	m->meanTval/=(double)nbres;
	
	for(y21=0;y21<((m->NB_chain)+1);y21++){
		deb=m->Pos_FirstRes[y21];
		fin=m->Pos_LastRes[y21]-1;

		for(y06=deb;y06<fin;y06++){
			sd+=(m->pdbatomtype[((m->deb_residues[y06])+1)].ATOM_TemperatureFactor-m->meanTval)*(m->pdbatomtype[((m->deb_residues[y06])+1)].ATOM_TemperatureFactor-m->meanTval);
			nbres++;
			}
		}
	m->meanTvalsd=sqrt(sd/(double)(nbres-1));
	
	
}	

/***##***/
/* 0022 */
/***##***/

/*********************************************************************************************/
/* 		procedure pour nettoyer au mieux le fichier de proteines 		     */
/*********************************************************************************************/

void Nettoyage_Prot(pdbfile *m){

	if(Writedefi=='T')WriteDef();	/* write the definitions of PBs, turns,	...*/

/* 0043 */		CheckName(m);
/* 0023 */		UnChainMyH(m);				/*        recherche du nombre de chaines        */
/* 0024 */  		Recherche_Alternative_Location(m);	/* 	recherche des alternatives locations	*/
/* 0015 */		Test_Prot(m);				/* pour anihiler les restrictions faites avant  */
/* 0023 */		UnChainMyH(m);
/* 00XX */		Check_AA(m);
	if(Werboze=='T') printf("la proteine %s est composee de %d chaines\n",m->name,(m->NB_chain)+1);


	if(/*(m->PB_Doublet==0)&&*/(ResearchPB=='T')){
/* 0026 */		Angles_Research(m);			/* 		calcul des angles 		*/
/* 0030*/		AssignBP(m);				/* 	assignation au bloc proteique		*/

/* ???	fg=fopen("Results/Proteine_Utilisees.txt","a+");
	fprintf(fg,"%s.Z\n",nom_fichier);
	fclose (fg);*/

/* 0036 */		if(ResearchTurn=='T') Turn(m);				/* Travail sur les turns */
/* 003XX*/		if(ResearchTurn2=='T') TurnClean(m);			/* Travail sur les turns */
	
			meanTvalcompt(m);
			

/* 0047 */		if(LECT_DSSP=='T')    		S2dssp(m);		/* structures secondaires */
			if(LECT_DSSP_cont=='T')    	S2dsspcont(m);		/* structures secondaires */
/* 0048 */		if(LECT_STRIDE=='T')  		S2stride(m);		/* structures secondaires */
/* 0046 */		if(LECT_SEA=='T')     		S2sea(m);		/* structures secondaires P-sea	*/
			if(LECT_DEFINE=='T') 	 	S2define(m);
			if(LECT_PCURVE=='T')   		S2pcurve(m);
			if(LECT_xtlsstr=='T')   	S2xtlsstr(m);
			if(Fodje=='T')   		S2FodjeAlK(m);
			if(SEGNO=='T')   		S2Segno(m);
			if(KAKSI=='T')   		S2Kaksi(m);
			
			if(Werboze=='T') printf("BACK_XYZ : %c\n",BACK_XYZ);
			if(BACK_XYZ=='T')     		back_XYZ(m);	/* 		Sortie XYZ	*/
			

			if(PROMOTIF=='T') 		Promotif_Read(m);
			
			if(NACESS=='T')			ReadNaxes(m);
			
			if(PRAPIA=='T') 		WriteFastDBank(m);
			if(PROTEIN_NETWORK=='T') 	Protein_Network(m);

			if(SEARCH_DIS=='T')   		DistanceLAT(m); 		/* Travail sur les distances */
		        if(HELIXES=='T')   		Helix_Axes(m); 		/* Travail sur les distances */
			/*DistRep(m);*/
			/*Kolocomparison();*/
			
			if(TEST_PDB=='T')		write_chain_pdb(m,"Clean",0);
			
/* 0033 */	     	WriteFast(m);				/* 		ecriture des resultats		*/
			if(MOLSCRIPT=='T')		Molscriptage(m);
			if(lg_SEARCH_PBserie>0)		SearchPBmotifs(m);
			if(CYS=='T') 			CYSsearch(m);
			if(REK=='T') 			rec(m);
			if(PII=='T') 			PIIpdb(m);
			if(DBT=='T') 			SimpleOut(m);
			if(DISTCA=='T')			Dist(m);
			if(PYMOL=='T')			pymol(m);
			if(SCWRL=='T')			SubCL(m);
			
			printf("end\n");
	}





























/*Nuz	long integrity=0;*/
/*	FILE *fg;*/
/*NUz	long suivi_res=0;*/	/* est-ce que les numeros de residus se suivent */
/*Nuz	long suivi_ato=0;*/	/*  est-ce que les numeros d'atomes se suivent  */
	

	
/*A REFAIRE			MouveAleXYZ(m,0.20); */

			
}	

