# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>



/******************************************************************************/
/*									      */
/* 			Allocation / Desallocation 			      */
/*	de vecteurs, matrices a 2 ou 3 D pour entiers et doubles	      */
/*									      */
/******************************************************************************/


short int***  AllocMemoireShIntIntInt(short int dimension1,short int dimension2,short int dimension3){	
	short int*** matrice;
	short int i_i,i_2;
	matrice=(short int***) calloc (dimension1,sizeof (short int**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(short int**)calloc(dimension2,sizeof(short int*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(short int*)calloc(dimension3,sizeof(short int));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

/**********************   int matrice 3D     *******************************/

void DesAllocMemoireShIntIntInt(short int ***matrice,short int dimension1,short int dimension2){	
	short int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}


/******************************************************************************/
/* 			Allocation pour entier	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/


int*  AllocMemoireInt(int dimension1){	
	int *vect;
	if((vect=(int*)calloc((dimension1),sizeof(int)))==NULL)		
		printf("Alloc_01 Pb d'allocation du vecteur  \n");
	return(vect);}

/**********************   Entier matrice 2D     *******************************/

int**  AllocMemoireIntInt(int dimension1,int dimension2){	
	int **matrice;
	int i_i;
	matrice=(int **) calloc (dimension1,sizeof (int*));
	assert (matrice != NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(int*)calloc(dimension2,sizeof(int));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;}

/******************************************************************************/
/* 			Allocation pour double	 			      */
/******************************************************************************/

/**********************   Double matrice 2D     *******************************/

double**  AllocMemoireFlFl(int dimension1,int dimension2){	
	double **matrice;
	int i_i;
	matrice=(double **) calloc (dimension1,sizeof (double*));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double*)calloc(dimension2,sizeof(double));
		assert(matrice[i_i]!=NULL);
	}
	return matrice;
}

/**********************   Double matrice 3D     *******************************/

double***  AllocMemoireFlFlFl(int dimension1,int dimension2,int dimension3){	
	double*** matrice;
	int i_i,i_2;
	matrice=(double***) calloc (dimension1,sizeof (double**));
	assert(matrice!= NULL );
	for (i_i=0;i_i<dimension1;i_i++){	
		matrice[i_i]=(double**)calloc(dimension2,sizeof(double*));
		assert(matrice[i_i]!=NULL);
		for (i_2=0;i_2<dimension2;i_2++){
			matrice[i_i][i_2]=(double*)calloc(dimension3,sizeof(double));
			assert(matrice[i_i][i_2]!=NULL);
		}
	}
	return matrice;
}

/******************************************************************************/
/* 		     Desallocation pour entier	 			      */
/******************************************************************************/

/**********************   Entier vecteur 1D     *******************************/

void DesallocMemoireInt(int *xc){	
	free(xc);}

/**********************   Entier matrice 2D     *******************************/

void DesallocMemoireIntInt(int **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free (matrice);}

/******************************************************************************/
/* 		     Desallocation pour double	 			      */
/******************************************************************************/

/**********************   Double matrice 2D     *******************************/

void DesallocMemoireFlFl(double **matrice,int dimension1){	
	int i2;
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/**********************   Double matrice 3D     *******************************/

void DesallocMemoireFlFlFl(double ***matrice,int dimension1, int dimension2){	
	int i2,i3;
	for(i2=0;i2<dimension1;i2++)
		for(i3=0;i3<dimension2;i3++)
			free(matrice[i2][i3]);
	for(i2=0;i2<dimension1;free(matrice[i2++]));
	free(matrice);}

/*     pour la desallocation on prend la meme chose mais on va a l'envers     */
/******************************************************************************/
