/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	options.c	(beta version 2003)				      */
/*	----------							      */
/*	all the different options that could be done			      */
/*	the small help file is here too					      */
/*	last modification : 31-10-2003					      */
/******************************************************************************/

# include "../HEADER/basic_h.h" 


# include "../HEADER/lib_define.h"
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/*********/
/* 0001b */
/************************************************************************************************************************************/
/*	Decode_Options: treatment of all the options 				 						    */
/************************************************************************************************************************************/

void Decode_Options(int argc, char *argv[],char *options[])
	{
	int i,t;
	int j=1;
	
	if(argc>1) 
	 {
	 while(j<argc)
	  	{
		i=0;
		while(strcmp(argv[j],options[i])) 
        	     {
               	     if(i>Nb_Max_Options)
			{i=Nb_Max_Options;break;}
			i++;	
        	     }
	 
	switch (i)
		     {										     /*******************************/
		     case (0): help(options); j++; break;					     /*            aide             */
		     case (1): strcpy(nom_fichier,argv[(j+1)]);j=j+2; break;			     /*        input PDB file       */
		     case (2): NO_CHECK='T'; j++; break;					     /*       no  X-RAY check       */
		     case (3): Resolution_autorisee=atof(argv[(j+1)]); j+=2; break;		     /*    resolution minimale      */
		     case (4): WORK_PROLINE='T'; j++; break;					     /*  Travail sur les Prolines   */
  	             case (5): WORK_GLYCINE='T'; j++; break;					     /*  Travail sur les Glycines   */
		     case (6): Werboze='T'; j++; break;					             /*    pour avoir du blabla     */
		     case (7): ResearchPB='T'; j++; break;					     /*    pour recoder en PBs      */
		     case (8): ResearchTurn='T'; j++; break;					     /*    recherche des turns      */
		     case (9): EcrDiedres='T'; j++; break;			  		     /*fichier de sortie sur Phi/Psi*/
		    case (10): EveryPB='T'; j++; break;					     	     /*  pour recupere tous les PBs */
		    case (11): SEARCH_CAV='T'; j++; break;					     /*             surface         */
		    case (12): SEARCH_DIS='T'; j++; break;					     /*       distance minimale     */
		    case (13): SEARCH_ALP='T'; j++; break;					     /*       angles alpha    	    */
		    case (14): DistAA[0]=argv[(j+1)][0];DistAA[1]=argv[(j+2)][0]; j=j+3; 
		    									break;	     /*     distance entre 2 aa     */
		    case (15): PRED_TYPE='T'; j++; break;					     /*    prediction bayesienne    */	
		    case (16): PRED_TYPE='X'; j++; break;					     /*    avec Family Sequences    */
		    case (17): LECT_SEA='T';  j++; break;					     /*    	pour P-SEA    	    */
		    case (18): LECT_SEA='T';  V_SEA='T';  j++; break;				     /*    	pour P-SEA    	    */
		    case (19): LECT_DSSP='T'; j++; break;					     /*    	pour dssp    	    */
		    case (20): LECT_DSSP='T'; V_DSSP='T'; j++; break;				     /*    	pour dssp    	    */
		    case (21): LECT_STRIDE='T'; j++; break;					     /*    	pour Stride    	    */
		    case (22): LECT_STRIDE='T'; LECT_STRIDEplus='T'; j++; break;		     /*    	pour Stride    	    */
		    case (23): V_STRIDE='T'; LECT_STRIDE='T'; j++; break;			     /*    	pour Stride    	    */
		    case (24): V_S2='T'; LECT_SEA='T'; LECT_DSSP='T'; LECT_STRIDE='T'; j++; break;   /*     pour P-SEA/dssp/Stride  */
		    case (25): LECT_DEFINE='T';  j++; break;					     /*    	pour Define    	    */
		    case (26): LECT_DEFINE='T';  V_DEFINE='T';  j++; break;			     /*    	pour Define    	    */
		    case (27): LECT_PCURVE='T';  j++; break;					     /*    	pour PCURVE	    */
		    case (28): LECT_PCURVE='T';  V_PCURVE='T';  j++; break;			     /* 	pour PCURVE	    */
		    case (29): V_S25='T'; LECT_SEA='T'; LECT_DSSP='T'; LECT_STRIDE='T'; 	     /*     pour P-SEA/dssp/Stride  */
			       LECT_DEFINE='T'; LECT_PCURVE='T'; j++;  break;  			     /*    et     Define/PCURVE     */
		    case (30): ROOM='T';  j++; break;					    	     /*    	pour Rooman	    */	
		    case (31): FETROW='T';  strcpy(nom_fetr,argv[(j+1)]);j=j+2; break;		     /*    	pour Fetrow	    */	  
		    case (32): COLOR='T';  j++; break;					             /*   pour coloriser par BP     */
		    case (33): COMPO='T';  j++; break;					             /*   pour frequence en AA      */
		    case (34): COMPO2='T'; LECT_DSSP='T'; j++; break;   	                     /*   pour frequence en S2      */
	 	    case (35): RAMA='T'; j++; break;   	         			             /*   pour Phi-Psi (Ramacha.)   */
		    case (36): WORK_BEST_PB='T'; j++; break;   	         			     /*   pour bedst PB et angles   */
		    case (37): BACK_XYZ='T'; j++; break;   	         			     /*   pour XYZ vers Sippl rms   */		    
		    case (38): MODELLER='T'; j++; break;   	         			     /*     a faire pour Modeller   */		    		    
		    case (39): CHAIN=(argv[(j+1)][0]); j=j+2; break;				     /*   pour  une seule chaine    */
		    case (40): PRAPIA='T'; j++; break;  					     /*      recherche PN et DBk    */ 					
		    case (41): WRITE_DBank_AMTRIX='T';j++; break;  				     /*      ecrire sequence SW     */ 
		    case (42): RECOV_CLASSIC='T';j++; break;   				             /*          covering 72        */
		    case (43): RECOV_PAPIA='T';j++; break;   					     /*      covering 190 PAPIA     */
                    case (44): RSMOL_HIR='T';j++; break;   					     /*      sortie rasmol PN       */
                    case (45): BPin='9';j++; break;   						     /*   PN/SW calcul 9 ou 5 cove  */
                    case (46): REPET='T';j++; break; 						     /* prendre m=alp, d=be, et re  */
		    case (47): PB_RMSD='T';j++; break; 					             /* pour superposer les PBs pr  */
  		    case (48): HELIXES='T';j++; break; 					    	     /*   pour les axes des helices */
  		    case (49): SIPPL='T';j++; break; 					     	     /*   pour superposition Sippl  */
  		    case (50): PROMOTIF='T';j++; break; 					     /*    pour traiter PROMOTIF    */		    
		    case (51): PROTEIN_NETWORK='T';j++; break; 				             /*    pour le protein network  */		    
		    case (52): CHECK_DBG='T';j++; break; 				             /*         pour debugage       */		    
		    case (53): TEST_PDB='T';j++; break; 				             /*    pour sortir PDB propre   */		    
		    case (54): ResearchTurn2='T'; j++; break;					     /*  recherche des turns(v2)    */
		    case (55): PDBTurn2='T'; ResearchTurn2='T'; j++; break;			     /*  recherche des turns(v2)    */
		    case (56): Writedefi='T'; j++; break;			     		     /*   Write definition used     */
		    case (57): LECT_DSSP_cont='T'; j++; break;					     /*    pour dssp cont   	    */		    
		    case (58): LECT_xtlsstr='T'; j++; break;					     /*    	pour xtllstr  	    */	
	    	    case (59): HELANAL='T'; LECT_DSSP='T'; j++; break;				     /*    	pour helanal  	    */	
		    case (60): RKstr='T'; LECT_DSSP='T'; j++; break;				     /*    decoupeur feuillet beta  */
		    case (61): Fodje='T';  j++; break;				     		     /*       travail helices       */
		    case (62): CutPsiLoops='T'; PROMOTIF='T'; j++; break;			     /*       psi-loops en pdb      */
		    case (63): PRAPIA='T'; DBNAME='T'; strcpy(nom_db,argv[(j+1)]); j+=2; break; 	     	     /*       pour le nom de DBs    */
		    case (64): MOLSCRIPT='T';  j++; break;				     	     /*  sortie script molscript    */		    
		    case (65): MOLVID='T';  j++; break;				     	    	     /*  sortie script mols. Vid    */		    
		    case (66): MolTrans='T'; strcpy(rot3Dmolscr,argv[(j+1)]); j+=2; j++; break;	     /*  pour script molscriptTrans */		    		    
		    case (67): LGFASTA=atoi(argv[(j+1)]);  j+=2; break;				     /*  longeur de la sortie fasta */		    		    
		    case (68): lg_SEARCH_PBserie=atoi(argv[(j+1)]);
		    		for(t=0;t<lg_SEARCH_PBserie;t++)SEARCH_PBserie[t]=argv[(j+2)][t];  
				SEARCH_PBserie[t]='\n';j+=3; break;			     	     /*  longeur de la sortie fasta */		    		    
		    case (69): CYS='T'; j++; break;	     					     /*        pour Cysteine        */		    		    
		    case (70): REK='T'; j++; break;	     					     /*        pour recon. sp.      */		    		    
		    case (71): PII='T'; j++; break;	     					     /*        pour PolyII pdb      */		    		    
		    case (72): DBT='T'; j++; break;	     					     /*        pour sortie DBK      */		    		    
		    case (73): NBCOL=atoi(argv[(j+1)]);  j+=2; break;				     /*        pour colum lgth      */		    		    
		    case (74): DISTCA='T'; j++; break;	     					     /*              */		    		    
		    case (75): SEGNO='T'; j++; break;	     					     /*              */		    		    
		    case (76): NODB='F'; j++; break;	     					     /*              */		    		    
		    case (77): KAKSI='T'; j++; break;	     					     /*              */		    		    		    
		    case (78): NACESS='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (79): CYSDSSP='T'; j++; break;	     					     /*              */		    		    		    		    		   
		    case (80): NOMPDB='T'; strcpy(nom_PDB,argv[(j+1)]); j+=2; j++; break;     					     /*              */		    		    		    		    		   		    
		    case (81): PYMOL='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (82): SCWRL='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (83): SCAP='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (84): SCATD='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (85): IRECS='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (86): SCCOMP='T'; j++; break;	     					     /*              */		    		    		    		    
		    case (87): TEST_PDB='T';PDBbb='T';j++; break; 				             /*    pour sortir PDB bb propre   */		    
		    case (88): TEST_PDB='T';PDBbb='B';j++; break; 				             /*    pour sortir PDB bb+cb propre   */		    
		    
		    default:    printf("PB:Decode_Options 01 : unknown option [%s]\n",argv[j]); j++; /*    default : the option is  */
		    		break;	     							     /*            unknown          */
		    										     /*******************************/
		     }
		}
	 }		

}	

/*********/
/* 0001c */
/********************************************************************************************************************/
/*	ban_deb() : read and write the file in 	"DATA/ban.txt"	 						    */
/********************************************************************************************************************/

void ban_deb(){
					/****************/
	FILE *fban;			/*     file     */
	char buffer_ban[Lg_buffer];	/* ligne buffer */
					/****************/	
	fban=flire("CODE/DATA/ban.txt");
	while(fgets(buffer_ban,Lg_buffer,fban)!=NULL)
		printf("%s",buffer_ban);
	of(fban);
}

/*********/
/* 0001d */
/********************************************************************************************************************/
/* void help(char *options[]) : Short explanaition of all the options						    */
/********************************************************************************************************************/

void help(char *options[]){
					/***********************/
	int i;				/*      to count       */
					/* the explanaitions : */
					/***********************/
					
	char *expoption[Nb_Max_Options]={"\tthis help !!",\
			   	         "give the PDB file name",\
			   		 "Ne pas regarder la resolution, mat. exp.,...",\
			   	         "resolution minimale demande",\
			   		 "travail sur la proline",\
			                 "travail sur la glycine",\
			   		 "\tmode Verbose",\
					 "\tProtein Blocks (16)",\
					 "\trResearch of turns [obsolete] => use classical definition",\
					 "pour un fichier de sortie phi/psi/omega",\
					 "pour recuperer un fichier PDB pour chaque bloc",\
					 "\tpour avoir une vision de la surface de la proteine",\
					 "\tpour une carte de distance",\
					 "pour les angles alpha par PBs",\
					 "pour une distance entre 2 types d'aa",\
					 "\tpour prediction bayesienne de base",\
					 "pour prediction bayesienne avec Familles Sequentielles",\
					 "\tpour les structures secondaires (P-SEA)",\
					 "\tpour verboze les structures secondaires (P-SEA)",\
					 "\tpour les structures secondaires (DSSP)",\
					 "\tpour verboze les structures secondaires (DSSP)",\
					 "pour les structures secondaires (STRIDE)",\
					 "pour les structures secondaires (STRIDE) turn detail",\
					 "pour verboze les structures secondaires (STRIDE)",\
					 "\tpour les structures secondaires (P-SEA+DSSP+STRIDE)",\
					 "pour les structures secondaires (DEFINE)",\
					 "pour verboze les structures secondaires (DEFINE)",\
					 "pour les structures secondaires (P-CURVE)",\
					 "pour verboze les structures secondaires (P-CURVE)",\
					 "\tpour les structures secondaires (5 types)",\
					 "Rooman et Wodak (1990)",\
					 "Fetrow (1997)",\
					 "fichier couleur sour rasmol",\
					 "frequence(AA)",\
					 "frequence(S2)",\
					 "\tPhi-Psi pour Ramachandran",\
					 "\tpour best PB",\
					 "pour avoir un fichier XYZ",\
					 "afaire (Modeller lecture)",\
					 "chaine X (mettre -Chain X)",\
					 "Databank and Protein Network",\
					 "Ecriture des sequences associes aux SWs",\
					 "covering classique (72 SWs)",\
					 "covering tendu (190 SWs issus de PAPIA aug-2001)",\
					 "sortie RASMOL pour le protein network",\
					 "passage d'une couverture 9 aa = 1 SW a 5 aa = 1 SW",\
					 "alpha = m et beta = d, rete = coil pour Protein Network",\
					 "pour superposer les PBs sur la proteine",\
					 "pour les axes des helices",\
					 "pour superposition experim",\
					 "Promotif",\
					 "for protein network methods",\
					 "\tfor debugging purpose",\
					 "for Clean PDB :-}",\
					 "for Turn with classical definition",\
					 "the same with PDB file output",\
					 "Write definitions used",\
					 "DSSPcont (interet = ?)",\
					 "for xtlsstr",\
					 "for helanal (w/ DSSP)",\
					 "for Rachel Karchin script (beta-sheets w/ DSSP)",\
					 "for Fodje",\
					 "for Psi-Loops pdb",\
					 "nom de la DB",\
					 "small molscript script",\
					 "pour molscript lancement video",\
					 "matrice de rotation pour molscript",\
					 "length of fasta line for output files (default = 40)",\
					 "give length and motif",\
					 "\tCysteine / Cystine ",\
					 "\tfor recons. spec.",\
					 "for writing PII pdb (need xtlsstr)",
					 "\tfor summary of PDB files (.rsy)",\
					 "for minimal length of PDB file column",\
					 "for distance Calpha-Calpha",\
					 "for Segno",\
					 "for the use of Db/",\
					 "for Kaksi",\
					 "\tfor Nacess",\
					 "for Cys by DSSP",\
					 "for output PDB name",\
					 "Pymol",\
					 "scwrl",\
					 "\tscap",\
					 "scatd",\
					 "irecs",\
					 "sscomp",\
					 "PDB only backbone",\
					 "PDB backbone w/Cbeta"};
					 
	 
					 
					
	ban_deb();										/* 0001c */
	for(i=0;i<Nb_Max_Options;i++)
		printf("option %2d %s\t%s\n",i+1,options[i],expoption[i]);

}


void banana(){
					/*******************/
	FILE *fban;			/*       file      */
	char buffer_ban[Lg_buffer];	/*  ligne buffer   */
	int num;			/* number of items */
	int chosen;			/*	random     */
	char test='F';			/*	test	   */
					/*******************/

	srand48(time(NULL));

	fban=flire("CODE/DATA/text.txt");
	fscanf(fban,"%d",&num);
	chosen=(drand48()*(int)num)+1;
	/*printf("num : |%d||%d|\n",num,chosen);*/
	if(chosen<1) chosen =1; 
	if((chosen)>(num))chosen=num; 
	while(fgets(buffer_ban,Lg_buffer,fban)!=NULL){
		/*printf("==>%s",buffer_ban);*/
		if(buffer_ban[0]=='#')  test='F';
		if (test=='T') printf("%s",buffer_ban);
		/*printf("==>%d\n",atoi(buffer_ban));*/
		if(atoi(buffer_ban)==chosen){
			/*printf("=====>%d %d\n",atoi(buffer_ban),chosen);*/
			test='T';
			}	
		clean_str(buffer_ban,Lg_buffer);
		}
	of(fban);
}

