/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	pdb_lecture.c	(version 2004)				      	      */
/*	-------------							      */
/*	read each ligne of the PDB files and treat them			      */
/*	version : 1.04						              */
/*	last modification : 02-08-2004					      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
/*		la partie simple de lecture et de mise brute dans les champs		     */
/*				  de 0001 a 0013					     */
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##*****/
/* 00013e */
/***##*****/
/*********************************************************************************************/
/* 	aatreatment :  classification of residues				     	     */
/*********************************************************************************************/

void aatreatment(short int *y_19, char tamp_19[4], short int deb,char* s, pdbfile *m,\
			char *step,char *statet){

	FILE *faa;

	for((*y_19)=0;(*y_19)<3;tamp_19[(*y_19)]=s[deb+(*y_19)],(*y_19)++);
		tamp_19[(*y_19)]='\0';
		if(CHECK_DBG=='T')
			printf("step %s ==> [%s]\n",step,tamp_19);
		(*y_19)=0;	
		while((strcmp(AA_3_Letter[(*y_19)],tamp_19)!=0)&&((*y_19)<19)){
			(*y_19)++;
			/*printf("%d\n",(*y_19));*/
			}
		if(CHECK_DBG=='T') printf("step %s ==> : amino acid of type %d (%s)\n",step,(*y_19),tamp_19);
		if((AAthreeToone(tamp_19)==20)){
			printf("PB :Read_Pdb_File %s : amino acid [%s]\n",statet,tamp_19);
			faa=fopen("Results/unknown_amino_acid.txt","a+");
			fprintf(faa,"%s",m->header);
			fprintf(faa,"PB :Read_Pdb_File %s : amino acid [%s]\n",statet,tamp_19);
			of(faa);
			}

}

/***##*****/
/* 00013d */
/***##*****/
/*********************************************************************************************/
/* 	Work_Turn :  the turns defined in the PDB file				     	     */
/*********************************************************************************************/
/*
         10        20        30        40        50        60        70        80
|         |         |         |         |         |         |         |         |          
012345678901234567890123456789012345678901234567890123456789012345678901234567890

TURN     5  T5 ASN   247  ALA   250                                     1BGT 125
TURN     5  T5 ASN   247  ALA   250                                     1BGU 132
TURN     5  T5 ASN    27  GLY    30     TYPE I                                  
TURN     5 T5  ASN    46  GLY    49     TYPE I                          135L  69
TURN     5 T5  ASN    75  HIS    78     TYPE I                          133L  79
TURN     5 T5  ASP   102  GLY   105     TYPE III                        134L  79
TURN     5  T5 ASP    33  ILE    36     DA DISTANCE 3.29 A              1AGM 230
TURN     5  T5 ASP    73  SER    76     TYPE I                          1ACF 119
TURN     5 T5A TYR A  94  VAL A  97                                     1BBP 175
TURN     5  T5 CYS A  95  THR A  98     EXTENSION HELIX C               1ATH 319
TURN     5  T5 GLU A  71  GLY A  74     TYPE I                          1BNC 198
TURN     1 T1  ASP    20  GLY    23                                     128L 113
TURN     1  T1 ASP    20  GLY    23                                     129L 105

To be done : looking at the TYPE 
	     However it is so badly written */

void Work_Turn(char* s, pdbfile *m){
	/*FILE *fx01;*/
	short int y_19,w_19;
	char tamp_19[4];
	char tamp_20[6];
	short int deb;
	char chainis;
	int nb=0;

	/*fx01=fopen("res_turn.txt","a+");
	fprintf(fx01,"%s",s);
	of(fx01);
	*/
	if(s[19]==' ')chainis='A';
	else chainis=s[19];

	deb=15;
	while(nb<2){
		if(s[deb]!=' '){
		
			aatreatment(&y_19,tamp_19,deb,s,m,"0013d","09");		/* 00013e */
			
			/*for(y_19=0;y_19<3;tamp_19[y_19]=s[deb+y_19],y_19++);
			tamp_19[y_19]='\0';
			y_19=0;
			while((strcmp(AA_3_Letter[y_19],tamp_19)!=0)&&(y_19<20))
				y_19++;
			
			if(y_19>=20){
				printf("PB :Read_Pdb_File 09 : amino acid [%s]\n",tamp_19);
				fx01=fopen("Results/unknown_turn_amino_acid.txt","a+");
				fprintf(fx01,"PB :Read_Pdb_File 09 : amino acid [%s]\n",tamp_19);
				of(fx01);
				}
			else	{
				*/
				for(w_19=0;w_19<4;tamp_20[w_19]=s[deb+w_19+5],w_19++);tamp_20[w_19]='\0';
					
				if(nb==0) {
					m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].begin_turn=atoi(tamp_20);
					m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].begin_turn_res=y_19;
					}
				else  	{
					m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].end_turn=atoi(tamp_20);
					m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].end_turn_res=y_19;
					}
				m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].chain=chainis;
				/*}*/
			}
		nb++;
		deb+=11;		
	}
	/*
	To be done 
	
	for(w_19=0;w_19<2;tamp_20[w_19]=s[38+w_19],w_19++);tamp_20[w_19]='\0';
	
	m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].type_turn=atoi(tamp_20);
	
	if(((m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].type_turn)>1)&&((m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].type_turn)<(-1))){
		
		fx01=fopen("Results/notclassical_turn.txt","a+");
		fprintf(fx01,"Read_Pdb_File  : type %d for %s\n",m->pdbturn.pdbturnpos[m->pdbturn.nb_turn].type_turn,m->name);
		of(fx01);
		}
	*/
	if(nb==2) m->pdbturn.nb_turn++;	/* to change */
}


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/*
         10        20        30        40        50        60        70        80
|         |         |         |         |         |         |         |         |          
012345678901234567890123456789012345678901234567890123456789012345678901234567890

SHEET    2   A 3 ASN A  34  ILE A  39  1  O  ASN A  34   N  ILE A   4           
SHEET    1   A 5 PHE A  14  LEU A  17  0                                        
SHEET    4   A 5 GLU A 164  PHE A 171 -1  N  CYS A 170   O  VAL A 116           
*/

/***##*****/
/* 00013d */
/***##*****/
/*********************************************************************************************/
/* 	Work_Sheet :  the strand defined in the PDB file				     */
/*********************************************************************************************/

void Work_Sheet(char* s, pdbfile *m){
	FILE *fx01;
	short int y_19,w_19;
	char tamp_19[4];
	char tamp_20[6];
	short int deb;
	char chainis;
	/*int numchain=0;*/
	int nb=0;
	
	if(s[21]==' ')chainis='A';
	else chainis=s[21];

	deb=17;
	while(nb<2){
		if(s[deb]!=' '){

			aatreatment(&y_19,tamp_19,deb,s,m,"0013d","08");			/* 00013e */
			
			/*for(y_19=0;y_19<3;tamp_19[y_19]=s[deb+y_19],y_19++);
			tamp_19[y_19]='\0';
			y_19=0;
			while((strcmp(AA_3_Letter[y_19],tamp_19)!=0)&&(y_19<20))
				y_19++;
			
			if(y_19>=20){
				printf("PB :Read_Pdb_File 08 : amino acid [%s]\n",tamp_19);
				fx01=fopen("Results/unknown_beta_amino_acid.txt","a+");
				fprintf(fx01,"PB :Read_Pdb_File 08 : amino acid [%s]\n",tamp_19);
				of(fx01);
				}
			else	{
				*/
				for(w_19=0;w_19<4;tamp_20[w_19]=s[deb+w_19+5],w_19++);tamp_20[w_19]='\0';
					
				if(nb==0) {
					m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].begin_beta=atoi(tamp_20);
					m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].begin_beta_res=y_19;
					}
				else  	{
					m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].end_beta=atoi(tamp_20);
					m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].end_beta_res=y_19;
					}
				m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].chain=chainis;
				/*}*/	
			}
		nb++;
		deb+=11;		
	}
	for(w_19=0;w_19<2;tamp_20[w_19]=s[38+w_19],w_19++);tamp_20[w_19]='\0';
	
	m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].type_beta=atoi(tamp_20);
	
	if(((m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].type_beta)>1)&&((m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].type_beta)<(-1))){
		/* not parralel or anti parallel */
		fx01=fopen("Results/notclassical_beta.txt","a+");
		fprintf(fx01,"Read_Pdb_File  : type %d for %s\n",m->pdbbeta.pdbbetapos[m->pdbbeta.nb_beta].type_beta,m->name);
		of(fx01);
		}
	if(nb==2) m->pdbbeta.nb_beta++;/* to change */
}


/***##*****/
/* 00013c */
/***##*****/
/*********************************************************************************************/
/* 	Work_helix :  the helix defined in the PDB file					     */
/*********************************************************************************************/

/*
         10        20        30        40        50        60        70        80
|         |         |         |         |         |         |         |         |          
012345678901234567890123456789012345678901234567890123456789012345678901234567890
HELIX    8   8 MET A  105  SER A  112  1                                   8    */
/*********************************************************************************************/

void Work_Helix(char* s, pdbfile *m){
	FILE *fx01;
	short int y_19,w_19;
	char tamp_19[4];
	char tamp_20[6];
	short int deb;
	char chainis;
	/*int numchain=0;*/
	int nb=0;

	if(CHECK_DBG=='T') printf("step 0013c\n");	

	if(s[19]==' ')chainis='A';
	else chainis=s[19];
	
	deb=15;
	while(nb<2){
	
		if(CHECK_DBG=='T') printf("step 0013c [%d]\n", nb);	
		
		if(s[deb]!=' '){

			aatreatment(&y_19,tamp_19,deb,s,m,"0013c","07");			/* 00013e */
	
			/*for(y_19=0;y_19<3;tamp_19[y_19]=s[deb+y_19],y_19++);
			tamp_19[y_19]='\0';
			y_19=0;
	
			if(CHECK_DBG=='T') printf("step 0013c [%s]\n", tamp_19);	
	
			while((strcmp(AA_3_Letter[y_19],tamp_19)!=0)&&(y_19<20))
				y_19++;
			
			if(y_19>=20){
				printf("PB :Read_Pdb_File 07 : amino acid [%s]\n",tamp_19);
				fx01=fopen("Results/unknown_helix_amino_acid.txt","a+");
				fprintf(fx01,"PB :Read_Pdb_File 07 : amino acid [%s]\n",tamp_19);
				of(fx01);
				}
			else	{
			*/	
				for(w_19=0;w_19<4;tamp_20[w_19]=s[deb+w_19+7],w_19++);tamp_20[w_19]='\0';
					
				if(nb==0) {
					m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].begin_helix=atoi(tamp_20);
					m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].begin_helix_res=y_19;
					
					}
				else  	{
					m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].end_helix=atoi(tamp_20);
					m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].end_helix_res=y_19;
					}
				m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].chain=chainis;
				/*}*/	
			}
		nb++;
		deb+=12;		
	}
	for(w_19=0;w_19<2;tamp_20[w_19]=s[38+w_19],w_19++);tamp_20[w_19]='\0';
	
	m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].type_helix=atoi(tamp_20);
	
	if(((m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].type_helix)!=1)&&((m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].type_helix)!=5)){
		/* not alpha or 3.10 helix */
		fx01=fopen("Results/notclassical_helix.txt","a+");
		fprintf(fx01,"Read_Pdb_File  : type %d for %s\n",m->pdbhelix.pdbhelixpos[m->pdbhelix.nb_helix].type_helix,m->name);
		of(fx01);
		}
	
	if(nb==2){/* to change */
		if((m->pdbhelix.nb_helix+1)<NB_MAX_helix){
					m->pdbhelix.nb_helix++;
					}
				else  {
					printf("PB :Read_Pdb_File 13: too many helix in HELIX (%d) [%d]\n",m->pdbhelix.nb_helix,NB_MAX_helix);
					fx01=fopen("Results/log.txt","a+");
					fprintf(fx01,"PB :Read_Pdb_File 13: too many helix in HELIX (%d) [%d]\n",m->pdbhelix.nb_helix,NB_MAX_helix);
					of(fx01);
				}	
	}
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##****/
/* 00013b*/
/***##****/
/*********************************************************************************************/
/* 	Work_Seq : reading the SEQRES 							     */
/*********************************************************************************************/

/*
 example of SEQRES :
   -------------------

         10        20        30        40        50        60        70        80
|         |         |         |         |         |         |         |         |          
012345678901234567890123456789012345678901234567890123456789012345678901234567890
SEQRES  10 F  326  ALA ALA ALA GLY LEU LEU THR TYR PRO PRO LEU MET ALA           */
/*********************************************************************************************/

void Work_Seq(char* s, pdbfile *m){
	FILE *fx01;
	short int y_19;
	char tamp_19[4];
	char tamp_20[6];
	short int deb;
	char chainis;
	int numchain=0;
	int nb=0;
	deb=19;
	tamp_19[3]='\0';
	
	if(s[11]==' ')chainis='A';
	else chainis=s[11];
	numchain=chainis-(int)'A';
	
	if(CHECK_DBG=='T') printf("step 0013b\n");
	
	for(y_19=0;y_19<6;tamp_20[y_19]=s[12+y_19],y_19++);
	tamp_20[5]='\0';
	if(CHECK_DBG=='T')
		printf("|%c|%c| %d %s\n",s[11],chainis,atoi(tamp_20),tamp_20);
	
	while(nb<13){
		if(s[deb]!=' '){

			aatreatment(&y_19,tamp_19,deb,s,m,"0013b","06");				/* 00013e */
		
			if(CHECK_DBG=='T')
				printf("step 0013b ==> |%s| [%d|%d]\n",tamp_19,AAthreeToone(tamp_19),y_19);
			if(m->pdbseqreschain.length_chain[numchain]==0){					/* new chain */
				if((m->pdbseqreschain.nb_chain+1)<NB_MAX_CHAIN){
					m->pdbseqreschain.nb_chain++;
					}
				else  {
					printf("PB :Read_Pdb_File 12: too many chains in SEQRES (%d) [%d]\n",m->pdbseqreschain.nb_chain,NB_MAX_CHAIN);
					fx01=fopen("Results/log.txt","a+");
					fprintf(fx01,"PB :Read_Pdb_File 12: too many chains in SEQRES (%d) [%d]\n",m->pdbseqreschain.nb_chain,NB_MAX_CHAIN);
					of(fx01);
				}	
				
				m->pdbseqreschain.length_chain[numchain]=atoi(tamp_20);
				m->pdbseqreschain.begin_chain[numchain]=m->pdbseqreschain.nb_res;		/* begin chain */
				m->pdbseqreschain.name_chain[numchain]=s[11];					/* name of the chain */
				}
			m->pdbseqreschain.end_chain[numchain]=m->pdbseqreschain.nb_res;				/* end chain */
			
			m->pdbseqres[m->pdbseqreschain.nb_res].RESIDUE=AALogictrans(AAthreeToone(tamp_19));
			/*printf("%3ld [%s] %c\n",m->pdbseqreschain.nb_res,tamp_19,m->pdbseqres[m->pdbseqreschain.nb_res].RESIDUE);*/
			
			m->pdbseqres[m->pdbseqreschain.nb_res].local_chain=chainis;
			m->pdbseqres[m->pdbseqreschain.nb_res].chain_length=atoi(tamp_20);
			if((m->pdbseqreschain.nb_res+1)<NB_MAX_RES){
				m->pdbseqreschain.nb_res++;
				}
			else  {
				printf("PB :Read_Pdb_File 11: too many residues in SEQRES (%ld) [%d]\n",m->pdbseqreschain.nb_res,NB_MAX_RES);
				fx01=fopen("Results/log.txt","a+");
				fprintf(fx01,"PB :Read_Pdb_File 11: too many residues in SEQRES (%ld) [%d]\n",m->pdbseqreschain.nb_res,NB_MAX_RES);
				of(fx01);
			      }	
			 
		}
		deb+=4;
		nb++;
	}
}

/***##***/
/* 0013 */
/***##***/
/*********************************************************************************************/
/*  Fine_Decoup: to fulffil the structur with ATOM (hard case)			    	     */
/*********************************************************************************************/

short int Fine_Decoup(const char *bfe,const long deb,const long fin,pdbfile *m,const char Typos,\
	       const long numero_atom){
	short int i15,y15;
	char  cha[NB_TAMP00];
	short int t=0;
	
	if(CHECK_DBG=='T') printf("step 0013\n");
	
		/* 0- cas pb entre col 12 et 17 : O5*2, C1*1,C2*B, O1P2 des nuclotides  */
	if ((deb==12)&&(fin==17)&&(Typos=='m')){
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0];
		strcpy(m->pdbatomtype[numero_atom].ATOM_name,cha);
		t=1;
	}
	else
		/* 0- entre 20 et 22 du Unknown !!! fichier sale*/
	
	if ((deb==20)&&(fin==22)&&(Typos=='U')){
		t=1;
	}
	else
		/* 1- cas pb entre col 15 et 20 : AILE */
		
	if ((deb==15)&&(fin==20)&&(Typos=='M')){
		m->pdbatomtype[numero_atom].ATOM_altloc=bfe[0];
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<3;i15++)cha[i15]=bfe[i15+1];
			strcpy(m->pdbatomtype[numero_atom].ATOM_residuesname,cha);
		t=1;
		if(CHECK_DBG=='T')
		printf("cas 1 :\n------\nATOM_altloc %c ATOM_residuesname %5s\n",m->pdbatomtype[numero_atom].ATOM_altloc,m->pdbatomtype[numero_atom].ATOM_residuesname);	
		}
	else 	/* 1bis- variante avec : cas pb entre col 15 et 20 : 2LYS */
	if ((deb==15)&&(fin==20)&&(Typos=='m')){
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0];
		m->pdbatomtype[numero_atom].ATOM_altloc=(char)((atoi(cha))+65); /* on essaye de le passer en majuscule */
		for(i15=0;i15<3;i15++)cha[i15]=bfe[i15+1];
			strcpy(m->pdbatomtype[numero_atom].ATOM_residuesname,cha);
		t=1;
		if(CHECK_DBG=='T')	
		printf("cas 1b:\n------\nATOM_altloc %c ATOM_residuesname %5s\n",m->pdbatomtype[numero_atom].ATOM_altloc,m->pdbatomtype[numero_atom].ATOM_residuesname);
		}	
		
	else 	
		/* 2- cas pb entre col 12 et 20 : CG1AILE */
	if((deb==12)&&(fin==20)){
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<3;i15++)cha[i15]=bfe[i15];
			strcpy(m->pdbatomtype[numero_atom].ATOM_name,cha);
		m->pdbatomtype[numero_atom].ATOM_altloc=bfe[3];
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<3;i15++)cha[i15]=bfe[i15+4];
			strcpy(m->pdbatomtype[numero_atom].ATOM_residuesname,cha);
		t=1;
		if(CHECK_DBG=='T')
		printf("cas 2 :\n------\nATOM_name |%s| ATOM_altloc %c ATOM_residuesnumber %5s\n",\
			m->pdbatomtype[numero_atom].ATOM_name,\
			m->pdbatomtype[numero_atom].ATOM_altloc,m->pdbatomtype[numero_atom].ATOM_residuesname);
		}
	else	/* 3- cas pb entre col 11 et 20 : 2HE2BGLN */
	if((deb==11)&&(fin==20)){
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<4;i15++)cha[i15]=bfe[i15];
			strcpy(m->pdbatomtype[numero_atom].ATOM_name,cha);
		m->pdbatomtype[numero_atom].ATOM_altloc=bfe[4];	/* idem au-dessus +1 */
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<3;i15++)cha[i15]=bfe[i15+5];
			strcpy(m->pdbatomtype[numero_atom].ATOM_residuesname,cha);
		t=1;
		if(CHECK_DBG=='T')
		printf("cas 3 :\n------\nATOM_name |%s| ATOM_altloc %c ATOM_residuesnumber %5s\n",m->pdbatomtype[numero_atom].ATOM_name,\
			m->pdbatomtype[numero_atom].ATOM_altloc,m->pdbatomtype[numero_atom].ATOM_residuesname);
		}	
		
	else 		/* 4- cas pb entre col 20 et 26 : A1000 */
	if((deb==20)&&(fin==26)){
		m->pdbatomtype[numero_atom].ATOM_chainnumber=bfe[0];
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<4;i15++)cha[i15]=bfe[i15+1];	
			m->pdbatomtype[numero_atom].ATOM_residuesnumber=atoi(cha);
		t=1;
		if(CHECK_DBG=='T')
		printf("cas 4 :\n------\nATOM_chainnumber %c ATOM_residuesnumber %3ld\n",m->pdbatomtype[numero_atom].ATOM_chainnumber,m->pdbatomtype[numero_atom].ATOM_residuesnumber);
		}
	else 		/* 4bis- cas pb entre col 20 et 26 : A1003A */
	if((deb==20)&&(fin==27)){
		m->pdbatomtype[numero_atom].ATOM_chainnumber=bfe[0];
		clean_str(cha,NB_TAMP00);
		for(i15=0;i15<4;i15++)cha[i15]=bfe[i15+1];	
			m->pdbatomtype[numero_atom].ATOM_residuesnumber=atoi(cha);
		t=1;
		m->pdbatomtype[numero_atom].ATOM_insert=bfe[(fin-deb-2)];
		if(CHECK_DBG=='T')
		printf("cas 4 :\n------\nATOM_chainnumber %c ATOM_residuesnumber %3ld\n",m->pdbatomtype[numero_atom].ATOM_chainnumber,m->pdbatomtype[numero_atom].ATOM_residuesnumber);
		}
	else 		/* 5- cas pb entre col 22/23/24 et 27 : 308A 34B 9A */
	if((deb>=22)&&(fin==27)){
		clean_str(cha,NB_TAMP00);
		m->pdbatomtype[numero_atom].ATOM_insert=bfe[(fin-deb-2)];
		for(i15=0;i15<(fin-deb-2);i15++)cha[i15]=bfe[i15];	
		m->pdbatomtype[numero_atom].ATOM_residuesnumber=atoi(cha);
		t=1;
		if(CHECK_DBG=='T')
		printf("cas 5 :\n------\nATOM_insert %c ATOM_residuesnumber %3ld\n",m->pdbatomtype[numero_atom].ATOM_insert,m->pdbatomtype[numero_atom].ATOM_residuesnumber);
		}	
	else if((deb>=29)&&(fin<=54)){
	
				/*ce n'est pas crystallographie : 29 54 9999.0009999.0009999.000 f !!!!*/
		
		if((bfe[0]==9)&&(bfe[1]==9)){
		printf("fichier non acceptable \n");
		t=1;
		/* PbL+=999;*/
		}
		else{	/* ou tout est dans le negatif 29 54 -108.212-107.734-208.209 f*/
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0]; i15=1;
		while(bfe[i15]!='-'){
			cha[i15]=bfe[i15];
			i15++;
		}m->pdbatomtype[numero_atom].ATOM_CoordX=atof(cha);
		y15=0;
		while(bfe[i15]!='\0'){
			cha[y15++]=bfe[i15];
			i15++;
		}
		cha[y15]=' ';
		m->pdbatomtype[numero_atom].ATOM_CoordY=atof(cha);
		y15=0;
		while(bfe[i15]!='\0'){
			cha[y15++]=bfe[i15];
			i15++;
		}
		cha[y15]=' ';
		m->pdbatomtype[numero_atom].ATOM_CoordZ=atof(cha);
		t=1;
		}
		
	}else 
		/* 6- cas pb entre col 22/23/24 et 27 : -14.532-103.325 */
	if((deb>=20)&&(fin<=46)){
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0]; i15=1;
		while(bfe[i15]!='-'){
			cha[i15]=bfe[i15];
			i15++;
		}m->pdbatomtype[numero_atom].ATOM_CoordX=atof(cha);
		y15=0;
		while(bfe[i15]!='\0'){
			cha[y15++]=bfe[i15];
			i15++;
		}
		cha[y15]=' ';
		m->pdbatomtype[numero_atom].ATOM_CoordY=atof(cha);
		t=1;
		if(CHECK_DBG=='T')	
		printf("cas 6xx:\n------\ncoord Y : %8.3f *** coord Z :%8.3f  (init : %s)\n",m->pdbatomtype[numero_atom].ATOM_CoordY,m->pdbatomtype[numero_atom].ATOM_CoordZ,bfe);
		}
	else			/*38 54 -10.172-188.620 f*/
	if((deb>=38)&&(fin<=54)){
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0]; i15=1;
		while(bfe[i15]!='-'){
			cha[i15]=bfe[i15];
			i15++;
		}m->pdbatomtype[numero_atom].ATOM_CoordY=atof(cha);
		y15=0;
		while(bfe[i15]!='\0'){
			cha[y15++]=bfe[i15];
			i15++;
		}
		cha[y15]=' ';
		m->pdbatomtype[numero_atom].ATOM_CoordZ=atof(cha);
		t=1;
		if(CHECK_DBG=='T')	
		printf("cas 6ww :\n------\ncoord Y : %8.3f *** coord Z :%8.3f  (init : %s)\n",m->pdbatomtype[numero_atom].ATOM_CoordY,m->pdbatomtype[numero_atom].ATOM_CoordZ,bfe);
		}
	
	if((deb>=46)&&(fin<=60)){ 				/* 47 60 21.117-99.00 f */
		clean_str(cha,NB_TAMP00);
		cha[0]=bfe[0]; i15=1;
		while(bfe[i15]!='-'){
			cha[i15]=bfe[i15];
			i15++;
		}
		m->pdbatomtype[numero_atom].ATOM_CoordZ=atof(cha);
		y15=0;clean_str(cha,NB_TAMP00);
		while(bfe[i15]!=' '){
			cha[y15]=bfe[i15];
			i15++;y15++;
		}
		m->pdbatomtype[numero_atom].ATOM_Occupancy=atof(cha);
		if(CHECK_DBG=='T')
		printf("cas 7 :\n------\n coord Z :%8.3f ATOM_Occupancy %8.3f (init : %s)\n",\
		m->pdbatomtype[numero_atom].ATOM_CoordZ,m->pdbatomtype[numero_atom].ATOM_Occupancy,bfe);
		t=1;
		}
	if((deb>=54)&&(fin<=66)){ 				/* 55 66 1.00100.06 f */	
		clean_str(cha,NB_TAMP00);
		y15=0;
		while(bfe[y15]!='.')y15++;
			/* 2 chiffres apres le polong du flottant */
		for(i15=0;i15<(y15+2);cha[i15]=bfe[i15],i15++);
		cha[i15]='\0';i15++;
		/*printf("ici %s\n",cha);*/
		m->pdbatomtype[numero_atom].ATOM_Occupancy=atof(cha);
		y15=0;clean_str(cha,NB_TAMP00);
		/*printf("i15 %d y15 %d\n",i15,y15);*/
		while((bfe[i15]!=' ')&&(bfe[i15]!='\0')){
			cha[y15]=bfe[i15];
			/*printf("i15 %d y15 %d avec |%c|\n",i15,y15,bfe[i15]);*/
			i15++;y15++;
		}cha[i15]='\0';
		/*printf("ici %s\n",cha);*/
		m->pdbatomtype[numero_atom].ATOM_TemperatureFactor=atof(cha);
		if(CHECK_DBG=='T')
		printf("cas 8 :\n------\n ATOM_Occupancy :%8.3f ATOM_TemperatureFactor %8.3f (init : %s)\n",\
		m->pdbatomtype[numero_atom].ATOM_Occupancy,m->pdbatomtype[numero_atom].ATOM_TemperatureFactor,bfe);
		t=1;
		}
	if((deb>=66)&&(fin<=70)){ /*66 70 100 I	*/
				/******************/
				/* non implemente */
				/******************/				
		t=1;
		}
		
	return (t);
}	       

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0012 */
/***##***/
/*********************************************************************************************/
/*  ATOM_placement: to fulffil the structur with ATOM  					     */
/*********************************************************************************************/

void ATOM_placement(const char *bfe,const long deb,const long fin,pdbfile *mole3,const char Typos,\
	       const long numero_atom){
	FILE *f0a;
	
	if(CHECK_DBG=='T') printf("step 0012 with %s\n",bfe);
	
	if ((deb>=0)&&(fin<=6)&&(Typos=='M'))
		strcpy(mole3->pdbatomtype[numero_atom].ATOM_HETAM,bfe);					/* juste pour anhiler cela */
	else 
	if ((deb>=5)&&(fin<=11)&&(Typos=='I'))
		mole3->pdbatomtype[numero_atom].ATOM_serialnumber=atoi(bfe);
	else
	if ((deb>=11)&&(fin<=16)&&((Typos=='m')||(Typos=='M')))
		strcpy(mole3->pdbatomtype[numero_atom].ATOM_name,bfe);
	else
	if((deb==15)&&(fin<=17))mole3->pdbatomtype[numero_atom].ATOM_altloc=bfe[0];
	else
	if ((deb>=16)&&(fin<=21)&&((Typos=='m')||(Typos=='M')))
		strcpy(mole3->pdbatomtype[numero_atom].ATOM_residuesname,bfe);
	else
	if ((deb>=20)&&(fin<=22)&&((Typos=='M')||(Typos=='I')))
		{
		if(Typos=='M')
			mole3->pdbatomtype[numero_atom].ATOM_chainnumber=bfe[0];
		else 	{mole3->pdbatomtype[numero_atom].ATOM_ichainnumber=atoi(bfe);
			 mole3->pdbatomtype[numero_atom].ATOM_chainnumber='Z';
			}	
		}
	else
	if ((deb>=21)&&(fin<=26)&&(Typos=='I'))
		mole3->pdbatomtype[numero_atom].ATOM_residuesnumber=atoi(bfe);
	else	
	if ((deb>=29)&&(fin<=38)&&(Typos=='f'))
		mole3->pdbatomtype[numero_atom].ATOM_CoordX=atof(bfe);
	else	
	if ((deb>=38)&&(fin<=46)&&(Typos=='f'))
		mole3->pdbatomtype[numero_atom].ATOM_CoordY=atof(bfe);
	else	
	if ((deb>=46)&&(fin<=54)&&(Typos=='f'))
		mole3->pdbatomtype[numero_atom].ATOM_CoordZ=atof(bfe);
	else 
	if ((deb>=55)&&(fin<=60)&&(Typos=='f'))
		mole3->pdbatomtype[numero_atom].ATOM_Occupancy=atof(bfe);
	else	
	if((deb>=60)&&(fin<=66)&&(Typos=='f')){
		mole3->pdbatomtype[numero_atom].ATOM_TemperatureFactor=atof(bfe);
		/*printf("%3lf\n",mole3->pdbatomtype[numero_atom].ATOM_TemperatureFactor);*/
		}
	else	
	if((deb>=68)&&(fin<=70)&&(Typos=='I'))
		mole3->pdbatomtype[numero_atom].ATOM_ls=atoi(bfe);
		
		/****************************************************************************/
		/* on a tout tente ce qui est classique mais on doit avoir des champs colle */
		/*   		on part donc sur les cas plus particuliers 		    */
		/****************************************************************************/
		
	else {

	    /* printf("%ld %ld %c %ld |%s|\n",deb,fin,Typos,numero_atom,bfe);*/
/* 0013 */	     
	     if(Fine_Decoup(bfe,deb,fin,mole3,Typos,numero_atom)==0){
		     /*printf("%ld %ld %s %c\n",deb,fin,bfe,Typos);*/
		     f0a=fopen("Results/pb_dassignation.txt","a+");
		     fprintf(f0a,"%ld %ld %s %c\n",deb,fin,bfe,Typos);
		     of(f0a);
		     }

	     if(CHECK_DBG=='T'){ f0a=fopen("./Results/encours2.txt","a+");
	     			fprintf(f0a,"%ld %ld %s %c\n",deb,fin,bfe,Typos);
				of(f0a);
	     	}
	     }	
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0011 */
/***##***/
/*********************************************************************************************/
/* char String_Research : to classify the in Majuscule, minus., real, ...		     */
/*********************************************************************************************/

char String_Research(char *str){
	FILE *f1;
	long internI;
	long Majus,Chiffre,Point,Unk;
	
	f1=fopen("./Results/.e","w");fclose(f1);
	
	if(CHECK_DBG=='T') printf("step 0011\n");
	if(CHECK_DBG=='T'){
		f1=fopen("./Results/encours1.txt","a+");
		fprintf(f1,"\n|%s|",str);
		fprintf(f1,"==> longeur %d\t",(int)strlen(str));}
	Majus=Chiffre=Point=Unk=0;
	for(internI=0;internI<strlen(str);internI++)
		{
		if ((str[internI]>='A')&&(str[internI]<='Z'))
			Majus++;
		else	
		if ((str[internI]>='0')&&(str[internI]<='9'))
			Chiffre++;
		else	
		if (str[internI]=='.')
			Point++;
		else Unk++;	
		}
	/*fprintf(f1,"maj %d chiffre %d polong %d inconnu %d\n",Majus,Chiffre,Point,Unk);*/
	if ((Majus>0)&&(Chiffre==0)&&(Point==0)) {
						 if(CHECK_DBG=='T'){fprintf(f1," cas 0 maj seul %ld ",Majus);
						 of(f1);}
				    		 return 'M';
						 }
	
	if ((Majus>0)&&(Chiffre>0)&&(Point==0)) {
						 if(CHECK_DBG=='T'){fprintf(f1," cas 1 maj %ld et chiffre %ld ",Majus,Chiffre);
						 of(f1);}
				    		 return 'm';
						 }
	
	if ((Chiffre>0)&&(Point==0)) 	{
					if(CHECK_DBG=='T'){fprintf(f1," cas 2 chiffre seul  %ld ",Chiffre);
					of(f1);}
					return 'I';	
					}
	if ((Chiffre>0)&&(Point>0)) {
				    if(CHECK_DBG=='T'){fprintf(f1,"cas 3 un doubleant %ld ",Point);
				    of(f1);}
				    return 'f';
				    }
	 if(CHECK_DBG=='T'){if (Unk>0) fprintf(f1,"pb de non reconnaissance : ??? %ld \n",Unk);}
	 if (Unk>0) printf("PB :Read_Pdb_File 05 : some strange characters [%ld] \n",Unk);
	 if(CHECK_DBG=='T')of(f1);
	return 'U'; 
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0010 */
/***##***/
/*********************************************************************************************/
/*	Work_ATOM : to clean and use the ATOM						     */
/*********************************************************************************************/

void Work_ATOM(char* s, pdbfile *mole2){
	FILE *flocal2;
	long i_t=0;
	long i_t2=0;
	char buf2_interne[Lg_buffer];
	char recup;
	long deb=0;
	
	if(CHECK_DBG=='T')  printf("step 0010 ATOM * %ld sur |%d|\n",(mole2->NbAtome),NB_MAX_ATOM);
	
	
	if(strlen(s)<NBCOL) {
		printf("PB :Read_Pdb_File 10: ATOM line seems to short (%d) [%s]\n",(int)strlen(s),s);
		flocal2=fopen("./Results/cutpdb.txt","a+");
		fprintf(flocal2,"\n*****************************************\n%s",mole2->header);
		fprintf(flocal2,"PB :Read_Pdb_File 10: ATOM line seems to short (%d) [%s]\n",(int)strlen(s),s);
		of(flocal2);
		}
	else{
	while((s[i_t]!='\0')&&(i_t<70)){
		i_t2=0;
		while((s[i_t]!=' ')&&(s[i_t]!='\0')){
			buf2_interne[i_t2++]=s[i_t];
			i_t++;
			}

		if (i_t2>0){
			if(buf2_interne[i_t2-1]=='\n')			/* pour les problemes de fin de ligne */
				{
				buf2_interne[i_t2-1]='\0';
				i_t--;
				}
			else buf2_interne[i_t2]='\0';			/* marqueur de fin de chaine de char */
			
/* 0011 */			
			recup=String_Research(buf2_interne);
			/*printf("%ld %c %s\n",i_t2,recup,buf2_interne);*/
/* 0012 */			
			ATOM_placement(buf2_interne,deb,i_t,mole2,recup,(mole2->NbAtome));
			}
		deb=i_t;
		i_t++;	
		}
	(mole2->NbAtome)++;						/* incremente le nombre d'atome vu */
	if((mole2->NbAtome)==(NB_MAX_ATOM-1)){				/* pour eviter les problemes*/
		printf("PB :Read_Pdb_File 04: Huge PDB files : %d atoms authorized\n",NB_MAX_ATOM);
		(mole2->NbAtome)--;
		}
	}	
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0009 */
/***##***/

/*********************************************************************************************/
/*			   recuperation du Caveat pour voir l'interet 			     */
/*			 THERE ARE CHIRALITY ERRORS IN C-ALPHA CENTERS			     */
/*********************************************************************************************/

void Caveat( char* s, pdbfile *m){
	FILE *fx01;
	fx01=fSurecrire("Results/CAVEAT.txt");
	fprintf(fx01,"%s\n",m->header);
	fprintf(fx01,"%s\n",s);
	of(fx01);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0008 */
/***##***/
/*********************************************************************************************/
/*	Work_Experiment_Usi; type of experimental techniques	 			     */
/*********************************************************************************************/

void Work_Experiment_Usi(char* s, pdbfile *m){
	short int y_19;
	char tamp_19[13];
	FILE *fx01;
	for(y_19=0;y_19<13;tamp_19[y_19]=s[y_19],y_19++);
	tamp_19[y_19]='\0';
	     if(strcmp("EXPDTA    X-R",tamp_19)==0)
		m->WhichExp=1;
	else if(strcmp("EXPDTA    SYN",tamp_19)==0)	/* EXPDTA    SYNCHROTRON X-RAY DIFFRACTION */
							/* EXPDTA    SYNCHROTRON RADIATION */
		m->WhichExp=1;
	else if(strcmp("EXPDTA    ELE",tamp_19)==0)	/* EXPDTA    ELECTRON DIFFRACTION */
		m->WhichExp=1;
	else if(strcmp("EXPDTA    NMR",tamp_19)==0)
		m->WhichExp=2;
	else if(strcmp("EXPDTA    THE",tamp_19)==0)
		m->WhichExp=3;
	else if(strcmp("EXPDTA    FIB",tamp_19)==0)	/* EXPDTA    FIBER DIFFRACTION */
		m->WhichExp=4;
	else if(strcmp("EXPDTA    NEU",tamp_19)==0)	/* EXPDTA    NEUTRON DIFFRACTION */
		m->WhichExp=5;
	else if(strcmp("EXPDTA   2 RE",tamp_19)==0)	/* EXPDTA   2 RESTRAINED MOLECULAR DYNAMICS */
		m->WhichExp=6;
	else if(strcmp("EXPDTA    FLU",tamp_19)==0)	/* EXPDTA    FLUORESCENCE TRANSFER *//* 15/12/1999*/
		m->WhichExp=7;
		
	else {
		printf("PB :Read_Pdb_File 03 : experiment method not found %d|%s\n",m->WhichExp,s);
		fx01=fSurecrire("Results/EXPDTA_unknown.txt");
		fprintf(fx01,"%s",s);
		of(fx01);
		m->WhichExp=27;	/* NON determine */
	     }
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0007 */
/***##***/
/*********************************************************************************************/
/*	Work_resolution: protein resolution  (Angtroms)			     	     	     */
/*********************************************************************************************/

void Work_resolution( char* s, pdbfile *m){
	short int y_19,i_19;
	char tamp_19[24];
	for(y_19=0;y_19<23;tamp_19[y_19]=s[y_19],y_19++);
	tamp_19[y_19]='\0';
	if(strcmp("REMARK   2 RESOLUTION. ",tamp_19)==0){
	for(i_19=0;i_19<3;tamp_19[i_19++]=s[y_19++]);tamp_19[i_19]='\0';
		if((tamp_19[0]=='N')||(tamp_19[1]=='N')||(tamp_19[2]=='N'))	/* pour REMARK   2 RESOLUTION. NOT APPLICABLE.*/
			m->resolution=DEFAULT_RES;		
		else 	m->resolution=atof(tamp_19);
		
		}
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0006 */
/***##***/
/*********************************************************************************************/
/*	Work_HEADER : to read the header of the file					     */
/*********************************************************************************************/

void Work_HEADER( char* str, pdbfile *mole2){
	short int y_17;
	(mole2->lg_header)+=strlen(str);
	strcpy((mole2->header),str);
	for(y_17=0;y_17<4;mole2->name[y_17]=str[y_17+62],y_17++);		/* commence a la 61eme colonne */
	for(y_17=0;y_17<9;mole2->depositdate[y_17]=str[y_17+50],y_17++);	/* date de deposition commence a la 50eme colonne */
}

void Work_REVDAT( char* s, pdbfile *m){
	short int y_19,i_19;
	char tamp_19[13];
	for(y_19=0;y_19<10;tamp_19[y_19]=s[y_19],y_19++);
	tamp_19[y_19]='\0';
	if(strcmp("REVDAT   1",tamp_19)==0){
/*pb*/	for(i_19=0;i_19<9;i_19++)m->releasedate[i_19]=s[(i_19+13)];
		m->releasedate[i_19]='\0';
	/*printf("01 -Q> |%s|\n",m->releasedate);*/
	}
	else printf("02 -Q> %s\n",tamp_19);
		
}
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0005 */
/***##***/
/*********************************************************************************************/
/*	Megadecoup : for the hardest problems						     */
/*********************************************************************************************/

long Megadecoup(char* s){
	short int i_tr2=-1;
	s[6]='\0';
	
	if(CHECK_DBG=='T')  printf("step 0005 * %d|%s|\n",i_tr2,s);
	while(strcmp(s,First[++i_tr2])!=0)
		{
	if(CHECK_DBG=='T')  printf("step 0005 ** %d|%s|\n",i_tr2,s);
		if(i_tr2==(Number_First-1))
			{
			i_tr2=Number_First+1;	/*n'a reelement pas trouve le champ*/
			break;
			}
		}
	if(CHECK_DBG=='T')  printf("step 0005 *** %d|%s|\n",i_tr2,s);
	i_tr2--;	
	
	if (i_tr2<Number_First) return (0);
	else {
	     s[3]='\0';
	     if(strcmp(s,"END")==0) return (0);	/*PB de fin  de fichier*/
	     else return (1);
	     }
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/*26 - 07 -2007 */

void Work_SSBONd( char* s, pdbfile *m){
	printf("%s\n",s);
		
}


/***##***/
/* 0004 */
/***##***/
/*********************************************************************************************/
/*	Redeploy : for each format							      */
/*********************************************************************************************/

void Redeploy(char* str,pdbfile *m, long champ_number){
	switch (champ_number)
		{
		
/* 0006 */		
		case  (0): Work_HEADER(str,m); 	   	break;	/*"HEADER"*/
		
		case  (4): Work_REVDAT(str,m);		break;	/* REVDAT */
/* 0007 */		
		case  (6): Work_resolution(str,m); 	break;	/*"REMARK"*/
/* 00013b*/		
		case  (7): Work_Seq(str,m); 		break;	/*"SEQRES"*/
/* 00013c*/		
		case (11): Work_Helix(str,m); 		break;	/*"HELIX"*/
/* 00013d*/		
		case (12): Work_Sheet(str,m); 		break;	/*"SHEET"*/
/* 0010 */		
		case (25): Work_ATOM(str,m);       	break;

		case (32): Work_SSBONd(str,m);		break;	/*"SSBOND"*/
/* 00013e*/		
		case (33): Work_Turn(str,m);		break;	/*"TURN"*/
/* 0008 */		
		case (38): Work_Experiment_Usi(str,m); 	break;	/*"EXPDTA"*/
/* 0009 */		
		case (49): Caveat(str,m);          	break;
		};
}
	     
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
/***##****/
/* 0003b */
/***##****/
/*********************************************************************************************/
/*	isitsomething:  for the file with stange blank at the end of file		     */
/*********************************************************************************************/

short int isitsomething(char *chstr){
	short int t=1;
	int s_i=0;
	while(chstr[s_i]!='\n'){
		/*printf("%2d|%c|\n",s_i,chstr[s_i]);*/
		s_i++;
		t++;
		}
	return (t);
}

/***##***/
/* 0003 */
/***##***/
/*********************************************************************************************/
/*	traitement: take each ligne and search "what can be that ?" 			     */
/*********************************************************************************************/

void traitement(char* str, long *compteur_good, pdbfile *molecule, long *lignefichier)
	{
	FILE *flocal1;			/* pointeur quand on ne trouve pas un champ */
	short int i_tr=-1;
	char buf_interne[Lg_buffer];
	
		/*************************************************************/
		/* on met toute la ligne dans le buffer et on nettoie la fin */
		/*************************************************************/
			
	while(str[++i_tr]!=' ') buf_interne[i_tr]=str[i_tr];
		buf_interne[i_tr]='\0';
	i_tr=0;
	
		/************************************************************/
		/* on cherche dans la liste le champ auquel cela correspond */
		/************************************************************/
			
	
	while(strcmp(buf_interne,First[i_tr++])!=0)
		{
		if(i_tr==(Number_First))
			{
			i_tr=Number_First+1;	/* n'a reelement pas trouve le champ */
			break;
			}
		}
	i_tr--;	if(CHECK_DBG=='T') printf("step 0003 %d|%s\n",i_tr,str);
			/**************************************/
			/* on en a un bon alors on va checker */
			/**************************************/
						
	if (i_tr<Number_First){	
		(*compteur_good)++;
/* 0004 */
		Redeploy(str,molecule,i_tr);
		}
	else  {

			/***************************************************/	
			/* pour essayer de le recuperer en dernier recours */
			/***************************************************/				

/* 0005 */			
		if (Megadecoup(buf_interne)==0){
			(*compteur_good)++;
/* 0004 */			
			Redeploy(str,molecule,i_tr);

			}
		else {
		
			if(isitsomething(str)==1){
				(*lignefichier)--;		/*blank ligne == does not count */
				}
			else    {
				printf("pas trouve : ligne %d %s |%s| %d (%c %d)\n",i_tr,str,buf_interne,i_tr,str[5],str[5]);	
				flocal1=fopen("./Results/untreated.txt","a+");
				fprintf(flocal1,"\n*****************************************\n%s",molecule->header);
				fprintf(flocal1,"PB :Read_Pdb_File 02 : ligne number : %d %s |%s| %d (%c %d)\n",i_tr,str,buf_interne,i_tr,str[5],str[5]);	
				of(flocal1);
				}
		}
	}

	(*lignefichier)++;			
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
	
/***##***/
/* 0002 */
/***##***/
/*********************************************************************************************/
/*	Read_Pdb_File : take ligne by ligne the PDB file 				      */
/*********************************************************************************************/

void Read_Pdb_File(FILE *fpdb, pdbfile *molecule){
	
	char buffer[Lg_buffer];
	long lignefichier=0;
	long lignebonne=0;
	
	                     /*****************************/
	                     /* a- on lit ligne par ligne */
	                     /*****************************/
	
	if(Werboze=='T') printf("Read_Pdb_File 01: begin molecule treatment\n");
	
	while(fgets(buffer,Lg_buffer,fpdb)!=NULL)
	  {
	  	/***********************************************/	
		/* b- et on traite l'information bloc par bloc */
		/***********************************************/

	  traitement(buffer,&lignebonne,molecule,&lignefichier);				/* 0003 */
										
  					
	  }
	if((lignefichier-lignebonne)>0){
		 printf("PB :Read_Pdb_File 01 : ligne number : %ld [known : %ld | unknown : %ld]\n",lignefichier,lignebonne,lignefichier-lignebonne); 
		 printf("molecule.NbAtome : %ld \n",molecule->NbAtome);
		 }
	else if(Werboze=='T') printf("Read_Pdb_File 02: end molecule treatment [%ld lignes -- all treated]\n",lignefichier);
	of(fpdb);
	
	sum(molecule,0);									/* 0001g */
	check_seqres(molecule);									/* 0001h */
	
	
	}
 
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/




