/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	structure.c	(beta version 2003)				      */
/*	----------							      */
/*	main part of the software					      */
/*	all the different options are sequentially done			      */
/*	last mofication : 10-04-2003					      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/options.h"
# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"


/***##***/
/* 0001 */
/***##***/
/*********************************************************************************************/
/*		To be sure to have a clean structure to work				     */
/*********************************************************************************************/

void Nullify(pdbfile *mole1){
	long y02=0;
	long  i02=0;
	
	if(Werboze=='T') p("Cleaning of the structure begin");
	
	mole1->IsItProt=mole1->IsItCalphaOnly=mole1->IsItDNA=0;	  			/*    0 = NO  / 1=YES   */
	mole1->WhichExp=0;								/*    0= Not identify   */
	mole1->PB_latChain=mole1->PB_Backbone=mole1->PB_AA=0;				/* default : no problem */
	mole1->PB_Doublet=0;								/* default : no problem */
	
			/*****************/
			/* for the atoms */
			/*****************/			
	
	for(y02=0;y02<NB_AMX_HEADER;mole1->header[y02++]=' ');				/* A 01*/
	for(y02=0;y02<4;mole1->name[y02++]=' ');					/* A 02*/
	mole1->lg_header=0;								/* A 03*/
	mole1->NbAtome=0;								/* A 06*/
	mole1->resolution=500.;								/* A 07*/
	mole1->Nb_AtNA=0;
			
			/****************************************/
			/*   for the atoms of pdbfile structure */
			/****************************************/
	
	for(y02=0;y02<NB_MAX_ATOM;y02++){						/* A 04*/
		mole1->pdbatomtype[y02].ATOM_serialnumber=0;	 			/*C 02*/
											/* ou =0 c'est pareil */
		for(i02=0;i02<NB_M_LG;mole1->pdbatomtype[y02].ATOM_name[i02++]=0);
											/*C 03*/
		mole1->pdbatomtype[y02].ATOM_altloc=0;					/*C 04*/
		for(i02=0;i02<NB_M_LG;mole1->pdbatomtype[y02].ATOM_residuesname[i02++]=0);
											/*C 05*/
		mole1->pdbatomtype[y02].ATOM_chainnumber=0;				/*C 06*/
		mole1->pdbatomtype[y02].ATOM_ichainnumber=0;				/*C 07*/
		mole1->pdbatomtype[y02].ATOM_residuesnumber=0;				/*C 08*/
		mole1->pdbatomtype[y02].ATOM_insert=0;					/*C 09*/
		mole1->pdbatomtype[y02].ATOM_CoordX=0;					/*C 10*/
		mole1->pdbatomtype[y02].ATOM_CoordY=0;					/*C 11*/
		mole1->pdbatomtype[y02].ATOM_CoordZ=0;					/*C 12*/
/*		mole1->pdbatomtype[y02].ATOM_Occupancy=0;*/				/*C 13*/
/*		mole1->pdbatomtype[y02].ATOM_TemperatureFactor=0;*/			/*C 14*/
		mole1->pdbatomtype[y02].ATOM_real=0;					/*C 15*/
		
		}

			/**********************************/
			/*for the residues (AA, proteins) */
			/**********************************/
						
	mole1->Nb_residues=0;								/* B 01*/
	for(y02=0;y02<NB_MAX_RES;y02++){
		mole1->deb_residues[y02]=mole1->end_residues[y02]=0;		     	/* B 02*//* B 03*/
		mole1->Nam_residues[y02]=0;						/* B 04*/
		mole1->Complete_Res[y02]=0;						/* B 05*/
		mole1->Phi[y02]=mole1->Psi[y02]=mole1->Omega[y02]=0;			/* B 06*//* B 07*//* B 08*/
		mole1->New_Phi[y02]=mole1->New_Psi[y02]=DEFAULT_ANGLE;			/* B 14*//* B 15*/
		mole1->Nea_Phi[y02]=mole1->Nea_Psi[y02]=DEFAULT_ANGLE;			/* B 16*//* B 17*/
		for(i02=0;i02<NB_MAX_XHI;mole1->Xhi[y02][i02++]=0);			/* B 09*/
		mole1->Assign_PB[y02]=-1;						/* B 13*/
		mole1->Pos_FirstRes[y02]=mole1->Pos_LastRes[y02]=0;			/* B 20*/
		mole1->Alpha[y02]=DEFAULT_ANGLE;
		mole1->S2sea[y02]='X';
		mole1->S2dssp[y02]='X';
		mole1->S2dsspcont[y02]='X';
		mole1->S2dssphel[y02]='X';		
		mole1->S2stride[y02]='X';
		mole1->S2define[y02]='X';
		mole1->S2pcurve[y02]='X';
		mole1->S2xtlsstr[y02]='X';
		mole1->S2RKdssp[y02]='X';
		mole1->S2Fodje[y02]='X';
		mole1->S2Segno[y02]='X';
		mole1->S2Kaksi[y02]='X';
		for(i02=0;i02<2;mole1->BetaTurnPro[y02][i02++]=0);
		for(i02=0;i02<2;mole1->GammaTurnPro[y02][i02++]=0);
		mole1->BetaHairpinPro[y02]=0;
		mole1->BetaBulPro[y02]=0;
		mole1->BetaBulProX[y02]=0;
		mole1->PsiLoopPro[y02]=0;
		}
	for(i02=0;i02<NbrAA;mole1->Composition_AA[i02++]=0);			        /* B 10*/
	mole1->NB_chain=0;								/* B 11*/
	for(i02=0;i02<NB_MAX_CHAIN;mole1->Pos_chain[i02][0]=0,\
	mole1->Pos_chain[i02][1]=mole1->Deb_chain[i02]=mole1->End_chain[i02]=0,i02++);	/* B 12-18-19*/
		
		mole1->meanTval=0.0;
		mole1->meanTvalsd=0.0;
	
/*	DistAA[0]='X';
	DistAA[1]='X';*/
	
	for(y02=0;y02<NB_MAX_RES;y02++){
		mole1->pdbseqres[y02].RESIDUE='-';
		mole1->pdbseqres[y02].local_chain='-';
		mole1->pdbseqres[y02].chain_length=0;
	}
	
	mole1->pdbseqreschain.nb_res=0;
	mole1->pdbseqreschain.nb_chain=0;
	for(y02=0;y02<NB_MAX_CHAIN;y02++){
		mole1->pdbseqreschain.length_chain[y02]=0;
		mole1->pdbseqreschain.begin_chain[y02]=-1;
		mole1->pdbseqreschain.end_chain[y02]=-1;
		mole1->pdbseqreschain.name_chain[y02]='-';
		
		}
		
	mole1->pdbhelix.nb_helix=0;
	
	for(y02=0;y02<NB_MAX_helix;y02++){
		mole1->pdbhelix.pdbhelixpos[y02].chain='-';
		mole1->pdbhelix.pdbhelixpos[y02].begin_helix=-1;
		mole1->pdbhelix.pdbhelixpos[y02].end_helix=-1;
		}
	
	mole1->pdbbeta.nb_beta=0;
	
	for(y02=0;y02<NB_MAX_helix;y02++){
		mole1->pdbbeta.pdbbetapos[y02].chain='-';
		mole1->pdbbeta.pdbbetapos[y02].begin_beta=-1;
		mole1->pdbbeta.pdbbetapos[y02].end_beta=-1;
		}
		
	mole1->pdbturn.nb_turn=0;
	
	for(y02=0;y02<NB_MAX_helix;y02++){
		mole1->pdbturn.pdbturnpos[y02].chain='-';
		mole1->pdbturn.pdbturnpos[y02].begin_turn=-1;
		mole1->pdbturn.pdbturnpos[y02].end_turn=-1;
		}			

	for(y02=0;y02<NB_MAX_RES;y02++){
		mole1->Turn_Type1[y02]=0;
		mole1->Turn_Type2[y02]=0; 	     
		mole1->Turn_Type8[y02]=0;	     
		mole1->Turn_Type1I[y02]=0;	     
		mole1->Turn_Type2I[y02]=0;	     
		mole1->Turn_Type6a1[y02]=0;	     
		mole1->Turn_Type6a2[y02]=0;	     
		mole1->Turn_Type6b[y02]=0;	     
		mole1->Turn_Type4[y02]=0;
		mole1->Turn_GammaClass[y02]=0;
		mole1->Turn_GammaClassI[y02]=0;
		mole1->RelativeAccess[y02]=0.00;
		mole1->CysDSSP[y02]=0;
		}

	if(Werboze=='T') p("Cleaning of the structure is done");

}
