/******************************************************************************/
/*	PDB Dreamer version 1.02					      */
/*      (A.G. de Brevern - EBGM - U726 INSERM)				      */
/******************************************************************************/
/*	tradution.c	(beta version 2005)				      */
/*	-------------							      */
/*	From PB to 3D to amino and backs				      */
/*	version : 1.01						              */
/*	last modification : 28-05-2005					      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

char BPtransTM(const long w)
	 {
	 char entier;
		if(w==12) entier='H';
		else      entier='b';
	return entier;
 	}
	
char BPtrans(const long w)
	 {
	 char entier;
		switch (w)
			{
			case  (0) : entier='a'; break;
			case  (1) : entier='b'; break;
			case  (2) : entier='c'; break;
			case  (3) : entier='d'; break;
			case  (4) : entier='e'; break;
			case  (5) : entier='f'; break;
			case  (6) : entier='g'; break;
			case  (7) : entier='h'; break;
			case  (8) : entier='i'; break;
			case  (9) : entier='j'; break;
			case (10) : entier='k'; break;
			case (11) : entier='l'; break;
			case (12) : entier='m'; break;
			case (13) : entier='n'; break;
			case (14) : entier='o'; break;
			case (15) : entier='p'; break;
			case (-1) : entier='Z'; break;
			case (-3) : entier='I'; break;		/* 	pour aa incomplet sur la chaine carbonee       */
			case (-5) : entier='W'; break;		/* pour un dedoublement d'acide amine en meme position */
			default :   entier='X'; break;
			}
	return entier;
 	}
/*********************************************************************************************/
/*			Traduction du code a une lettre en entier			     */
/*  (attention ce n'est pas par ordre alphabetique a une lettre mais par celuia 3 lettres)   */
/*********************************************************************************************/

int transAA(const char w)
	 {
	 int entier;
		switch (w)
			{
			case ('A') : entier= 0; break;
			case ('R') : entier= 1; break;
			case ('N') : entier= 2; break;
			case ('D') : entier= 3; break;
			case ('C') : entier= 4; break;
			case ('Q') : entier= 5; break;
			case ('E') : entier= 6; break;
			case ('G') : entier= 7; break;
			case ('H') : entier= 8; break;
			case ('I') : entier= 9; break;
			case ('L') : entier=10; break;
			case ('K') : entier=11; break;
			case ('M') : entier=12; break;
			case ('F') : entier=13; break;
			case ('P') : entier=14; break;
			case ('S') : entier=15; break;
			case ('T') : entier=16; break;
			case ('W') : entier=17; break;
			case ('Y') : entier=18; break;
			case ('V') : entier=19; break;
			default : printf("Probleme d'acide  amines non conforme %c \n",w);
/* A VOIR PbL ++;*/
				  entier=20;
			}
	return entier;
 	}

int transAAlogic(const char w)
	 {
	 int entier;
		switch (w)
			{
			case ('I') : entier= 0; break;
			case ('V') : entier= 1; break;
			case ('L') : entier= 2; break;
			case ('M') : entier= 3; break;
			case ('A') : entier= 4; break;
			case ('F') : entier= 5; break;
			case ('Y') : entier= 6; break;
			case ('W') : entier= 7; break;
			case ('C') : entier= 8; break;
			case ('Q') : entier= 9; break;
			case ('P') : entier=10; break;
			case ('G') : entier=11; break;
			case ('H') : entier=12; break;
			case ('S') : entier=13; break;
			case ('T') : entier=14; break;
			case ('N') : entier=15; break;
			case ('D') : entier=16; break;
			case ('E') : entier=17; break;
			case ('R') : entier=18; break;
			case ('K') : entier=19; break;
			default : printf("Probleme d'acide  amines non conforme %c \n",w);
/* A VOIR PbL ++;*/
				  entier=20;
			}
	return entier;
 	}

/*********************************************************************************************/
/*			Traduction de l'entier dans le code a 1 lettre			     */
/*  (attention ce n'est pas par ordre alphabetique a une lettre mais par celuia 3 lettres)   */
/*********************************************************************************************/
	
char AAtrans(const long w)
	 {
	 char entier;
		switch (w)
			{
			case  (0) : entier='A'; break;
			case  (1) : entier='R'; break;
			case  (2) : entier='N'; break;
			case  (3) : entier='D'; break;
			case  (4) : entier='C'; break;
			case  (5) : entier='Q'; break;
			case  (6) : entier='E'; break;
			case  (7) : entier='G'; break;
			case  (8) : entier='H'; break;
			case  (9) : entier='I'; break;
			case (10) : entier='L'; break;
			case (11) : entier='K'; break;
			case (12) : entier='M'; break;
			case (13) : entier='F'; break;
			case (14) : entier='P'; break;
			case (15) : entier='S'; break;
			case (16) : entier='T'; break;
			case (17) : entier='W'; break;
			case (18) : entier='Y'; break;
			case (19) : entier='V'; break;
			default : /*printf("Probleme d'acide  amines non conforme %c \n",w);*/ 
				  entier='X';
			}
	return entier;
 	}
/*	
char* aa3(const long w)
	 {
	 char entier[3];
		switch (w)
			{
			case  (0) : strcpy(entier,"ALA"); break;
			case  (1) : strcpy(entier,"ARG"); break;
			case  (2) : strcpy(entier,"ASN"); break;
			case  (3) : strcpy(entier,"ASP"); break;
			case  (4) : strcpy(entier,"CYS"); break;
			case  (5) : strcpy(entier,"GLN"); break;
			case  (6) : strcpy(entier,"GLU"); break;
			case  (7) : strcpy(entier,"GLY"); break;
			case  (8) : strcpy(entier,"HIS"); break;
			case  (9) : strcpy(entier,"ILE"); break;
			case (10) : strcpy(entier,"LEU"); break;
			case (11) : strcpy(entier,"LYS"); break;
			case (12) : strcpy(entier,"MET"); break;
			case (13) : strcpy(entier,"PHE"); break;
			case (14) : strcpy(entier,"PRO"); break;
			case (15) : strcpy(entier,"SER"); break;
			case (16) : strcpy(entier,"THR"); break;
			case (17) : strcpy(entier,"TRP"); break;
			case (18) : strcpy(entier,"TYR"); break;
			case (19) : strcpy(entier,"VAL"); break;
			default : 
				  strcpy(entier,"UNK");
			}
	return entier;
 	}
	*/
/*********************************************************************************************/
/*			Traduction de l'entier dans le code a 1 lettre			     */
/*********************************************************************************************/
	
char AALogictrans(const long w)
	 {
	 char entier;
		switch (w)
			{
			case  (0) : entier='A'; break;
			case  (1) : entier='C'; break;
			case  (2) : entier='D'; break;
			case  (3) : entier='E'; break;
			case  (4) : entier='F'; break;
			case  (5) : entier='G'; break;
			case  (6) : entier='H'; break;
			case  (7) : entier='I'; break;
			case  (8) : entier='K'; break;
			case  (9) : entier='L'; break;
			case (10) : entier='M'; break;
			case (11) : entier='N'; break;
			case (12) : entier='P'; break;
			case (13) : entier='Q'; break;
			case (14) : entier='R'; break;
			case (15) : entier='S'; break;
			case (16) : entier='T'; break;
			case (17) : entier='V'; break;
			case (18) : entier='W'; break;
			case (19) : entier='Y'; break;
			default : /*printf("Probleme d'acide  amines non conforme %c \n",w);*/ 
				  entier='X';
			}
	return entier;
 	}

int AAthreeToone(char *aa)	
		{
		int AA=20;
		switch (aa[0])  
			{
			case ('A') : /*alanine , arginine, acide asparagique, asparate */
					switch (aa[2])  
						{
						case ('A') : AA=0 ; break; /* ALA (A) alanine */
						case ('G') : AA=14; break; /* ARG (R) arginine */						
						case ('N') : AA=11; break; /* ASN (N) acide asparagique */
						case ('P') : AA=2;  break; /* ASP (D) asparate */
						} break;
			case ('C') : AA=1; break; 			      /* CYS (C) cysteine */
			case ('G') : /* glycine, glutamate, acide glutamique */
					switch (aa[2])  
						{
						case ('N') : AA=13;  break; /* GLN (Q) acide glutamique */
						case ('Y') : AA=5;   break; /* GLY (G) glycine */
						case ('U') : AA=3;   break; /* GLU (E) glutamate */
						} break;
			case ('H') : AA=6;   break; 			       /* HIS (H) histidine */
			case ('I') : AA=7;   break;	        	       /* ILE (I) isoleucine */
			case ('L') : /* leucine ,lysine */
					switch (aa[1])  
						{
						case ('E') : AA=9;  break; /* LEU (L) leucine */
						case ('Y') : AA=8;  break; /* LYS (K) lysine */
						} break;						
			case ('M') : AA=10;  break;			      /* MET (M) methionine */
			case ('P') : /* phenilalanine, proline */
					switch (aa[1])  
						{
						case ('H') : AA=4;  break; /* PHE (F) phenilalanine */
						case ('R') : AA=12; break; /* PRO (P) proline */
						} break;			
			case ('S') : AA=15;  break;			      /* SER (S) serine */
			case ('T') : /* threonine, tyrosine , tryptophane */
					switch (aa[1])  
						{
						case ('H') : AA=16;  break; /* THR (T) threonine */
						case ('R') : AA=18;  break; /* TRP (W) tryptophane */
						case ('Y') : AA=19;  break; /* TYR (Y) tyrosine */
						} break;						
			case ('V') : AA=17;  break; 			      /* VAL (V) valine */
			default : printf("PB traduction : Unknown amino acid [%c%c%c] \n",aa[0],aa[1],aa[2]); break;
			}
		return AA;
	}		
