/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	follow.c	(beta version 2003)				      */
/*	----------							      */
/*	to check the chosen options					      */
/*	last modification : 05-06-2003					      */
/******************************************************************************/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/options.h"
# include "../HEADER/lib_define.h"
# include "../HEADER/lib_protoC.h"

/*********/
/* 0001e */
/************************************************************************************************************************************/
/*	file_options: following the chosen options 				 						    */
/************************************************************************************************************************************/

void file_options(char *name){
					/****************/
	FILE *fg;			/*    file      */
	char buffer_opt[Lg_buffer];	/* ligne buffer */
	char buffer_opt2[Lg_buffer];	/* ligne buffer */
	short int bad=0;		/* follow  count*/
					/****************/	
	
	/* check if it's ok */
	
	if((fg=fopen("Results/verification_1.txt","r"))==0){
		fg=fecrire("Results/verification_1.txt");		/* creation if not here  */
		fclose(fg);
		}
	else	{							/* the file is here if not here  */
		clean_str(buffer_opt,Lg_buffer);clean_str(buffer_opt2,Lg_buffer);
		while(fgets(buffer_opt,Lg_buffer,fg)!=NULL){
		/*printf("****************=> |%s| |%d| |%c|\n",buffer_opt,strlen(buffer_opt),buffer_opt[strlen(buffer_opt)-1]);*/
		strcpy(buffer_opt2,buffer_opt);
		clean_str(buffer_opt,Lg_buffer);
		}
		/*printf("*************888=> |%s| |%d| |%c|\n",buffer_opt2,strlen(buffer_opt2),buffer_opt2[strlen(buffer_opt2)-1]);*/
		if((buffer_opt2[strlen(buffer_opt2)-1])=='X'){		/* the last was not finish */
			bad=1;				
			fclose(fg);
			fg=fSurecrire("Results/verification_does_not_work.txt");
			fprintf(fg,"%s\n",buffer_opt2);
			fclose(fg);
			}
			
	}
	
	fg=fSurecrire("Results/verification_1.txt");
	if(bad==1)	fprintf(fg,"\n%s\t",name);
	else		fprintf(fg,"%s\t",name);
	if(NO_CHECK=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(LECT_SEA=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(LECT_DSSP=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(LECT_STRIDE=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(LECT_DEFINE=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(PROMOTIF=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(PROTEIN_NETWORK=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	if(PRAPIA=='T')
		fprintf(fg,"%d ",0); else fprintf(fg,"%d ",1); 
	fprintf(fg,"X"); 
	of(fg);

}

/*********/
/* 0001f */
/************************************************************************************************************************************/
/*	end_options: end of the work		 				 						    */
/************************************************************************************************************************************/

void end_options(){
					/****************/
	FILE *fg;			/*    file      */
					/****************/

	fg=fSurecrire("Results/verification_1.txt");
	fprintf(fg,"  FINISH\n"); 
	of(fg);
}

/*********/
/* 0001g */
/************************************************************************************************************************************/
/*	sum: summary of the reading		 				 						    */
/************************************************************************************************************************************/

void sum(pdbfile *m, int state){
					/****************/
	FILE *fg;			/*    file      */
	int s_sum;			/*     count    */
					/****************/

	fg=fSurecrire("Results/sum_1.txt");
	switch(state){
		case(0): 
			fprintf(fg,"#######################################################\n");
			fprintf(fg,"# NAME : %s\n",m->name);
			fprintf(fg,"# RESIDUE NUMBER (SEQRES) : %9ld\n",m->pdbseqreschain.nb_res);
			fprintf(fg,"#######################################################\n");
			fprintf(fg,"# CHAIN NUMBER (SEQRES) :   %9d\n",m->pdbseqreschain.nb_chain);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbseqreschain.nb_chain;s_sum++){
				fprintf(fg,"# CHAIN NUMBER %2d BEGIN :   %9ld\n",s_sum,m->pdbseqreschain.begin_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2d END :     %9ld\n",s_sum,m->pdbseqreschain.end_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2d LENGTH :  %9ld\n",s_sum,m->pdbseqreschain.length_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2d (SEQRES) :%9ld\n",s_sum,m->pdbseqres[m->pdbseqreschain.end_chain[s_sum]].chain_length);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# HELIX NUMBER (HELIX) :    %9d\n",m->pdbhelix.nb_helix);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbhelix.nb_helix;s_sum++){
				fprintf(fg,"# HELIX NUMBER %2d BEGIN :%c[%c]%8ld\n",s_sum,AAtrans(m->pdbhelix.pdbhelixpos[s_sum].begin_helix_res),m->pdbhelix.pdbhelixpos[s_sum].chain,m->pdbhelix.pdbhelixpos[s_sum].begin_helix);
				fprintf(fg,"# HELIX NUMBER %2d END :  %c[%c]%8ld\n",s_sum,AAtrans(m->pdbhelix.pdbhelixpos[s_sum].end_helix_res),m->pdbhelix.pdbhelixpos[s_sum].chain,m->pdbhelix.pdbhelixpos[s_sum].end_helix);
				fprintf(fg,"# HELIX NUMBER %2d type :    %9d\n",s_sum,m->pdbhelix.pdbhelixpos[s_sum].type_helix);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# BETA NUMBER (SHEET) :     %9d\n",m->pdbbeta.nb_beta);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbbeta.nb_beta;s_sum++){
				fprintf(fg,"# BETA NUMBER %2d BEGIN :%c[%c]%9ld\n",s_sum,AAtrans(m->pdbbeta.pdbbetapos[s_sum].begin_beta_res),m->pdbbeta.pdbbetapos[s_sum].chain,m->pdbbeta.pdbbetapos[s_sum].begin_beta);
				fprintf(fg,"# BETA NUMBER %2d END :  %c[%c]%9ld\n",s_sum,AAtrans(m->pdbbeta.pdbbetapos[s_sum].end_beta_res),m->pdbbeta.pdbbetapos[s_sum].chain,m->pdbbeta.pdbbetapos[s_sum].end_beta);
				fprintf(fg,"# BETA NUMBER %2d type :    %9d\n",s_sum,m->pdbbeta.pdbbetapos[s_sum].type_beta);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# TURN NUMBER (TURN) :      %9d\n",m->pdbturn.nb_turn);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbturn.nb_turn;s_sum++){
				fprintf(fg,"# TURN NUMBER %2d BEGIN : %c[%c]%9ld\n",s_sum,AAtrans(m->pdbturn.pdbturnpos[s_sum].begin_turn_res),m->pdbturn.pdbturnpos[s_sum].chain,m->pdbturn.pdbturnpos[s_sum].begin_turn);
				fprintf(fg,"# TURN NUMBER %2d END :   %c[%c]%9ld\n",s_sum,AAtrans(m->pdbturn.pdbturnpos[s_sum].end_turn_res),m->pdbturn.pdbturnpos[s_sum].chain,m->pdbturn.pdbturnpos[s_sum].end_turn);
				fprintf(fg,"# TURN NUMBER %2d type :     %9d\n",s_sum,m->pdbturn.pdbturnpos[s_sum].type_turn);
				}
			fprintf(fg,"#######################################################\n");				
			
			break;
		case(1):  break;
		case(2):  break;
		case(3):  break;
	}
	of(fg);
}

void SimpleOut(pdbfile *m){
					/****************/
	FILE *fg;			/*    file      */
	long i,s_sum,i21,deb,fin;;			/*     count    */
	char ot[250];
					/****************/

	sprintf(ot,"Results/Rasta/%s.rsy",m->name);
	fg=fecrire(ot);
		
			
	fprintf(fg,"PDB NAME :\t\t\t\t%s\n",m->name);
	fprintf(fg,"RESOLUTION   :\t\t\t    %8.2lf\n",m->resolution);
	fprintf(fg,"DEPOSIT DATE   :\t\t [%s]\n",m->depositdate);
	fprintf(fg,"RELEASE DATE   :\t\t [%s]\n",m->releasedate);
	fprintf(fg,"SEQRES RESIDUE NUMBER :\t\t     %7ld\n",m->pdbseqreschain.nb_res);
	fprintf(fg,"SEQRES CHAIN NUMBER   :\t\t     %7d\n",m->pdbseqreschain.nb_chain);
	fprintf(fg,"STRUCTURE RESIDUE NUMBER :\t     %7ld\n",m->Nb_residues);
	fprintf(fg,"STRUCTURE CHAIN NUMBER :\t     %7d\n",m->NB_chain);
	
	for(s_sum=0;s_sum<m->pdbseqreschain.nb_chain;s_sum++){	
		fprintf(fg,"SEQRES SEQUENCE :\n"); 
		for(i=m->pdbseqreschain.begin_chain[s_sum];i<m->pdbseqreschain.end_chain[s_sum];i++) fprintf(fg,"%c",m->pdbseqres[i].RESIDUE);
		fprintf(fg,"\n");
		
		deb=m->Pos_FirstRes[s_sum];
		fin=m->Pos_LastRes[s_sum];
		
		fprintf(fg,"STRUCTURE SEQUENCE :\n");  			for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->Nam_residues[i21]);		fprintf(fg,"\n");
		fprintf(fg,"PROTEIN BLOCKS SEQUENCE :\n");  		for(i21=deb;i21<fin;i21++)  	fprintf(fg,"%c",BPtrans(m->Assign_PB[i21]));	fprintf(fg,"\n");
		if(LECT_DSSP=='T'){fprintf(fg,"DSSP SEQUENCE :\n"); 	for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2dssp[i21]);		fprintf(fg,"\n");}		
		if(LECT_DEFINE=='T'){fprintf(fg,"DEFINE SEQUENCE :\n");	for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2define[i21]);		fprintf(fg,"\n");}
		if(LECT_PCURVE=='T'){fprintf(fg,"PCURVE SEQUENCE :\n"); for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2pcurve[i21]);		fprintf(fg,"\n");}
		if(LECT_STRIDE=='T'){fprintf(fg,"STRIDE SEQUENCE :\n");	for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2stride[i21]);		fprintf(fg,"\n");}
		if(LECT_SEA=='T'){fprintf(fg,"PSEA SEQUENCE :\n");	for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2sea[i21]);			fprintf(fg,"\n");}
		if(LECT_xtlsstr=='T'){fprintf(fg,"XTLSSTR SEQUENCE :\n");for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2xtlsstr[i21]);		fprintf(fg,"\n");}	
		if(Fodje=='T'){fprintf(fg,"SECSTR SEQUENCE :\n");	for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2Fodje[i21]);		fprintf(fg,"\n");}
		if(HELANAL=='T'){fprintf(fg,"HELANAL [DSSP] SEQUENCE :\n");for(i21=deb;i21<fin;i21++)	fprintf(fg,"%c",m->S2dssphel[i21]);		fprintf(fg,"\n");}
		if(RKstr=='T'){fprintf(fg,"EXTENDED BETA [DSSP] SEQUENCE :\n");for(i21=deb;i21<fin;i21++)fprintf(fg,"%c",m->S2RKdssp[i21]);		fprintf(fg,"\n");}
		}
			
			for(s_sum=0;s_sum<m->pdbseqreschain.nb_chain;s_sum++){
				fprintf(fg,"# CHAIN NUMBER %2ld BEGIN :   %9ld\n",s_sum,m->pdbseqreschain.begin_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2ld END :     %9ld\n",s_sum,m->pdbseqreschain.end_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2ld LENGTH :  %9ld\n",s_sum,m->pdbseqreschain.length_chain[s_sum]);
				fprintf(fg,"# CHAIN NUMBER %2ld (SEQRES) :%9ld\n",s_sum,m->pdbseqres[m->pdbseqreschain.end_chain[s_sum]].chain_length);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# HELIX NUMBER (HELIX) :    %9d\n",m->pdbhelix.nb_helix);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbhelix.nb_helix;s_sum++){
				fprintf(fg,"# HELIX NUMBER %2ld BEGIN :%c[%c]%8ld\n",s_sum,AAtrans(m->pdbhelix.pdbhelixpos[s_sum].begin_helix_res),m->pdbhelix.pdbhelixpos[s_sum].chain,m->pdbhelix.pdbhelixpos[s_sum].begin_helix);
				fprintf(fg,"# HELIX NUMBER %2ld END :  %c[%c]%8ld\n",s_sum,AAtrans(m->pdbhelix.pdbhelixpos[s_sum].end_helix_res),m->pdbhelix.pdbhelixpos[s_sum].chain,m->pdbhelix.pdbhelixpos[s_sum].end_helix);
				fprintf(fg,"# HELIX NUMBER %2ld type :    %9d\n",s_sum,m->pdbhelix.pdbhelixpos[s_sum].type_helix);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# BETA NUMBER (SHEET) :     %9d\n",m->pdbbeta.nb_beta);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbbeta.nb_beta;s_sum++){
				fprintf(fg,"# BETA NUMBER %2ld BEGIN :%c[%c]%9ld\n",s_sum,AAtrans(m->pdbbeta.pdbbetapos[s_sum].begin_beta_res),m->pdbbeta.pdbbetapos[s_sum].chain,m->pdbbeta.pdbbetapos[s_sum].begin_beta);
				fprintf(fg,"# BETA NUMBER %2ld END :  %c[%c]%9ld\n",s_sum,AAtrans(m->pdbbeta.pdbbetapos[s_sum].end_beta_res),m->pdbbeta.pdbbetapos[s_sum].chain,m->pdbbeta.pdbbetapos[s_sum].end_beta);
				fprintf(fg,"# BETA NUMBER %2ld type :    %9d\n",s_sum,m->pdbbeta.pdbbetapos[s_sum].type_beta);
				}
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"#######################################################\n");				
			fprintf(fg,"# TURN NUMBER (TURN) :      %9d\n",m->pdbturn.nb_turn);
			fprintf(fg,"#######################################################\n");
			for(s_sum=0;s_sum<m->pdbturn.nb_turn;s_sum++){
				fprintf(fg,"# TURN NUMBER %2ld BEGIN : %c[%c]%9ld\n",s_sum,AAtrans(m->pdbturn.pdbturnpos[s_sum].begin_turn_res),m->pdbturn.pdbturnpos[s_sum].chain,m->pdbturn.pdbturnpos[s_sum].begin_turn);
				fprintf(fg,"# TURN NUMBER %2ld END :   %c[%c]%9ld\n",s_sum,AAtrans(m->pdbturn.pdbturnpos[s_sum].end_turn_res),m->pdbturn.pdbturnpos[s_sum].chain,m->pdbturn.pdbturnpos[s_sum].end_turn);
				fprintf(fg,"# TURN NUMBER %2ld type :     %9d\n",s_sum,m->pdbturn.pdbturnpos[s_sum].type_turn);
				}
			fprintf(fg,"#######################################################\n");				
			
			
			
}
