# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/lib_local_secstr.h"
# include "../LECTURE_SOFT/comparison.h"


void Molscriptage_formov(pdbfile *m);

/*
! MolScript v2.1 input file
! generated by MolAuto v1.1.1

title "DEFINE"

plot
  background  rgb 1 1 1;
  read mol "XmMol.pdb";
  
  transform atom * by centre position atom *
  	by translation 10 0 0;
	
  set planecolour rgb 0 0 0;
  set specularcolour white;
  set segments 2;

  set planecolour hsb 0.6667 1 1;
  coil from 2 to 5;
  set planecolour hsb 0 1 1;
  helix from 5 to 16;
  set planecolour hsb 0.2456 1 1;
  strand from 16 to 19;
  set planecolour hsb 0.6667 1 1;
  coil from 19 to 25;
  set planecolour hsb 0 1 1;
  helix from 24 to 47;
  set planecolour hsb 0.2456 1 1;
  strand from 47 to 51;
  set planecolour hsb 0 1 1;
  helix from 51 to 86;

end_plot
*/

int LocalPB(int a){
	int bre=1;
	
	/*bre=a+3;*/	/* experience color => 17-04-2004*/
	if(a<0) bre=1;
	if(a==12) bre=0;
	if((a==2)||(a==3)) bre=2;
	/*if(a==3) bre=2;*/

	return(bre);
}

void write_deb_rotation(FILE *f0, char *title, char *pdbfich,double rotay){

	fprintf(f0,"! MolScript input file\n");
	fprintf(f0,"! generated by PDB reader\n\n");

	fprintf(f0,"title \"%s\"\n\n",title);

	fprintf(f0,"plot\n");
	
	fprintf(f0,"  background  rgb 1 1 1;\n");
	fprintf(f0,"  read mol \"%s\";\n\n",pdbfich);

	fprintf(f0,"! here for the transformation matrix\n  \n\n");
	 fprintf(f0,"  transform atom *\n");
	 fprintf(f0,"      by centre position atom *\n");
	 fprintf(f0,"      by rotation y %4.1lf;\n",rotay);
	
	fprintf(f0,"  set planecolour rgb 0 0 0;\n");
	fprintf(f0,"  set specularcolour white;\n");
	fprintf(f0,"  set segments 2;\n\n\n");


}


void write_deb(FILE *f0, char *title, char *pdbfich){

	FILE *f1;
	char buff[Lg_buffer];

	fprintf(f0,"! MolScript input file\n");
	fprintf(f0,"! generated by PDB reader\n\n");

	fprintf(f0,"title \"%s\"\n\n",title);

	fprintf(f0,"plot\n");
	
	fprintf(f0,"  background  rgb 1 1 1;\n");
	fprintf(f0,"  read mol \"%s\";\n\n",pdbfich);
  
  	if(MolTrans=='F'){
	fprintf(f0,"! here for the transformation matrix\n  transform atom * by centre position atom *;\n\n");
	}
	else {
	/*mettre tout : 
	  transform atom *
	    by centre position atom *
	    by rotation x 180.0
	    by rotation x -56.8819
	    by rotation y 13.7420
	    by rotation z -55.0029;*/
	
	f1=fopen(rot3Dmolscr,"r");
	while(fgets(buff,Lg_buffer,f1)!=NULL){
		fprintf(f0,"%s",buff);
		/*printf("%s",buff);*/
		}
	fprintf(f0,"\n");
	fclose(f1);
	}
	
	fprintf(f0,"  set planecolour rgb 0 0 0;\n");
	fprintf(f0,"  set specularcolour white;\n");
	fprintf(f0,"  set segments 2;\n\n\n");


}

void write_newline(pdbfile *m,FILE *f0, long hcb, long ideb,long ifin, int colo){
	long deb,fin;
	
	if(colo==0) fprintf(f0,"  set planecolour rgb 1 1 1;\n");

	/* rouge : helice red */
	/* bleu : coil dodgerblue */
	/* vert : feuillet : springgreen*/

	deb=m->pdbatomtype[m->deb_residues[ideb]].ATOM_residuesnumber;
	fin=m->pdbatomtype[m->deb_residues[ifin]].ATOM_residuesnumber;
	
	switch (hcb){
		case (0) : 	if(colo==1) fprintf(f0,"  set planecolour red;\n");
				fprintf(f0,"  helix from %ld to %ld;\n",deb,fin);	 break;
		case (1) : 	if(colo==1) fprintf(f0,"  set planecolour dodgerblue;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (2) : 	if(colo==1) fprintf(f0,"  set planecolour springgreen;\n");
				fprintf(f0,"  strand from %ld to %ld;\n",deb,fin);	break;
		/*17-04-2004 color experience */
		case (7) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.8 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (8) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.6 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (9) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.4 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (10) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.2 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (11) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.0 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (12) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.25 0.0 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (13) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.50 0.0 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (14) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.75 0.0 0.0;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
				/* m => 15 /alpha */
		case (16) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.75 0.25 0.25;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (17) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.50 0.25 0.50;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (18) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.25 0.25 0.50;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (3) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.25 0.25 0.50;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (4) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.50 0.50;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		case (5) : 	if(colo==1) fprintf(f0,"  set planecolour rgb 0.0 0.75 0.25;\n");
				fprintf(f0,"  coil from %ld to %ld;\n",deb,fin);	break;
		default : printf("Molscript !!! PB color avec %ld undefined\n",hcb);	break;
	}
}

void end_plot(FILE *f0){
	fprintf(f0,"end_plot\n");
	fclose(f0);
}

void do_script(char *fich,char *name, char *ps){
	FILE *f1;

	f1=fopen(fich,"a+");
	
	fprintf(f1,"molscript < %s > %s.ps\n\n",name,ps);

	fprintf(f1,"molscript -r < %s > %s.r3d\n",name,ps);
	fprintf(f1,"cat %s.r3d | render | display avs:- ;\n\n",ps);

	fclose(f1);
}

void do_scriptv2(char *fich,char *name, char *ps){
	FILE *f1;
	char b[250];
	f1=fopen(fich,"a+");
	
	fprintf(f1,"molscript < %s > %s.ps\n\n",name,ps);
	sprintf(b,"/home/glenan/logiciels/molscript-2.1.2/molscript  < Results/Rasmol/%s > Results/Rasmol/%s.ps\n",name,ps);
	system(b);
	sprintf(b,"convert Results/Rasmol/%s.ps Results/Rasmol/a_%s.jpg \n",ps,ps);
	system(b);
	
	fprintf(f1,"molscript -r < %s > %s.r3d\n",name,ps);
	fprintf(f1,"cat %s.r3d | render | display avs:- ;\n\n",ps);

	fclose(f1);
}

void do_script2(char *fich,char *name, char *ps){
	FILE *f1;

	f1=fopen(fich,"a+");
	
/*	fprintf(f1,"molscript2 < %s > %s.ps\n\n",name,ps);*/

	fprintf(f1,"molscript -r < %s > %s.r3d\n",name,ps);
	fprintf(f1,"cat %s.r3d | render2 -jpeg -quality 100 > %s.jpg\n\n",ps,name);

	fclose(f1);
}

void do_script2v2(char *fich,char *name, char *ps){
	char b[250];
	sprintf(b,"/home/glenan/logiciels/molscript-2.1.2/molscript -r < Results/Rasmol/%s > Results/Rasmol/%s.r3d\n",name,ps);
	system(b);
	sprintf(b,"cat Results/Rasmol/%s.r3d | /home/glenan/logiciels/Raster3D/bin/render2 -jpeg -quality 100 > Results/XYZ/%s.jpg\n\n",ps,name);
	system(b);

}

void do_script3(char *fich,char *name, double rotay){
	FILE *f1;
	f1=fopen(fich,"a+");
	if(rotay<0.45)	fprintf(f1,"\nconvert ");
	fprintf(f1," %s.jpg ",name);
	fclose(f1);
}

void do_script3part2(char *fich,char *name){
	FILE *f1;
	f1=fopen(fich,"a+");
	fprintf(f1," %s.mpg \n ",name);
	fclose(f1);
}

/*********************************************************************************************/
/*	Sortie de fichier Molscript		             				     */
/*********************************************************************************************/

void Molscriptage(pdbfile *m){
	
	FILE *fmol;
	long mol_i,mol_y,u_mol;
	char buffer[250];
	char buffer2[250];

	long deb;
	char S2[50];
	long state_in_use=-1;	
	long new_state_three=-1;
	int color=0;
	long limit=8;
	
	for(color=0;color<2;color++){
	for(u_mol=0;u_mol<limit;u_mol++){
		if((LECT_DSSP!='T')&&(u_mol==0))u_mol++;
		if((LECT_STRIDE!='T')&&(u_mol==1))u_mol++;		
		if((LECT_SEA!='T')&&(u_mol==2))u_mol++;
		if((LECT_DEFINE!='T')&&(u_mol==3))u_mol++;
		if((LECT_PCURVE!='T')&&(u_mol==4))u_mol++;
		if((LECT_xtlsstr!='T')&&(u_mol==5))u_mol++;
		if((Fodje!='T')&&(u_mol==6))u_mol++;
		
		if(u_mol<limit){
		for(mol_y=0;mol_y<((m->NB_chain)+1);mol_y++){
			
			if(u_mol==0) sprintf(S2,"DSSP");
			if(u_mol==1) sprintf(S2,"STRIDE");
			if(u_mol==2) sprintf(S2,"PSEA");
			if(u_mol==3) sprintf(S2,"DEFINE");
			if(u_mol==4) sprintf(S2,"PCURVE");
			if(u_mol==5) sprintf(S2,"XTLSSTR");
			if(u_mol==6) sprintf(S2,"FODJE");
			if(u_mol==7) sprintf(S2,"PB");
			
			printf("Molscript |%s|\n",S2);
			sprintf(buffer,"Results/Rasmol/molscript_%s_%s_%ld_%d.in",S2,m->name,mol_y,color);
			fmol=fopen(buffer,"w");
			sprintf(buffer2,"%s_%ld.pdb",m->name,mol_y);
			write_deb(fmol,S2,buffer2);		
			sprintf(buffer2,"Results/Rasmol/%s_%ld.pdb",m->name,mol_y);
			write_chain_pdb(m, buffer2, mol_y);
			deb=m->Pos_FirstRes[mol_y];
			
			if(u_mol==0) state_in_use=TroisEtatsDssp(m->S2dssp[m->Pos_FirstRes[mol_y]]);
			if(u_mol==1) state_in_use=TroisEtatsDssp(m->S2stride[m->Pos_FirstRes[mol_y]]);
			if(u_mol==2) state_in_use=TroisEtatsPsea(m->S2sea[m->Pos_FirstRes[mol_y]]);
			if(u_mol==3) state_in_use=TroisEtatsDefine(m->S2define[m->Pos_FirstRes[mol_y]]);
			if(u_mol==4) state_in_use=TroisEtatsPcurve(m->S2pcurve[m->Pos_FirstRes[mol_y]]);
			if(u_mol==5) state_in_use=TroisEtatsxtls(m->S2xtlsstr[m->Pos_FirstRes[mol_y]]);
			if(u_mol==6) state_in_use=TroisEtatsFodje(m->S2Fodje[m->Pos_FirstRes[mol_y]]);
			if(u_mol==7) state_in_use=LocalPB(m->Assign_PB[m->Pos_FirstRes[mol_y]]);
			
			for(mol_i=m->Pos_FirstRes[mol_y]+1;mol_i<m->Pos_LastRes[mol_y];mol_i++){
			
				if(u_mol==0) new_state_three=TroisEtatsDssp(m->S2dssp[mol_i]);
				if(u_mol==1) new_state_three=TroisEtatsDssp(m->S2stride[mol_i]);
				if(u_mol==2) new_state_three=TroisEtatsPsea(m->S2sea[mol_i]);
				if(u_mol==3) new_state_three=TroisEtatsDefine(m->S2define[mol_i]);
				if(u_mol==4) new_state_three=TroisEtatsPcurve(m->S2pcurve[mol_i]);
				if(u_mol==5) new_state_three=TroisEtatsxtls(m->S2xtlsstr[mol_i]);
				if(u_mol==6) new_state_three=TroisEtatsFodje(m->S2Fodje[mol_i]);
				if(u_mol==7) new_state_three=LocalPB(m->Assign_PB[mol_i]);
				
				
				if(state_in_use!=new_state_three){
						if((u_mol==7)&&(mol_i-deb<2)&&(state_in_use!=1)) {write_newline(m,fmol,state_in_use,deb,mol_i+1,color);						mol_i++;}
						else write_newline(m,fmol,state_in_use,deb,mol_i,color);
						deb=mol_i;state_in_use=new_state_three;
					}
				}
			if(deb!=mol_i-1)write_newline(m,fmol,state_in_use,deb,mol_i-1,color);	
			end_plot(fmol);
			sprintf(buffer,"molscript_%s_%s_%ld_%d.in",S2,m->name,mol_y,color);	
			sprintf(buffer2,"%s_%s_%ld_%d.in",S2,m->name,mol_y,color);
			do_script("Results/Rasmol/molscript.scr",buffer,buffer2);
			do_script2("Results/Rasmol/molscript2.scr",buffer,buffer2);
			}
		}	
	}
	}

	if(MOLVID=='T')Molscriptage_formov(m);
}

void Molscriptage_formov(pdbfile *m){
	
	FILE *fmol;
	long mol_i,mol_y,u_mol;
	char buffer[250];
	char buffer2[250];

	long deb;
	char S2[50];
	long state_in_use=-1;	
	long new_state_three=-1;
	int color=0;
	long limit=8;
	double rot=1.0;
	
	
	for(color=0;color<2;color++){
	for(u_mol=0;u_mol<limit;u_mol++){
	for(rot=0.0;rot<360.0;rot+=1.0){
		if((LECT_DSSP!='T')&&(u_mol==0))u_mol++;
		if((LECT_STRIDE!='T')&&(u_mol==1))u_mol++;		
		if((LECT_SEA!='T')&&(u_mol==2))u_mol++;
		if((LECT_DEFINE!='T')&&(u_mol==3))u_mol++;
		if((LECT_PCURVE!='T')&&(u_mol==4))u_mol++;
		if((LECT_xtlsstr!='T')&&(u_mol==5))u_mol++;
		if((Fodje!='T')&&(u_mol==6))u_mol++;
		
		if(u_mol<limit){
		for(mol_y=0;mol_y<((m->NB_chain)+1);mol_y++){
			
			if(u_mol==0) sprintf(S2,"DSSP");
			if(u_mol==1) sprintf(S2,"STRIDE");
			if(u_mol==2) sprintf(S2,"PSEA");
			if(u_mol==3) sprintf(S2,"DEFINE");
			if(u_mol==4) sprintf(S2,"PCURVE");
			if(u_mol==5) sprintf(S2,"XTLSSTR");
			if(u_mol==6) sprintf(S2,"FODJE");
			if(u_mol==7) sprintf(S2,"PB");
			
			printf("Molscript |%s [%lf]|\n",S2,rot);
			sprintf(buffer,"Results/Rasmol/molscript_%s_rotate_%s_%ld_%d.in_%lf",S2,m->name,mol_y,color,rot);
			fmol=fopen(buffer,"w");
			sprintf(buffer2,"%s_%ld.pdb",m->name,mol_y);
			write_deb_rotation(fmol,S2,buffer2,rot);		
			sprintf(buffer2,"%s_%ld.pdb",m->name,mol_y);
			write_chain_pdb(m, buffer2, mol_y);
			deb=m->Pos_FirstRes[mol_y];
			
			if(u_mol==0) state_in_use=TroisEtatsDssp(m->S2dssp[m->Pos_FirstRes[mol_y]]);
			if(u_mol==1) state_in_use=TroisEtatsDssp(m->S2stride[m->Pos_FirstRes[mol_y]]);
			if(u_mol==2) state_in_use=TroisEtatsPsea(m->S2sea[m->Pos_FirstRes[mol_y]]);
			if(u_mol==3) state_in_use=TroisEtatsDefine(m->S2define[m->Pos_FirstRes[mol_y]]);
			if(u_mol==4) state_in_use=TroisEtatsPcurve(m->S2pcurve[m->Pos_FirstRes[mol_y]]);
			if(u_mol==5) state_in_use=TroisEtatsxtls(m->S2xtlsstr[m->Pos_FirstRes[mol_y]]);
			if(u_mol==6) state_in_use=TroisEtatsFodje(m->S2Fodje[m->Pos_FirstRes[mol_y]]);
			if(u_mol==7) state_in_use=LocalPB(m->Assign_PB[m->Pos_FirstRes[mol_y]]);
			
			for(mol_i=m->Pos_FirstRes[mol_y]+1;mol_i<m->Pos_LastRes[mol_y];mol_i++){
			
				if(u_mol==0) new_state_three=TroisEtatsDssp(m->S2dssp[mol_i]);
				if(u_mol==1) new_state_three=TroisEtatsDssp(m->S2stride[mol_i]);
				if(u_mol==2) new_state_three=TroisEtatsPsea(m->S2sea[mol_i]);
				if(u_mol==3) new_state_three=TroisEtatsDefine(m->S2define[mol_i]);
				if(u_mol==4) new_state_three=TroisEtatsPcurve(m->S2pcurve[mol_i]);
				if(u_mol==5) new_state_three=TroisEtatsxtls(m->S2xtlsstr[mol_i]);
				if(u_mol==6) new_state_three=TroisEtatsFodje(m->S2Fodje[mol_i]);
				if(u_mol==7) new_state_three=LocalPB(m->Assign_PB[mol_i]);
				
				
				if(state_in_use!=new_state_three) {
						if((u_mol==7)&&(mol_i-deb<2)&&(state_in_use!=1)) {write_newline(m,fmol,state_in_use,deb,mol_i+1,color);mol_i++;}
						else write_newline(m,fmol,state_in_use,deb,mol_i,color);
						deb=mol_i;state_in_use=new_state_three;
						
					}
				}
			if(deb!=mol_i-1)write_newline(m,fmol,state_in_use,deb,mol_i-1,color);	
			end_plot(fmol);
			sprintf(buffer,"molscript_%s_rotate_%s_%ld_%d.in_%lf",S2,m->name,mol_y,color,rot);	
			sprintf(buffer2,"molscript_%s_rotate_%s_%ld_%d_for.%lf",S2,m->name,mol_y,color,rot);
			do_scriptv2("Results/Rasmol/rotate_molscript.scr",buffer,buffer2);
			do_script2v2("Results/Rasmol/rotate_molscript2.scr",buffer,buffer2);
			do_script3("Results/Rasmol/rotate_molscript3.scr",buffer,rot);
			}
		}	
	}
	sprintf(buffer2,"mov_%s_%s_%d",m->name,S2,color);
	do_script3part2("Results/Rasmol/rotate_molscript3.scr",buffer2);
	}
}	

}
