# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"




void distfollow(double **A,char *name,long lg){
	FILE *f0;
	long i;
	
	f0=fecrire(name);
	for(i=0;i<lg-1;i++){
		fprintf(f0," %8.3lf\n",sqrt(distance_intercarbone(A[i+1][0],A[i+1][1],A[i+1][2],A[i][0],A[i][1],A[i][2])));
	}
	of(f0);
}


void add_toCalpaha(FILE *f0, long taill_frag, long *begin,double *X, double *Y, double *Z){
	long i;
	for(i=0;i<taill_frag;i++){
			fprintf(f0,"ATOM    %3.0ld %3s %4s %c%4ld",i+(*begin),"CA ","GLY",'A',i+(*begin));
			fprintf(f0,"   %8.3f%8.3f%8.3f  1.00 19.19             %c\n",X[i],Y[i],Z[i],'C');
			}
}

void add_toConnect(FILE *f0, long taill_frag, long *begin,double *X, double *Y, double *Z){
	long i;
	for(i=0;i<(taill_frag-1);i++)
	fprintf(f0,"CONECT %4ld %4ld\n",i+(*begin),i+(*begin)+1);
	(*begin)+=taill_frag;
}


void MoyenneBary(long lgseq,double **BaryInterm,double **Bary,long lgfrag){
	
	long i,jk,dep,pos;
	
	for(i=0;i<lgseq;i++){
		pos=0;
		for(dep=0;dep<lgfrag;dep++){
				if(BaryInterm[i][3*dep]<990.0){
					/*printf("%8.3lf %8.3lf %8.3lf",BaryInterm[i][3*dep],BaryInterm[i][3*dep+1],BaryInterm[i][3*dep+2]);*/
					Bary[i][0]+=BaryInterm[i][3*dep];
					Bary[i][1]+=BaryInterm[i][3*dep+1];
					Bary[i][2]+=BaryInterm[i][3*dep+2];
					pos++;
			}
		}
		for(jk=0;jk<3;jk++){
			Bary[i][jk]/=(double)pos;
			/*printf("[%8.3lf]",Bary[i][jk]);*/
		}
			/*printf("\n");*/

	}	
}

void MoyenneBarySup(long lgseq,double **BaryInterm,double **Calpha,double **Bary,long lgfrag){
	
	long i,dep;
	double dd,minim;
	
	for(i=0;i<lgseq;i++){
		dd=0.0;
		minim=2598.23;
			for(dep=0;dep<lgfrag;dep++){
				if(BaryInterm[i][3*dep]<990.0){
					dd=distance_intercarbone(BaryInterm[i][3*dep],BaryInterm[i][3*dep+1],BaryInterm[i][3*dep+2],Calpha[i][0],Calpha[i][1],Calpha[i][2]);
					/*printf("%8.3lf %8.3lf %8.3lf (%8.3lf-%8.3lf)",BaryInterm[i][3*dep],BaryInterm[i][3*dep+1],BaryInterm[i][3*dep+2],dd,minim);*/
					if(dd<minim){
						Bary[i][0]=BaryInterm[i][3*dep];
						Bary[i][1]=BaryInterm[i][3*dep+1];
						Bary[i][2]=BaryInterm[i][3*dep+2];
						minim=dd;
					/*printf("[%8.3lf %8.3lf %8.3lf]",Bary[i][0],Bary[i][1],Bary[i][2]);	*/
					}
				}
			}
		/*printf("\n");*/
	}
}

void CopieCalpha(double **Calpha,long chaine_use,pdbfile *m){
	
	long residu_A,pos;
	
	for(residu_A=m->Pos_FirstRes[chaine_use];residu_A<m->Pos_LastRes[chaine_use];residu_A++){
		pos=m->deb_residues[residu_A]+1;
		Calpha[residu_A-m->Pos_FirstRes[chaine_use]][0]=m->pdbatomtype[pos].ATOM_CoordX;
		Calpha[residu_A-m->Pos_FirstRes[chaine_use]][1]=m->pdbatomtype[pos].ATOM_CoordY;
		Calpha[residu_A-m->Pos_FirstRes[chaine_use]][2]=m->pdbatomtype[pos].ATOM_CoordZ;				
		}
}	

void rec(pdbfile *m){
	FILE *filetoread;
	FILE *filetopdbwrite;
	FILE *fildconect;
	FILE *all;
	int chaine_use=0;
	long residu_A=0;
	long begin=1;
	long lgseq=0;
	char buffy[250];
	long i,ik,jk,pos,dep;
	double X1[5],Y1[5],Z1[5];
	double X2[5],Y2[5],Z2[5];
	
	double **Calpha;
	double **Bary;
	double **BaryInterm;
	
	double **localrmsd;	
	int minim;
	double minimrmsd;
	
/*	int *frozy;*/
		
	all=fSurecrire("Results/XYZ/all.rms");
	
	if(Werboze=='T')  printf("Work on reconstruction \n");
	
	chaine_use=0;	/* a modifier */

	if((CHAIN!='-')&&(CHAIN!='_'))	{chaine_use=(int)(CHAIN)-(int)('A');}
	else{chaine_use=0;}
	lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use]));
	if(lgseq<10) printf("chain %d (m->Pos_LastRes[chaine_use]) %ld (m->Pos_FirstRes[chaine_use]) %ld\n",chaine_use,(m->Pos_LastRes[chaine_use]),(m->Pos_FirstRes[chaine_use]));
	
	localrmsd=AllocMemoireDblDbl_By_Long(lgseq,5);
	
	fprintf(all,"%4ld\t",lgseq);
	
	/*****************************************************************************************************************************/
	/*****************************************************************************************************************************/
		
	/*********/
	/* PB 16 */	
	/*********/
	
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	BaryInterm=AllocMemoireDblDbl_By_Long(lgseq,3*5);
	for(i=0;i<lgseq;i++) for(jk=0;jk<15;jk++)BaryInterm[i][jk]=(999.00);
	
	if(Werboze=='T')  printf("Recherche brute \n");
	
	filetopdbwrite=fecrire("Results/XYZ/super.pdb");
	fildconect=fecrire("Results/XYZ/superC.pdb");
	fprintf(filetopdbwrite,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',lgseq+1,1.0);
	
	dep=0;
	
	for(residu_A=m->Pos_FirstRes[chaine_use]+2;residu_A<m->Pos_LastRes[chaine_use]-2;residu_A++){
		sprintf(buffy,"CODE/DATA/Protein_Blocks/x%d.txt",m->Assign_PB[residu_A]);
		filetoread=flire(buffy);		
		
		for(jk=0;jk<5;jk++){fscanf(filetoread,"%lf\n",&X1[jk]);fscanf(filetoread,"%lf\n",&Y1[jk]);fscanf(filetoread,"%lf\n",&Z1[jk]);}
		of(filetoread);		
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);

		localrmsd[residu_A][0]=rmsd(X2,Y2,Z2,X1,Y1,Z1,5);

		add_toCalpaha(filetopdbwrite,5,&begin,X1,Y1,Z1);
		add_toConnect(fildconect,5,&begin,X1,Y1,Z1);
	
		for(jk=0;jk<5;jk++){
			pos=jk+residu_A-2;
			BaryInterm[pos][3*dep]=X1[jk];	BaryInterm[pos][3*dep+1]=Y1[jk]; BaryInterm[pos][3*dep+2]=Z1[jk];
		}
		dep++;	if(dep>4)dep=0;
	}
	
	fprintf(fildconect,"END\n");
	fclose(filetopdbwrite);
	fclose(fildconect);
	
	sprintf(buffy,"cat Results/XYZ/super.pdb Results/XYZ/superC.pdb > Results/XYZ/%s_%d_v1.pdb ",m->name,chaine_use );
	system(buffy);
	
	MoyenneBary(lgseq,BaryInterm,Bary,5);

	Calpha=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	CopieCalpha(Calpha,chaine_use,m);
	
	printf("rmsd final (PB superpos.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	
	sprintf(buffy,"Results/XYZ/%s_%d_v2.pdb",m->name,chaine_use );
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);
	
	sprintf(buffy,"Results/XYZ/dist%s_%d_v2.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);
	
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	MoyenneBarySup(lgseq,BaryInterm,Calpha,Bary,5);

	printf("rmsd final (PB superpo2.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	
	sprintf(buffy,"Results/XYZ/%s_%d_v3.pdb",m->name,chaine_use );

	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	
	
	

	sprintf(buffy,"Results/XYZ/dist%s_%d_v3.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);
	
	DesallocMemoireDblDbl_By_Long(Calpha,lgseq);
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	DesallocMemoireDblDbl_By_Long(BaryInterm,lgseq);
	
	/*****************************************************************************************************************************/
	/*****************************************************************************************************************************/
		
	/****************/
	/* K20 Kolodony */	
	/****************/
	
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	BaryInterm=AllocMemoireDblDbl_By_Long(lgseq,3*5);
	for(i=0;i<lgseq;i++) for(jk=0;jk<15;jk++)BaryInterm[i][jk]=(999.00);
	
	if(Werboze=='T')  printf("Recherche brute \n");
	
	filetopdbwrite=fecrire("Results/XYZ/superK20.pdb");
	fildconect=fecrire("Results/XYZ/superCK20.pdb");
	fprintf(filetopdbwrite,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',lgseq+1,1.0);
	
	dep=0;
	
	for(residu_A=m->Pos_FirstRes[chaine_use]+2;residu_A<m->Pos_LastRes[chaine_use]-2;residu_A++){
		
		minimrmsd=5895.0;
		minim=0;
		for(ik=0;ik<20;ik++){
		for(jk=0;jk<5;jk++){ X1[jk]=Kolodny_20_5[ik][jk][0];	Y1[jk]=Kolodny_20_5[ik][jk][1]; Z1[jk]=Kolodny_20_5[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		if(minimrmsd>rmsd(X1,Y1,Z1,X2,Y2,Z2,5)){minimrmsd=rmsd(X1,Y1,Z1,X2,Y2,Z2,5);minim=ik;}
		}
		
		ik=minim;
		for(jk=0;jk<5;jk++){ X1[jk]=Kolodny_20_5[ik][jk][0];	Y1[jk]=Kolodny_20_5[ik][jk][1]; Z1[jk]=Kolodny_20_5[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		localrmsd[residu_A][1]=rmsd(X2,Y2,Z2,X1,Y1,Z1,5);
				
		add_toCalpaha(filetopdbwrite,5,&begin,X1,Y1,Z1);
		add_toConnect(fildconect,5,&begin,X1,Y1,Z1);
	
		for(jk=0;jk<5;jk++){
			pos=jk+residu_A-2;
			BaryInterm[pos][3*dep]=X1[jk];	BaryInterm[pos][3*dep+1]=Y1[jk]; BaryInterm[pos][3*dep+2]=Z1[jk];
		}
		dep++;	if(dep>4)dep=0;
	}
	
	fprintf(fildconect,"END\n");
	fclose(filetopdbwrite);
	fclose(fildconect);
	
	sprintf(buffy,"cat Results/XYZ/superK20.pdb Results/XYZ/superCK20.pdb > Results/XYZ/K20%s_%d_v1.pdb ",m->name,chaine_use );
	system(buffy);
	
	MoyenneBary(lgseq,BaryInterm,Bary,5);

	Calpha=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	CopieCalpha(Calpha,chaine_use,m);
	
	printf("rmsd final (K20 superpo.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	
	sprintf(buffy,"Results/XYZ/K20%s_%d_v2.pdb",m->name,chaine_use );
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_K20_%s_%d_v2.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	MoyenneBarySup(lgseq,BaryInterm,Calpha,Bary,5);

	printf("rmsd final (K20 superp2.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	
	sprintf(buffy,"Results/XYZ/K20%s_%d_v3.pdb",m->name,chaine_use );

	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);
	
	sprintf(buffy,"Results/XYZ/dist_K20_%s_%d_v3.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);
	

	DesallocMemoireDblDbl_By_Long(Calpha,lgseq);
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	DesallocMemoireDblDbl_By_Long(BaryInterm,lgseq);
	
	/* K10 Kolodony */	

	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	BaryInterm=AllocMemoireDblDbl_By_Long(lgseq,3*5);
	for(i=0;i<lgseq;i++) for(jk=0;jk<15;jk++)BaryInterm[i][jk]=(999.00);
	
	if(Werboze=='T')  printf("Recherche brute \n");
	
	filetopdbwrite=fecrire("Results/XYZ/superK10.pdb");
	fildconect=fecrire("Results/XYZ/superCK10.pdb");
	fprintf(filetopdbwrite,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',lgseq+1,1.0);
	
	dep=0;
	
	for(residu_A=m->Pos_FirstRes[chaine_use]+2;residu_A<m->Pos_LastRes[chaine_use]-2;residu_A++){
		
		minimrmsd=5895.0;
		minim=0;
		for(ik=0;ik<10;ik++){
		for(jk=0;jk<5;jk++){ X1[jk]=Kolodny_10_5[ik][jk][0];	Y1[jk]=Kolodny_10_5[ik][jk][1]; Z1[jk]=Kolodny_10_5[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		if(minimrmsd>rmsd(X1,Y1,Z1,X2,Y2,Z2,5)){minimrmsd=rmsd(X1,Y1,Z1,X2,Y2,Z2,5);minim=ik;}
		}
		
		ik=minim;
		for(jk=0;jk<5;jk++){ X1[jk]=Kolodny_10_5[ik][jk][0];	Y1[jk]=Kolodny_10_5[ik][jk][1]; Z1[jk]=Kolodny_10_5[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		localrmsd[residu_A][2]=rmsd(X2,Y2,Z2,X1,Y1,Z1,5);
				
		add_toCalpaha(filetopdbwrite,5,&begin,X1,Y1,Z1);
		add_toConnect(fildconect,5,&begin,X1,Y1,Z1);
	
		for(jk=0;jk<5;jk++){
			pos=jk+residu_A-2;
			BaryInterm[pos][3*dep]=X1[jk];	BaryInterm[pos][3*dep+1]=Y1[jk]; BaryInterm[pos][3*dep+2]=Z1[jk];
		}
		dep++;	if(dep>4)dep=0;
	}
	
	fprintf(fildconect,"END\n");
	fclose(filetopdbwrite);
	fclose(fildconect);
	
	sprintf(buffy,"cat Results/XYZ/superK10.pdb Results/XYZ/superCK10.pdb > Results/XYZ/K10%s_%d_v1.pdb ",m->name,chaine_use );
	system(buffy);
	
	MoyenneBary(lgseq,BaryInterm,Bary,5);

	Calpha=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	CopieCalpha(Calpha,chaine_use,m);
	
	printf("rmsd final (K10 superpo.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	sprintf(buffy,"Results/XYZ/K10_%s_%d_v2.pdb",m->name,chaine_use );
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_K10_%s_%d_v2.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	MoyenneBarySup(lgseq,BaryInterm,Calpha,Bary,5);

	printf("rmsd final (K10 superp2.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	sprintf(buffy,"Results/XYZ/K10_%s_%d_v3.pdb",m->name,chaine_use );

	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);
	
	sprintf(buffy,"Results/XYZ/dist_K10_%s_%d_v3.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Calpha,lgseq);
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	DesallocMemoireDblDbl_By_Long(BaryInterm,lgseq);
	
	
	/* Mic. M40 */
	
	
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	BaryInterm=AllocMemoireDblDbl_By_Long(lgseq,3*5);
	for(i=0;i<lgseq;i++) for(jk=0;jk<15;jk++)BaryInterm[i][jk]=(999.00);

	
	filetopdbwrite=fecrire("Results/XYZ/superM40.pdb");
	fildconect=fecrire("Results/XYZ/superCM40.pdb");
	fprintf(filetopdbwrite,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',lgseq+1,1.0);
	
	dep=0;
	
	for(residu_A=m->Pos_FirstRes[chaine_use]+2;residu_A<m->Pos_LastRes[chaine_use]-2;residu_A++){
		
		minimrmsd=5895.0;
		minim=0;
		for(ik=0;ik<40;ik++){
		for(jk=0;jk<5;jk++){ X1[jk]=Oligons[ik][jk][0];	Y1[jk]=Oligons[ik][jk][1]; Z1[jk]=Oligons[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		if(minimrmsd>rmsd(X1,Y1,Z1,X2,Y2,Z2,5)){minimrmsd=rmsd(X1,Y1,Z1,X2,Y2,Z2,5);minim=ik;}
		}
		
		ik=minim;
		for(jk=0;jk<5;jk++){ X1[jk]=Oligons[ik][jk][0];	Y1[jk]=Oligons[ik][jk][1]; Z1[jk]=Oligons[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		localrmsd[residu_A][3]=rmsd(X2,Y2,Z2,X1,Y1,Z1,5);
				
		add_toCalpaha(filetopdbwrite,5,&begin,X1,Y1,Z1);
		add_toConnect(fildconect,5,&begin,X1,Y1,Z1);
	
		for(jk=0;jk<5;jk++){
			pos=jk+residu_A-2;
			BaryInterm[pos][3*dep]=X1[jk];	BaryInterm[pos][3*dep+1]=Y1[jk]; BaryInterm[pos][3*dep+2]=Z1[jk];
		}
		dep++;	if(dep>4)dep=0;
	}
	
	fprintf(fildconect,"END\n");
	fclose(filetopdbwrite);
	fclose(fildconect);
	
	sprintf(buffy,"cat Results/XYZ/superM40.pdb Results/XYZ/superCM40.pdb > Results/XYZ/M40%s_%d_v1.pdb ",m->name,chaine_use );
	system(buffy);
	
	MoyenneBary(lgseq,BaryInterm,Bary,5);

	Calpha=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	CopieCalpha(Calpha,chaine_use,m);
	
	printf("rmsd final (M40 superpo.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	sprintf(buffy,"Results/XYZ/M40%s_%d_v2.pdb",m->name,chaine_use );
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_M40_%s_%d_v2.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	MoyenneBarySup(lgseq,BaryInterm,Calpha,Bary,5);

	printf("rmsd final (M40 superp2.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));

	sprintf(buffy,"Results/XYZ/M40_%s_%d_v3.pdb",m->name,chaine_use );
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_M40_%s_%d_v3.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Calpha,lgseq);
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	DesallocMemoireDblDbl_By_Long(BaryInterm,lgseq);
	
	
	/* M 16 */
	
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	BaryInterm=AllocMemoireDblDbl_By_Long(lgseq,3*5);
	for(i=0;i<lgseq;i++) for(jk=0;jk<15;jk++)BaryInterm[i][jk]=(999.00);

	
	filetopdbwrite=fecrire("Results/XYZ/superM16.pdb");
	fildconect=fecrire("Results/XYZ/superCM16.pdb");
	fprintf(filetopdbwrite,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',lgseq+1,1.0);
	
	dep=0;
	
	for(residu_A=m->Pos_FirstRes[chaine_use]+2;residu_A<m->Pos_LastRes[chaine_use]-2;residu_A++){
		
		minimrmsd=5895.0;
		minim=0;
		for(ik=0;ik<16;ik++){
		for(jk=0;jk<5;jk++){ X1[jk]=Oligons[ik][jk][0];	Y1[jk]=Oligons[ik][jk][1]; Z1[jk]=Oligons[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		if(minimrmsd>rmsd(X1,Y1,Z1,X2,Y2,Z2,5)){minimrmsd=rmsd(X1,Y1,Z1,X2,Y2,Z2,5);minim=ik;}
		}
		
		ik=minim;
		for(jk=0;jk<5;jk++){ X1[jk]=Oligons[ik][jk][0];	Y1[jk]=Oligons[ik][jk][1]; Z1[jk]=Oligons[ik][jk][2];	}
		
		for(jk=0;jk<5;jk++){pos=m->deb_residues[jk+residu_A-2]+1;
			X2[jk]=m->pdbatomtype[pos].ATOM_CoordX;	Y2[jk]=m->pdbatomtype[pos].ATOM_CoordY;	Z2[jk]=m->pdbatomtype[pos].ATOM_CoordZ;}
	
		Sippl(X2,Y2,Z2,X1,Y1,Z1,5);
		localrmsd[residu_A][4]=rmsd(X2,Y2,Z2,X1,Y1,Z1,5);
				
		add_toCalpaha(filetopdbwrite,5,&begin,X1,Y1,Z1);
		add_toConnect(fildconect,5,&begin,X1,Y1,Z1);
	
		for(jk=0;jk<5;jk++){
			pos=jk+residu_A-2;
			BaryInterm[pos][3*dep]=X1[jk];	BaryInterm[pos][3*dep+1]=Y1[jk]; BaryInterm[pos][3*dep+2]=Z1[jk];
		}
		dep++;	if(dep>4)dep=0;
	}
	
	fprintf(fildconect,"END\n");
	fclose(filetopdbwrite);
	fclose(fildconect);
	
	sprintf(buffy,"cat Results/XYZ/superM16.pdb Results/XYZ/superCM16.pdb > Results/XYZ/M16%s_%d_v1.pdb ",m->name,chaine_use );
	system(buffy);
	
	MoyenneBary(lgseq,BaryInterm,Bary,5);

	Calpha=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	CopieCalpha(Calpha,chaine_use,m);
	
	printf("rmsd final (M16 superpo.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\t",rmsd3d(Calpha,Bary,lgseq));
	sprintf(buffy,"Results/XYZ/M16_%s_%d_v2.pdb",m->name,chaine_use );
	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_M16_%s_%d_v2.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	Bary=AllocMemoireDblDbl_By_Long(lgseq,3);
	
	MoyenneBarySup(lgseq,BaryInterm,Calpha,Bary,5);

	printf("rmsd final (M16 superp2.): %6.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	fprintf(all,"%8.3lf\n",rmsd3d(Calpha,Bary,lgseq));
	sprintf(buffy,"Results/XYZ/M16_%s_%d_v3.pdb",m->name,chaine_use );

	create_PDB_CAxyz(Bary,m->name,buffy,1,lgseq);

	sprintf(buffy,"Results/XYZ/dist_M16_%s_%d_v3.pdb",m->name,chaine_use);
	distfollow(Bary,buffy,lgseq);

	DesallocMemoireDblDbl_By_Long(Calpha,lgseq);
	DesallocMemoireDblDbl_By_Long(Bary,lgseq);
	DesallocMemoireDblDbl_By_Long(BaryInterm,lgseq);
	
	
	
	/* SWs a voir :CODE/DATA/SWs72/ex_abdcd.pdb*/
	
	
	
	sprintf(buffy,"rm -rf Results/XYZ/super*");
	system(buffy);

	DesallocMemoireDblDbl_By_Long(localrmsd,lgseq);
	
	of(all);
}
